import java.util.*;
/**
 * ConstraintSet
 *
 *
 * Created: Fri Jul 25 14:39:08 2003
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */

public class ConstraintSet extends Hashtable {

    static int suffix = -1; //used to give unique names to sets
    String name;

       public ConstraintSet() {
	   name = getUniqueName();
       } // ConstraintSet constructor

       public ConstraintSet(int i) {
	   super(i);
	   name = getUniqueName();
       } // ConstraintSet constructor

    public Object getValue(String attributeName){
	return this.get(attributeName);
    }


    /*
     * Note that time_max should be a large number of milliseconds
     */
    public double getCSTimeRemaining(){
	long end;
	try {
	    end = Long.parseLong((String)getValue("time_max"));
	} catch (NumberFormatException e) {
	    e.printStackTrace();
	    return -999;
	}

	return (double)(end - System.currentTimeMillis());
    }
    //public double getTimeRemaining(){
    //	double end = Double.parseDouble((String)getValue("time_max"));
    //	return end - System.currentTimeMillis();
    //}

    static String getUniqueName(){
	suffix += 1;
	return "CS" + suffix;
    }

    public String getName(){ return name; }

    static public ConstraintSet readCSFromString(String s){
	String key;
	String value;
	ConstraintSet h = new ConstraintSet(10);
	StringTokenizer st = new StringTokenizer(s, "{}, =");
	while (st.hasMoreTokens()){
	    key = st.nextToken();
	    value = st.nextToken();
	    h.put(key,value);
	}
	return h;
    }
    
    public static void main(String[] args){
	String endtime = Double.toString(System.currentTimeMillis() + 10000);
	ConstraintSet cs = new 	ConstraintSet();
	cs.put("endtime", endtime);
	System.out.println("left: " + cs.getCSTimeRemaining()/1000);
	

    }

}  // ConstraintSet
