import java.util.*;
import java.io.*;
/**
 * DataSet.java
 *
 *
 * Created: Sat Jan 17 13:45:31 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class DataSet extends Hashtable{

    static final boolean DEBUG = true;
    static final String em = "Error in DataSet.java: ";
    static final String loc = "in DataSet.java: ";
    static final String wm = "Warning in DataSet.java: ";

    public DataSet() {
	
    } // DataSet constructor

    public DataSet(String source) {
	put("source", source);
    } // DataSet constructor
    
    public String getSource(){return (String)this.get("source");}

    public static Vector readMultipleDataSets(String s){
	Vector dsets = new Vector(6);
	StringTokenizer st = new StringTokenizer(s," []{},=", true );
	while(st.hasMoreTokens()){

	    while(st.hasMoreTokens() && !st.nextToken().equals("{"));//trim

	    DataSet d = readDataSet(st);
	    if (DEBUG) System.out.println(loc + "Parsed DataSet being added: " + d);
	    dsets.addElement(d);
	}
	return dsets;
    }//  static Vector readMultipleDataSets(String s)

    static public DataSet readDataSetFromString(String s){
    	StringTokenizer st = new StringTokenizer(s, "[], {}=", true); // "{}, =");
	String next = st.nextToken();
	if (next.equals("{"))
	    return readDataSet(st);
	else
	    System.out.println(em + "starting brace not found; found: " + next);
	return null;
    }

    //Reads data from st, then if Utility is null, calculates it.
    //Assumes first { already eaten.
    static public DataSet readDataSet(StringTokenizer st){
	String key, eq, value = null;
	boolean errorFlag = false;
	DataSet h = new DataSet();
	//if (DEBUG) System.out.println(loc + "inside readDataSet, st is: " );
	
	while (st.hasMoreTokens()){
	    key = st.nextToken("[], {}=");
	    if (key.equals("}")) 
		return h;
	    else if ( key.equals(",") || key.equals(" ") ) 
		continue;
	    
	    else if ( key.startsWith("DS") ) {
		eq = st.nextToken();
		if (eq.equals("=")){
		    Strength ds = Strength.readStrength(st);
		    h.put(key, ds);
		}
		else errorFlag = true;
	    }
	    else if ( key.equals("RV") ) {
		//if (DEBUG) System.out.println(loc + "inside readBid RV, st is: " + st.toString());
		eq = st.nextToken();
		if (eq.equals("=")){
		    RuleValue rv = RuleValue.readRuleValue(st);
		    h.put(key, rv);
		}
		else errorFlag = true;
	    }
	    else if ( key.equals("bid") ) {
		//if (DEBUG) System.out.println(loc + "inside readBid RV, st is: " + st.toString());
		eq = st.nextToken();
		st.nextToken(); //eat {
		if (eq.equals("=")){
		    Bid b = Bid.readBid(st);
		    h.put(key, b);
		}
		else errorFlag = true;
	    }
	    else if ( key.equals("tree") ) {
		//if (DEBUG) System.out.println(loc + "inside readBid RV, st is: " + st.toString());
		eq = st.nextToken();
		String temp = st.nextToken(); //eat {
		if (temp.equals("empty"))
		    h.put(key, "empty");
		else if (eq.equals("=")){
		    RSTTree t = RSTTree.readRSTTree(st);
		    h.put(key, t);
		}
		else errorFlag = true;
	    }
	    else {
		eq = st.nextToken();
		value = st.nextToken();
		h.put(key,value);
	    }
	if (errorFlag)
	    System.out.println(em + " errorFlag set for key: " + key + " eq: " + eq + " value: " + value);
	}
	if (DEBUG) System.out.println("readDataSet returning: " + h);
	return h;
    }//readDataSet(StringTokenizer st)
   

    public static void main(String[] args){
	DataSet d = new DataSet("spam");
	d.put("price", "32");
	System.out.println(d);
	String s = d.toString();
	System.out.println(s);
	d = DataSet.readDataSetFromString(s);
	System.out.println(d);
    }

} // DataSet
