import java.util.Timer;
import java.util.TimerTask;

/**
 * Delay.java
 *
 *  Uses java.util.Timer to schedule a task to execute
 * once n seconds have passed.
 *
 *
 * Created: Sun Apr 11 18:13:58 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class Delay {

    Timer timer;
    Object obj;

    public Delay(int seconds) {
	
        timer = new Timer();
	synchronized(timer){
	    timer.schedule(new wakingUp(), seconds*1000);
	}
    } // Delay constructor

    class wakingUp extends TimerTask {
        public void run() {
            System.out.println("Waking up!");
            timer.cancel(); //Terminate the timer thread
        }
    }



    public Object tryAgain(int seconds, Object o){
	
	synchronized(o){
	    new Delay(8);
	    return o;
	}

    }

    public static void main(String args[]) {
        System.out.println("About to schedule task.");
        Delay d = new Delay(5);
        System.out.println("Task scheduled.");
	Object o = "test";
	//o = d.tryAgain(8, o);
        //System.out.println("Task scheduled.");
	//System.out.println("o is" + o);
        System.out.println("Task scheduled.");
	try{
	    Thread.sleep(10000);
	}
	catch(Exception e){
	    System.out.println(e);
	}
        System.out.println("Task scheduled.");
	
    }
}

    

