import java.util.*;
/**
 * Envelope.java
 *
 * See BidSet.java for minEnvelopePercent.
 *
 * Created: Wed Jul 30 06:48:49 2003
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class Envelope extends Hashtable {

    static int suffix = -1; //used to give unique names to sets
    private String name;    
    private Bid bid = null;
    static final boolean DEBUG = false;

    public Envelope() {
	super(5);
	name = getUniqueName();
    } // Envelope constructor

    public Envelope(Bid b) {
	super(5);
	setBid(b);
	name = getUniqueName();
    } // Envelope constructor


    public void setBid(Bid b){bid = b;}
    public Bid getBid(){return bid;}
    public boolean isEmpty(){
	return super.isEmpty() && bid == null;
    }

    static String getUniqueName(){
	suffix++;
	return "Env" + suffix;
    }

    public String getName(){ return name; }

    public String toString(){
	String s = super.toString();
	int size = s.length();
	s = s.substring(0, size - 1);
	return s + ", Bid=" + getBid() + "}";
    }

    static public Envelope readEnvFromString(String s){
	String key;
	String value;
	Envelope e = new Envelope();
	StringTokenizer st = new StringTokenizer(s, "{}, =", true);

	if  (st.hasMoreTokens()){ //eat first {
	    key = st.nextToken();
	    while (key.equals(" ") && st.hasMoreTokens()) key = st.nextToken(); //trim
	    if ( ! key.equals("{"))
		System.out.println("ERROR parsing in Envelope.java, should be { but got: " + key);
	}

	while (st.hasMoreTokens()){
	    key = st.nextToken();
	    while (key.equals(" ") || key.equals("=") || key.equals(",")) key = st.nextToken();
	    if (key.equals("}")) return e;

	    value = st.nextToken();
	    while (value.equals(" ") || value.equals("=") || value.equals(",")) value = st.nextToken();

	    //	    
	    
	    if (key.equals("Bid")) {
		//value should be {
		if (DEBUG) System.out.println("inside Envelope.readEnv1: key, value: " + key + ", " + value);
		if (value.equals("null"))
		    e.setBid(null);
		else e.setBid( Bid.readBid(st) );
	    }

	    else e.put(key,value);
	}
	System.out.println("Envelope.readEnvelopeFromString new env name: " + e.getName() );
	
	return e;
    }
    
    public static void main(String[] args){
	Envelope e = new Envelope();
	e.put("utility_min", "20");
	System.out.println("e: " + e );
	String s = e.toString();
	System.out.println("s: " + s );
	e = e.readEnvFromString(s);
	System.out.println("e: " + e );
	
	Bid b = new Bid();
	b.put("cost_exp", "2");	b.put("length_exp", "3");
	e.setBid(b);

	System.out.println("e: " + e );
	s = e.toString();
	System.out.println("s: " + s );
	e = e.readEnvFromString(s);
	System.out.println("e: " + e );
	
    }

} // Envelope
