/**
 * GenAgent.java
 *
 *
 * Created: Wed Jan 14 17:47:51 2004
 *
 * GenAgents are the middle agents of the system, having a parent
 * above and children below. Note that this is not Agent in the DECAF
 * sense of the word; this class represents agent properties that only
 * hold for agents in my planner. Perhaps this should be an interface?? FIX
 *
 * See also NumericAgent subclass
 *
 * From the perspective of DECAF, this represents a Task Object, where
 * Agent behaviors are Tasks represented in .lsp and .java files. See
 * AgentDef.java.
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public abstract class GenAgent {

    public GenAgent() {
	
    } // GenAgent constructor

    
    void start(Agent Local, String ds){
       System.out.println("**********starting GenAgent: " + Local.getName() + " **************");
       Local.setDsType(ds);
       System.out.println("original tasks: " + Local.taskTemplates);
       Local.addTaskTemplate("acceptRFB.lsp");
       Local.addTaskTemplate("acceptEnv.lsp");
       Local.addTaskTemplate("BidAgent.lsp");
       Local.addTaskTemplate("failingUp.lsp");
       Local.addTaskTemplate("execute.lsp");
       Local.addTaskTemplate("update.lsp");
       System.out.println("all tasks: " + Local.taskTemplates);

       Local.setLocalBids(new BidSet(Local.getName()));

       return;
    }

    //This method should be moved to an Interface and only parents of
    //numeric agents should implement it? Or maybe all middle agents?
    /** See AgentDef.java for call **/
    public RSTTree makeTreeFromData(DataSet ds){
	return new RSTTree();
    }

} // GenAgent
