
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/* Lots of this code borrowed from Sun JSlider tutorial */
public class Gui1 extends JFrame 
    implements //ActionListener,
                                   WindowListener,
                                   ChangeListener {

    static final int COST_MAX = 10;
    static final int COST_INIT = 5;
    private JLabel costLabel, costValueLabel;
    private int costValue = COST_INIT; //default

    public Gui1(){

	super("Slider Test");
	Container c = getContentPane();
	c.setLayout( new FlowLayout() );

	costLabel = new JLabel("here is the slider label");
	costLabel.setToolTipText("Indicate the importance of $ cost");
	c.add( costLabel );

	costValueLabel = new JLabel(Integer.toString(COST_INIT));
	costValueLabel.setToolTipText("Current value of cost slider");
	c.add( costValueLabel );


	JSlider cost = new JSlider(JSlider.HORIZONTAL, 0 , COST_MAX, COST_INIT);
	cost.addChangeListener(this);
	cost.setMajorTickSpacing(COST_MAX/10);
	cost.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
	c.add(cost);

	setSize(250,150);
	show();
    }//end constructor

    /* Listen to the slider. */
    public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
        if (!source.getValueIsAdjusting()) {
            costValue = (int)source.getValue();
	    costValueLabel.setText(Integer.toString(costValue));
	}
    }



    /** Add a listener for window events. */
    void addWindowListener(Window w) {
        w.addWindowListener(this);
    }

    //React to window events.
    public void windowIconified(WindowEvent e) {
        //stopAnimation();
    }
    public void windowDeiconified(WindowEvent e) {
        //startAnimation();
    }
    public void windowOpened(WindowEvent e) {}
    public void windowClosing(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}

 /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the content pane.
        Gui1 myGUI = new Gui1();
	myGUI.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        //Display the window.
        myGUI.pack();
        myGUI.setVisible(true);
        //myGUI.startAnimation(); 
    }


    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.

        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
