
import java.lang.reflect.*;
/**
 * InternalNumericAgent.java
 *
 * Internal numerics are agents that do not contact external sources
 * for info; instead they perform calculations on internally known
 * data (e.g. in the user model). See e.g. classes PL_PortfolioAlloc and RetirementAlloc.
 *
 * Created: Fri Jun 18 17:26:33 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class InternalNumericAgent extends NumericAgent {
    static boolean DEBUG = true;
    Method makeBid;

    public InternalNumericAgent() {
	
    } // InternalNumericAgent constructor
    
    protected void setMakeBidMethod(Class c, String name){
	try{
	    Class[] params = {String.class, Agent.class};
	    makeBid = c.getMethod(name, params);
	}
	catch (Exception e){
	System.out.println("Error locating makeBid method: " + c.toString() + "." + name);
	}
    }

    public BidSet makeLocalBids(String msg, Agent Local){
	
	BidSet result = null;
	Object[] args = {msg, Local};
	try{
	    result = (BidSet)makeBid.invoke( this, args);
	    if (DEBUG) System.out.println("InternalNumericAgent makeLocalBids returning: " + result);
	    
	    return result;
	    
	} catch (IllegalAccessException e) {
	    System.out.println(e);
	} catch (InvocationTargetException e) {
	    System.out.println(e);
	}

	return result;
    }

} // InternalNumericAgent
