import java.util.*;
/**
 * Ktest.java
 *
 *
 * Created: Tue Mar 29 10:02:06 2005
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local">Terry Harvey</a>
 * @version 1.0
 */
public class Ktest {
    public Ktest() {
	
    } // Ktest constructor
    
    public static void main(String [] args){
	BidSet bsR = new BidSet();
	BidSet bsV = new BidSet();
	Bid b;

	BidUtility bu = BidUtility.readBidUtilityFromString("{DSr_coeff=5, DSv_coeff=5, length_coeff=5, length_target=35, length_fcn=normal}");
	//assume 2 children, each submit three bids, so 4^2 - 1 combos = 15
	b = Bid.readBidFromString("{length_exp=40, DSr_exp=[[3 5 2][0 0 0]], DSv_exp=[[0 0 0][0 0 0]]}");
	bsR.add(b);
	b = Bid.readBidFromString("{length_exp=25, DSr_exp=[[2 2 1][0 0 0]], DSv_exp=[[0 0 0][0 0 0]]}");
	bsR.add(b);
	b = Bid.readBidFromString("{length_exp=15, DSr_exp=[[3 3 1][0 0 0]], DSv_exp=[[0 0 0][0 0 0]]}");
	bsR.add(b);							   
	b = Bid.readBidFromString("{length_exp=40, DSr_exp=[[0 0 0][0 0 0]], DSv_exp=[[3 5 2][0 0 0]]}");
	bsV.add(b);							   
	b = Bid.readBidFromString("{length_exp=25, DSr_exp=[[0 0 0][0 0 0]], DSv_exp=[[2 2 1][0 0 0]]}");
	bsV.add(b);							   
	b = Bid.readBidFromString("{length_exp=15, DSr_exp=[[0 0 0][0 0 0]], DSv_exp=[[3 3 1][0 0 0]]}");
	bsV.add(b);							   

	Vector v = new Vector(2);
	v.add(bsR);
	v.add(bsV);

	System.out.println("v at 1 is: " + v);
	
	v = BidSet.chooseOneCombos("test", v);
	BidSet bs = BidSet.makeSingleBidsFromBidSets("test", v);
	bs.setEachBidUtility(bu);

	v = bs.getNSortedHighestUtility(15, bu);

	for (int i = 0; i<v.size(); i++)
	    System.out.println(v.get(i));
	
	BidSet alts = bs.getNAltUtility(3, bu, (Bid)v.get(0)); //assume last bid is hi
	//System.out.println("alts: " + alts);
	v = alts.getNSortedHighestUtility(15, bu);
	for (int i = 0; i<v.size(); i++)
	    System.out.println(v.get(i));
	
    }

} // Ktest
