import java.io.*;
import java.net.*;
import java.util.*;

public class PL_BidAgent extends GenTask
{
    String originator; //sender of bid request
    String originatorReplyWith;
    //    String envReplyWith;
    String resultReplyWith;
    //Hashtable ht; don't use this, use ht in GenAgent
    //String myEndTime; //time by which this task should have completed and returned results
    KQMLmsg startMsg;

    static boolean DEBUG = false;
    static boolean DEBUG2 = false;
    static final String loc = "in PL_BidAgent ";
    static final String em = "ERROR in PL_BidAgent ";

   public PL_BidAgent()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_BidAgent Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
   }

    /**
     * Sends a request to this agent's own request processor, acceptRFB.
     * Record certain incoming info from msg.
     **/
   public ProvisionCell sendRequest(LinkedListQ Plist, Agent Local)
   {
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       if (DEBUG) System.out.println("INSIDE sendRequest" + K);
       ht = Local.userHash;
       job = getMsgJob(K);

       Local.checkMsgTime(K, Local.dataFile1, job);

       originatorReplyWith = (String)K.getValue("reply-with");
       originator = (String)K.getValue("sender");
       startMsg = new KQMLmsg(K.toString());

       //Storage related to a job will be in agent ht (see
       //above). Keys are stored here for cleanup later in PL_CleanUp.
       ///This *should* run before localPut() can be used by this
       //agent to prevent memory buildup.
       synchronized(ht){
	   if (ht.get("jobStorageKeys" + job) == null){
	       System.out.println("Creating jobStorageKeys " + job);
	       HashSet jobStorageKeys = new HashSet(); //modified in countMsgs2()
	       ht.put("jobStorageKeys" + job, jobStorageKeys);
	   } 
	   else
	       if (true) System.out.println("ERROR initializing jobStorageKeys in acceptEnv");
       }

       localPut("startMsg", job, startMsg);

       //Local.setNumLevels(Integer.parseInt( K.getContentFieldValue("levels")));
       if (DEBUG) System.out.println("numLevels set to: " + Local.getNumLevels());
       String myEndTime = K.getContentFieldValue("endtime");
       Local.setUpperEndTime(Local.getEndTime(Local.taskUpperTimeout(myEndTime)));
       
       if (DEBUG) System.out.println("taskUpperTimeout(): " + Local.taskUpperTimeout(myEndTime));
       if (DEBUG) System.out.println("taskLowerTimeout(): " + Local.taskLowerTimeout(myEndTime));
       if (DEBUG) System.out.println("upperMsgTimeout(): " +  Local.upperMsgTimeout(myEndTime));
       if (DEBUG) System.out.println("lowerMsgTimeout(): " +  Local.lowerMsgTimeout(myEndTime));

       localPut("finished", job, new Boolean(false)); //see PL_Count.myTimeout(), collectResults

       /**This method should only be called once per job. These data
	* structures are for the lower level processing of a
	* generation agent. Could move this... Can't go in AgentDef
	* because we need the job link(?)**/

       /*********Initializations for Bidding *************/

       if (localGet("bidsMade", job) == null){
	   Hashtable bidsMade = new Hashtable(); //are stored bid=bidset
	   localPut("bidsMade", job, bidsMade);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsMade in acceptEnv");
       
       if (localGet("bidsAccepted", job) == null){
	   Hashtable bidsAccepted = new Hashtable(); 
	   localPut("bidsAccepted", job, bidsAccepted);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsAccepted in acceptEnv");
       
       /*********Initializations for Envelopes and Execution*************/

       if (localGet("envelopes", job) == null){
	   Hashtable envelopes = new Hashtable(); //are stored bid=env
	   localPut("envelopes", job, envelopes);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing envelopes in acceptEnv");
       
       if (localGet("bidsSentForExecution", job) == null){
	   HashSet bidsSentForExecution = new HashSet();
	    localPut("bidsSentForExecution", job, bidsSentForExecution);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsSentForExecution in acceptEnv");
       
       if (localGet("waitingForSenders", job) == null){
	   Hashtable waitingForSenders = new Hashtable(); //set of senders from who we expect bids
	   localPut("waitingForSenders", job, waitingForSenders);
	   System.out.println("Created new waitingForSenders for job " + job);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing waitingForSenders in acceptEnv");
       
       if (localGet("failedSenders", job) == null){
	   HashSet failedSenders = new HashSet();
	   localPut("failedSenders", job, failedSenders);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing failedSenders in acceptEnv");
       
       if (localGet("failedBids", job) == null){
	   HashSet failedBids = new HashSet();
	   localPut("failedBids", job, failedBids);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing failedBids in acceptEnv");
       
       if (localGet("recoverybidsMF", job) == null){
	   HashSet recoverybidsMF = new HashSet();
	   localPut("recoverybidsMF", job, recoverybidsMF);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing recoverybidsMF in acceptEnv");
       
       if (localGet("oppSenders", job) == null){
	   HashSet oppSenders = new HashSet();
	   localPut("oppSenders", job, oppSenders);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing oppSenders in acceptEnv");
       
       if (localGet("dataFromChildren", job) == null){
	   Hashtable dataFromChildren = new Hashtable(); //modified in countMsgs2()
	   localPut("dataFromChildren", job, dataFromChildren);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing dataFromChildren in acceptEnv");
       
       /** clean up ***/
       KQMLmsg K3 = new KQMLmsg();
       K3.addFieldValuePair("sender", Local.getName() );
       K3.addFieldValuePair("performative", "achieve");
       K3.addFieldValuePair("receiver", Local.getName());
       K3.addFieldValuePair("ontology", "PL" );
       K3.addFieldValuePair("content", ":task CleanUp :job " + job);
       MsgUtilities.copyGenContent(K, K3, Local);
       Local.sendNow(K3);
        
       /*****************************************************************/

       KQMLmsg K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName() );
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("reply-with", "z");
       K2.addFieldValuePair("receiver", Local.getName() );
       K2.addFieldValuePair("ontology", "PL" );
       K2.addFieldValuePair("content", ":task acceptRFB :in msg :constraints " + 
			    (String)K.getContentFieldValue("constraints") +
			    //" :symbol " + (String)K.getContentFieldValue("symbol") +
			    " :utilityFcn " + 
			    (String)K.getContentFieldValue("utilityFcn")); 
       MsgUtilities.copyGenContent(K, K2, Local);
       if (DEBUG) System.out.println(Local.getName() + " sendRequest writing: " + K2);
       //System.out.println("with timeout = " + Local.upperMsgTimeout(myEndTime));
	   

       ProvisionCell P1 =  
	   new ProvisionCell(K2.getKQMLString() + 
			     Util.addTimeout(Local.upperMsgTimeout(myEndTime)),"OK");

       System.out.println("Leaving sendRequest: "  + P1.getName() + P1.getData());
       return P1;
   }

    /**
     * Receives this agent's bid from acceptRFB, send it to the agent
     * that sent a request for bids to this agent. Goes to acceptRFB.countMsgs in parent.
     **/
   public ProvisionCell propagateBidsUp(LinkedListQ Plist, Agent Local)
   {
       KQMLmsg K1 = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
      
       System.out.println(Local.getName() + " entering propagateBidsUp: \n" + K1.getKQMLString());

       Local.checkMsgTime(K1, Local.dataFile1, job);

       String bidString = (String)K1.getContentFieldValue("newbidset"); /// extract text from msg

       if (bidString == null || bidString.equals("")) bidString = "empty";

       System.out.println(Local.getName() + " making bids: " + bidString);
       
       KQMLmsg K = new KQMLmsg();
       K.addFieldValuePair("sender", Local.getName() );
       K.addFieldValuePair("performative", "tell");
       K.addFieldValuePair("in-reply-to", originatorReplyWith);
       //K.addFieldValuePair("reply-with", "env");
       K.addFieldValuePair("receiver", originator );
       K.addFieldValuePair("ontology", "PL" );

       //why??
       String nextTask = Local.getLevel() == 2 ? "" : " :task ExecAgent";
       K.addFieldValuePair("content",  nextTask + " :bidset " + bidString);
       
       System.out.println(Local.getName() + " propagateBidsUp writing: " + K);
      
      return new ProvisionCell(K.getKQMLString(), "OK");
   }

    public static void main(String[] args){



    }
}
