import java.io.*;
import java.net.*;
import java.util.*;

public class PL_CleanUp extends GenTask
{

    static final boolean DEBUG = false;

   public PL_CleanUp()
   {
      System.out.println("%%%%%%% PL_CleanUp Zero constructor % <==============");
   }

    public ProvisionCell clean(LinkedListQ Plist, Agent Local)
    {

	KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
	///System.out.println(Local.getName() + " PL_CleanUp receiving: " + K);

	String myEndTime = K.getContentFieldValue("endtime");
	long waitTime = Local.getTimeRemaining(myEndTime) + 10000;

	String job = getMsgJob(K);
	System.out.println(Local.getName() + " PL_CleanUp for job "+job+" will wait: " + waitTime/1000);
	
	try{
	    Thread.sleep(waitTime - 1000);
	}catch (Exception e){
	    System.out.println(e);
	}

	//ht is in GenTask
	ht = Local.userHash;
	if (ht == null)
	    System.out.println("Cleanup has no hashtable access!");
	

	try{
	    Thread.sleep(1000);
	}catch (Exception e){
	    System.out.println(e);
	}

	Object o;

	//This is a list of all the objects that have been stored in
	//the Agent hashtable by the function localPut().
	Collection keys = (Collection)localGet("jobStorageKeys", job);	

	System.out.println(Local.getName() + " PL_CleanUp cleaning " + keys);
	synchronized(keys){
	synchronized(ht){
	    Iterator iKeys = keys.iterator();
	    String nextKey;
	    while( iKeys.hasNext() ){
		nextKey = (String)iKeys.next();
		//System.out.println("trying " + nextKey);
		
		if ( ht.containsKey(nextKey) ){
		    o = ht.remove(nextKey);
		    if (DEBUG){
			if (o != null)
			    System.out.println("Clean removed: " + nextKey);
			else
			    System.out.println("Clean failed to remove: " + nextKey);
		    }
		}
	    }
	}}
	
	System.out.println("cleanUp finished.");

	return new ProvisionCell("cleaning done","OK");
    }

}

//things that get cleaned up:

//	o = ht.remove("bidsMade" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing bidsMade in acceptEnv.cleanUp()");
//       
//	o = ht.remove("bidsAccepted" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing bidsAccepted in acceptEnv.cleanUp()");
//       
//	o = ht.remove("envelopes" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing envelopes in acceptEnv.cleanUp()");
//       
//	o = ht.remove("bidsSentForExecution" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing bidsSentForExecution in acceptEnv.cleanUp()");
//       
//	o = ht.remove("waitingForSenders" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing waitingForSenders in acceptEnv.cleanUp()");
//       
//	o = ht.remove("failedSenders" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing failedSenders in acceptEnv.cleanUp()");
//       
//	o = ht.remove("oppSenders" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing oppSenders in acceptEnv.cleanUp()");
//       
//	o = ht.remove("dataFromChildren" + job);
//	if (o == null)
//	    if (DEBUG) System.out.println("Warning: removing dataFromChildren in acceptEnv.cleanUp()");
//failedBids
///env to bid mappings from DistrEnv
