import java.io.*;
import java.net.*;
import java.util.*;

public class PL_Coord extends GenTask
{
    
    String originatorReplyWith = null;
    String originator = null; //sender who triggered this class
    KQMLmsg startMsg;
    String myEndTime;
    static final String em = "Error in PL_Coord: ";
    static final String wm = "Error in PL_Coord: ";
    static final String loc = "in PL_Coord: ";
    static final boolean DEBUG = false;
    static final boolean DEBUG2 = false;
    static final boolean DEBUG_W = true;

    //String outputFileName = "coordOutput";

    public PL_Coord()
    {
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
	System.out.println("% PL_Coord Zero constructor % <==============");
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
    }
    
   public ProvisionCell sendRequest(LinkedListQ Plist, Agent Local)
   {

       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println("INSIDE sendRequest");
       ht = Local.userHash;
       job = getMsgJob(K);

       originatorReplyWith = (String)K.getValue("reply-with");
       originator = (String)K.getValue("sender");
       startMsg = K;

       //Storage related to a job will be in agent ht (see
       //above). Keys are stored here for cleanup later in PL_CleanUp.
       ///This *should* run before localPut() can be used by this
       //agent to prevent memory buildup.
       synchronized(ht){
	   if (ht.get("jobStorageKeys" + job) == null){
	       System.out.println("Creating jobStorageKeys in PL_Coord for " + job);
	       HashSet jobStorageKeys = new HashSet(); //modified in countMsgs2()
	       ht.put("jobStorageKeys" + job, jobStorageKeys);
	   } 
	   else
	       if (true) System.out.println("ERROR initializing jobStorageKeys in acceptEnv");
       }

       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);
       
       localPut("startMsg", job, K.toString()); //used to write to file in CoordProcess

       localPut("finished", job, new Boolean(false)); //see PL_Count.myTimeout(), collectResults
       System.out.println("setting finished for job " + job + " in Coord: " + localGet("finished", job));
       

       /**This method should only be called once per job. These data
	* structures are for the lower level processing of a
	* generation agent. Could move this... Can't go in AgentDef
	* because we need the job link(?)**/

       /*********Initializations for Bidding *************/

       if (localGet("bidsMade", job) == null){
	   Hashtable bidsMade = new Hashtable(); //are stored bid=bidset
	   localPut("bidsMade", job, bidsMade);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsMade in acceptEnv");
       
       if (localGet("bidsAccepted", job) == null){
	   Hashtable bidsAccepted = new Hashtable(); 
	   localPut("bidsAccepted", job, bidsAccepted);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsAccepted in acceptEnv");
       
       /*********Initializations for Envelopes and Execution*************/

       if (localGet("envelopes", job) == null){
	   Hashtable envelopes = new Hashtable(); //are stored bid=env
	   localPut("envelopes", job, envelopes);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing envelopes in acceptEnv");
       
       if (localGet("bidsSentForExecution", job) == null){
	   HashSet bidsSentForExecution = new HashSet();
	    localPut("bidsSentForExecution", job, bidsSentForExecution);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing bidsSentForExecution in acceptEnv");
       
       if (localGet("waitingForSenders", job) == null){
	   Hashtable waitingForSenders = new Hashtable(); //set of senders from who we expect bids
	   localPut("waitingForSenders", job, waitingForSenders);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing waitingForSenders in acceptEnv");
       
       if (localGet("failedSenders", job) == null){
	   HashSet failedSenders = new HashSet();
	   localPut("failedSenders", job, failedSenders);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing failedSenders in acceptEnv");

       if (localGet("failedBids", job) == null){
	   HashSet failedBids = new HashSet();
	   localPut("failedBids", job, failedBids);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing failedBids in acceptEnv");
       
       if (localGet("recoverybidsMF", job) == null){
	   HashSet recoverybidsMF = new HashSet();
	   localPut("recoverybidsMF", job, recoverybidsMF);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing recoverybidsMF in acceptEnv");
              
       if (localGet("oppSenders", job) == null){
	   HashSet oppSenders = new HashSet();
	   localPut("oppSenders", job, oppSenders);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing oppSenders in acceptEnv");
       
       if (localGet("dataFromChildren", job) == null){
	   Hashtable dataFromChildren = new Hashtable(); //modified in countMsgs2()
	   localPut("dataFromChildren", job, dataFromChildren);
       } else
	   if (DEBUG2) System.out.println("ERROR initializing dataFromChildren in acceptEnv");
       
       /** clean up ***/
       KQMLmsg K3 = new KQMLmsg();
       K3.addFieldValuePair("sender", Local.getName() );
       K3.addFieldValuePair("performative", "achieve");
       K3.addFieldValuePair("receiver", Local.getName());
       K3.addFieldValuePair("ontology", "PL" );
       K3.addFieldValuePair("content", ":task CleanUp :job " + job);
       MsgUtilities.copyGenContent(K, K3, Local);
       Local.sendNow(K3);
        
       /*****************************************************************/


       myEndTime = K.getContentFieldValue("endtime");
       Local.setUpperEndTime(Local.getEndTime(Local.taskUpperTimeout(myEndTime)));

       if (DEBUG) System.out.println("taskUpperTimeout(): " + Local.taskUpperTimeout(myEndTime));
       if (DEBUG) System.out.println("taskLowerTimeout(): " + Local.taskLowerTimeout(myEndTime));
       if (DEBUG) System.out.println("upperMsgTimeout(): " +  Local.upperMsgTimeout(myEndTime));
       if (DEBUG) System.out.println("lowerMsgTimeout(): " +  Local.lowerMsgTimeout(myEndTime));

       KQMLmsg K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName() );
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("reply-with", "z");
       K2.addFieldValuePair("receiver", Local.getName() );
       K2.addFieldValuePair("ontology", "PL" );
       K2.addFieldValuePair("content", ":task acceptRFB :in msg :constraints " + 
			    (String)K.getContentFieldValue("constraints") +
			    " :utilityFcn " + 
			    (String)K.getContentFieldValue("utilityFcn")// +
			    //" :symbol " + //(String)K.getContentFieldValue("symbol")
			    ); 
       MsgUtilities.copyGenContent(K, K2, Local);
       System.out.println(Local.getName() + " sendRequest writing: " + K2);
       System.out.println("with timeout = " + Local.upperMsgTimeout(myEndTime));
	   

       ProvisionCell P1 =  new ProvisionCell(K2.getKQMLString() + 
					     Util.addTimeout(Local.upperMsgTimeout(myEndTime)),"OK");

       System.out.println("Leaving sendRequest: "  + P1.getName() + P1.getData());
       return P1;
   }

   public ProvisionCell calcEnvelopes(LinkedListQ Plist, Agent Local)
   {
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println(Local.getName() + " entering calcEnvelopes: " + K.getKQMLString());

       Local.checkMsgTime(K, Local.dataFile1, job);

       String temp = (String)K.getContentFieldValue("newbidset");
       Envelope env = null;
       synchronized(ht){
	   if (! (temp.equals("empty") || temp.equals(""))){
	       BidSet bs = BidSet.readBidSetFromString(temp);
	       bs.setEachBidUtility(Local.getUtilityFcn());
	       System.out.println(Local.getName() + " calcEnvelopes read BidSet: " + bs);

	       Vector best = bs.getNSortedHighestUtility(1, Local.getUtilityFcn());
	       System.out.println("Coord.calcEnv best bid: " + (Bid)best.get(0));

	       ShowWindow sw;
	       if (DEBUG_W) sw = new ShowWindow(((Bid)best.get(0)).toString(), job);
	       
	       //System.out.println("BIDSMADE: " + bidsMade);
       
	       if (DEBUG){
		   System.out.println("Listing bids in bidset: ");
		   Bid b;
		   Iterator bids = bs.iterator();
		   while(bids.hasNext()){
		       b = (Bid)bids.next();
		       System.out.println("bid: " + b);
		       b.calcAndPrintUtility(Local.getUtilityFcn());
		       //b.calcUtility(Local.getUtilityFcn());
		       //System.out.println("source: " + b.getBidSetSource());
		       //System.out.println("source2: " + getBidComponents(b));
		   }
	       }

	       //Currently selects best; should select a set? Best, Alt, Diff? or do that later?

	       env = bs.getBestBidsEnvelope(Local.getUtilityFcn());	  
	       localPut(env.getName(), job, env);

	       System.out.println("calcEnv new env: " + env.getName() + ": " + env);

	   }//end if ! empty
       }       

       KQMLmsg K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName() );
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("reply-with", "toCoordProcess");
       K2.addFieldValuePair("receiver", Local.getName() );
       K2.addFieldValuePair("ontology", "PL" );

       String envString =   env == null ? "empty" : env.getName();
       K2.addFieldValuePair("content", ":task acceptEnv :in3 msg :env " + envString + " :parentEnv " + Local.getName() + envString);       
       MsgUtilities.copyGenContent(startMsg, K2, Local);

       System.out.println(Local.getName() + " calcEnvelopes writing: " + K2);
       
       ProvisionCell P1 =  new ProvisionCell(K2.getKQMLString() + 
				   Util.addTimeout(Local.upperMsgTimeout(myEndTime)),"OK");
       return P1;
   }//calcEnvelopes(LinkedListQ Plist, Agent Local)


    /** 
     * Need this action so can require system timeout msgs. Send each
     * message out to PL_CoordProcess as it comes in. 
     **/
    public ProvisionCell collectResults(LinkedListQ Plist, Agent Local) {
	
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println("inside Coord.collectResults: " + K);

       Local.checkMsgTime(K, Local.dataFile1, job);

       KQMLmsg K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName());//K.getValue("sender")
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("receiver", Local.getName());//K.getValue("receiver")
       K2.addFieldValuePair("ontology", "PL" );
       
       if (K.getValue("performative").equals("timeout")){
	   K2.addFieldValuePair("content", ":task CoordProcess :msg3 x :status TIMEOUT" + 
				" :oldPerformative " + K.getValue("performative") +
				" :oldTask " + K.getContentFieldValue("task"));
       }
       else{
	   String status = K.getContentFieldValue("status");
	   if (status.equals("")) status = "fine2";

	   K2.addFieldValuePair("content", ":task CoordProcess :msg3 x" +
				" :result " + K.getContentFieldValue("result") +
				" :status " + status +
				" :oldSender " + K.getValue("sender"));
       }
       MsgUtilities.copyGenContent(startMsg, K2, Local);
       System.out.println("Coord.collectResults sending: " + K2);
       return new ProvisionCell(K2.toString(), "OK");
    }


}

