import java.util.*;
import java.io.*;
/**
 * PL_CoordProcess.java
 *
 *
 * Created: Mon Apr 19 10:12:10 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class PL_CoordProcess extends GenTask {


    static final String em = "Error in PL_CoordProcess: ";
    static final String wm = "Error in PL_CoordProcess: ";
    static final String loc = "in PL_CoordProcess: ";
    static final boolean DEBUG = false;
    static final boolean ALTPROCESS = false;
    KQMLmsg startMsg;

    String outputFileName = "coordOutput";
    String outputFileName2 = "coordOutputTrees";
    String altUTextFile = "coordOutputAlt";

    static String outputText = "empty";
    static String outputJob = "unset";

    public PL_CoordProcess() {
	
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
	System.out.println("% PL_CoordProcess Zero constructor % <==============");
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
    } // PL_CoordProcess constructor
    
   public ProvisionCell processResults(LinkedListQ Plist, Agent Local)
   {
       ht = Local.userHash;

       KQMLmsg K1 = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println(Local.getName() + " inside CoordProcess.processResults: " + K1);
       startMsg = new KQMLmsg(K1.toString());// save copy for reference

       job = getMsgJob(K1);

       Local.checkMsgTime(K1, Local.dataFile1, job);

       String result = K1.getContentFieldValue("results");//from collectResults

       
       if (! K1.getContentFieldValue("results").equals("empty") ||
	   ! K1.getContentFieldValue("failedResults").equals("empty")   ){

	   /*******************
	    SET TREES
	   ******************/
	   Vector trees = RSTTree.readMultipleRSTTrees(result);
	   
	   boolean usedFailed = false;
	   if (trees == null || trees.isEmpty()){
	       usedFailed = true;
	       trees = RSTTree.readMultipleRSTTrees( K1.getContentFieldValue("failedResults") );	       
	       System.out.println("processResults trying failed results");
	   }

	   Envelope env = null;
	   //determine envelope to use
	   if (K1.getContentFieldValue("opportunity").equals("yes")){
	       String envString = K1.getContentFieldValue("oppEnv");
	       env = Envelope.readEnvFromString(envString);
	   }
	   else
	       env = (Envelope)localGet("incomingEnvelope", job);

	   /*******************
	    PROCESS TREES
	   ******************/
	   String status = null;
	   BidUtility bu = Local.getUtilityFcn();
	   
	   //used only by rc and integrator; is this now obsolete? RSTTreePeakDSComp probably takes care of this
	   BidUtility dsBU = bu.dsOnlyClone();

	   if (trees != null && (! trees.isEmpty())){
	       RSTTreePeakDSComp rc = new RSTTreePeakDSComp(dsBU);
	       //RSTTreeComp rc = new RSTTreeComp(dsBU);
	       Collections.sort(trees,rc);

	       //Check utility so far - this updates bid utilities with bu instead of dsBU
	       if (treesSatisfyEnvelope(trees, bu, env, Local))
		   status = "PASS";
	       else{//if there are failed results and we haven't used them yet	
		   
		   status = "FAIL_RAW";
		   if (! usedFailed && 
		       ! K1.getContentFieldValue("failedResults").equals("empty")){	
       
		       System.out.println("processResults checking failed results");
		       Vector withFailedTrees = 
			   RSTTree.readMultipleRSTTrees( K1.getContentFieldValue("failedResults") );
		       withFailedTrees.addAll(trees);//put all in one vector
		       if (treesSatisfyEnvelope(withFailedTrees, bu, env, Local)){	       
			   System.out.println("processResults using failed results to meet Umin");
			   trees = withFailedTrees;
			   usedFailed = true;
			   status = "PASS";
		       }
		       else if (utilityFromTrees(withFailedTrees, bu, Local) >
				utilityFromTrees(trees, bu, Local)){	       
			   System.out.println("processResults using failed results to increase U");
			   trees = withFailedTrees;
			   usedFailed = true;
		       }
		       else    
			   System.out.println("processResults not using failed results");
		   }
	       }
	   
	       Collections.sort(trees,rc); //updates using dsBU


	       /************************************************************
			  clone trees for alternate processing      
	       ************************************************************/
	       Vector treesCopy;
	       if (ALTPROCESS){
		   treesCopy = new Vector();
		   for (int i = 0; i < trees.size(); i++)
		       treesCopy.add( ((RSTTree)trees.elementAt(i)).clone() );
	       }
	       /************************************************************/
	       ///back to regular processing

	       Integrator treeIntegrator = new Integrator(dsBU);
	       trees = treeIntegrator.addNewTrees(trees, rc, Local.getName());
	   
	       if (bu != null)
		   for(int i = 0; i < trees.size(); i++)
		       ((RSTTree)trees.get(i)).updateUtility(bu);
	       else
		   System.out.println(em + " in processResults Local.getU() was null");
	   
	       if (DEBUG) {
		   System.out.println(loc + ".processResults first all trees: ");
		   for(int i = 0; i < trees.size(); i++)
		       ((RSTTree)trees.get(i)).print();
	       }
	       
	       //check utility of processed trees here
	       if (treesSatisfyEnvelope(trees, bu, env, Local))
		   status = "PASS_PROC";
	       else status = "FAIL_PROC";
	       
	       Collections.sort(trees,rc);
	       System.out.println(loc + "making joint trees next ");
	       RSTTree best = treeIntegrator.joinAllTrees(trees, Local.getName());

	       best.updateUtility(bu);
	       /****************************************************************
                           do alternate processing here
	       ***************************************************************/
	       String altStatus = "noStatus";
	       BidUtility altBU = bu.reverseDSUclone();
	       RSTTree altBest = null;

	       if (ALTPROCESS){

		   if (altBU != null)
		       for(int i = 0; i < treesCopy.size(); i++)
			   ((RSTTree)treesCopy.get(i)).updateUtility(altBU);
		   else
		       System.out.println(em + " in ALT processResults Local.getU() was null");
	   
		   System.out.println("bu: " + bu.toString());
		   System.out.println("reversed bu: " + altBU.toString());

		   BidUtility altDSBU = altBU.dsOnlyClone();
		   RSTTreeComp altRC = new RSTTreeComp(altDSBU);
		   Collections.sort(treesCopy,altRC);

		   Integrator altTreeIntegrator = new Integrator(altDSBU);
		   treesCopy = altTreeIntegrator.addNewTrees(treesCopy, altRC, Local.getName());
	       
		   if (DEBUG) {
		       System.out.println(loc + " ALT processResults first all trees: ");
		       for(int i = 0; i < treesCopy.size(); i++)
			   ((RSTTree)treesCopy.get(i)).print();
		   }
	       
		   //check utility of processed trees here - updates U with altBU
		   if (treesSatisfyEnvelope(treesCopy, altBU, env, Local))
		       altStatus = "PASS_PROC";
		   else altStatus = "FAIL_PROC";
	       
		   Collections.sort(treesCopy,altRC); //updates U with altDSBU
		   System.out.println(loc + "before making joint trees");
		   for(int i = 0; i < treesCopy.size(); i++)
		       ((RSTTree)treesCopy.get(i)).print();
		   System.out.println(loc + "making joint treesCopy next ");
		   altBest = altTreeIntegrator.joinAllTrees(treesCopy, Local.getName());
		   altBest.updateUtility(altBU);
		   altBest.fillInUtilities(altBU);
		   System.out.println("altBest:");
		   altBest.print();
	       }
	       /*************end of alt processing ****************/

	       if (bu != null)
		   for(int i = 0; i < trees.size(); i++)
		       ((RSTTree)trees.get(i)).updateUtility(bu);
	       else
		   System.out.println(em + " in processResults Local.getU() was null");

	       if (best == null){ //when would this occur?
		   best = (RSTTree)trees.get(0);
	       }
	       System.out.println("**************************************************************");
	       System.out.println("***************************all trees**************************");
	       for (int i = 0; i < trees.size(); i++){
		   ((RSTTree)trees.get(i)).print();
		   System.out.println("________________________________________");
	       }
	       System.out.println("*************************************************************");
	       System.out.println("*************************************************************");
	       String symbol = startMsg.getContentFieldValue("symbol");
	       TreeGenerate tg = new TreeGenerate(symbol);

	       if (best != null){
		   System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\nBEST TREE:");
		   if (bu != null) best.fillInUtilities(bu);
		   best.print();
		   //System.out.println(TreeGen.treeString(best,bu));
		   System.out.println(tg.generate(best));
	       }
	       System.out.println("*************************************************************");
	       System.out.println("*************************************************************");
 
	       outputJob = job;

	       if (best != null){//write to file

		   String bestString =  tg.generate(best);
		   outputText = bestString;

		   try {

		       System.out.println("writing tree to file " + outputFileName + " job: " +
					  (String) localGet("startMsg", job));
		       FileWriter fw = new FileWriter(outputFileName, true);
		       FileWriter dataw = new FileWriter("thesisData", true);
		       fw.write("\n______________________________________________________________\n______________________________________________________________\n");
		       fw.write((String) localGet("startMsg", job)); //set in Coord.java

		       fw.write("\n______________________________________________________________");
		       //fw.write("\nmessage count is: " + K1.getCount() + " - " + Local.kqmlMsgCount + " = " + 
		       //(K1.getCount() - Local.kqmlMsgCount));
		       
		       //fw.write("\nexternal message count is: " + K1.getExternalMsgNum() + " - " + Local.kqmlMsgExtCount + " = " + 
		       //(K1.getExternalMsgNum() - Local.kqmlMsgExtCount));
		       //MsgCount.incrMsgCount(K1.getExternalMsgNum() - Local.kqmlMsgExtCount);
		       //K1.resetExternalMsgNum();
		       //Local.kqmlMsgExtCount = 0;
		       //fw.write("\nexternal message count is: " + MsgCount.getMsgCount());// + " - " + Local.kqmlMsgExtCount + " = " + (MsgCount.getMsgCount() - Local.kqmlMsgExtCount));
		       double remaining = Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"));
		       double time = Local.total_time - (remaining/1000);
		       fw.write("\nWriting with elapsed time: " + time + " remaining time: " + remaining);
		       fw.write("\nWriting with elapsed time: " + time);
		       fw.write("\nUfcn: " + bu + "\n");
		       fw.write(best.getBid().calcAndPrintUtility(bu));
		       fw.write("\n");
		       best.writeInforms(fw);
		       fw.write("\n");
		       //fw.write( TreeGen.treeString(best,bu) );
		       //fw.write("\n");
		       //fw.write("\n");
		       //fw.write(tg.generateLong(best, bu));
		       fw.write("\n");
		       fw.write(bestString );
		       fw.write("    word count: " + tg.wordCount(bestString) );
		       fw.write("\njob: " + job);
		       //fw.write("\nrandom:\n");
		       //fw.write(tg.generateRandom(best));
		       fw.write("\n______________\n");
		       best.write(fw);
		       fw.write("______________\n");
		       best.writeLong(fw);
		       fw.write("______________________________________________________________\n");

		       //CHANGE FILES
		       fw.flush();
		       fw.close();


		       dataw.write("\n" + job);
		       dataw.write(",   " + time);
		       dataw.write(",   " + MsgCount.getMsgCount());
		       dataw.write(",   " + best.getBid().utility());
		       dataw.flush();
		       dataw.close();

		       //write tree in object readable form
		       FileWriter fw2 = new FileWriter(outputFileName2, true);
		       fw2.write("______________________________________________________________\n");
		       fw2.write((String) localGet("startMsg", job)); //set in Coord.java

		       fw2.write("\n______________________________________________________________\n");
		       fw2.write("Ufcn: " + bu + "\n");
		       //fw2.write( TreeGen.treeString(best,bu) );
		       fw2.write("\n");
		       fw2.write(bestString );
		       fw2.write("    word count: " + tg.wordCount(bestString) );
		       fw2.write("\n______________\n");
		       fw2.write(best.getString());
		       fw2.write("\n______________\n");
		       fw2.write("______________________________________________________________\n");

		       fw2.flush();
		       fw2.close();
		   } 
		   catch (Exception e) {
		       System.out.println(e);
		   }

		   if (ALTPROCESS && altBest != null){//write text only to file
		       try {
			   
			   System.out.println("writing texts to file " + altUTextFile );
			   FileWriter fw = new FileWriter(altUTextFile, true);
			   fw.write("\n______________________________________________________________\n______________________________________________________________\n");
			   fw.write("job: " + job);
			   fw.write("Ufcn: " + bu + "\n");
			   fw.write(best.getBid().toString());
			   best.writeInforms(fw);
			   fw.write("\n");
			   fw.write("\nbest: \n" + bestString);
			   fw.write("\n______________\n");
			   fw.write("altUfcn: " + altBU + "\n");
			   fw.write(altBest.getBid().toString());
			   fw.write("\n");
			   fw.write(altBest.getBid().calcAndPrintUtility(altBU));
			   fw.write("\n");
			   altBest.writeInforms(fw);
			   fw.write("\naltU: \n" + tg.generate(altBest));
			   
			   fw.flush();
			   fw.close();
		       } 
		       catch (Exception e) {
			   System.out.println(e);
		       }
		   }
		   else
		       if (ALTPROCESS && DEBUG) System.out.println("Warning: altBest was null!");
	       }
	   }
       }       
       //       }
       else {
	   System.out.println(wm + " No text was available for these specifications.");
	   outputText = " No text was available for these specifications. ";
	   outputJob = job;
       }

       //Schedule a job for the event-dispatching thread:
       //creating and showing this application's GUI.
       javax.swing.SwingUtilities.invokeLater(new Runnable() {
	       public void run() {
		   createAndShowGUI();
	       }
	   });


       System.out.println("UTILITY FUNCTION: " + Local.getUtilityFcn());
       ProvisionCell P1 =  new ProvisionCell("CoordProcess finished","OK");
    
       //NOT a failure, just a notification for reference
       Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), "finished ", 
			    Long.toString(Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))), 
			    Local);

       System.out.println("Writing " + job + " with time remaining: " + 
			  (Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))/1000.0)
			  + " bid sets considered: " + 
			  localGet("numBidSetsConsidered", job));
       
       return P1;
   }

    private boolean treesSatisfyEnvelope(Vector trees, BidUtility bu, Envelope myEnv, Agent Local){

	if (bu != null){
	    Bid b = RSTTree.getOneBidFromTrees(trees, Local);
	    double bidU = b.getUtility(bu).doubleValue();
	    double envU = Double.parseDouble((String)myEnv.get("utility_min"));
	    if (DEBUG) System.out.println(loc + " checking bid U: " + bidU + " against env U: " + envU);
	       
	    if (bidU >= envU) return true;
		   else return false;
	}
	else {
	    System.out.println("treesSatisfyEnvelope: no BidUtility");
	    return false;
	}
    }
    
    private double utilityFromTrees(Vector trees, BidUtility bu, Agent Local){

	if (bu != null){
	    Bid b = RSTTree.getOneBidFromTrees(trees, Local);
	    Envelope myEnv = (Envelope)localGet("incomingEnvelope", job);
	    double bidU = b.getUtility(bu).doubleValue();
	    return bidU;
	}
	else {
	    System.out.println("utilityFromTrees: no BidUtility");
	    return -1;
	}
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {

	try {
	    OutputFrame frame = new OutputFrame(outputText, outputJob);
	    frame.initComponents();
	    frame.setVisible(true);
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }//createAndShowGUI()

} // PL_CoordProcess
