import java.util.*;
import java.io.*;
/**
 * PL_Count.java
 *
 *
 * Created: Sun Apr 18 15:11:15 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class PL_Count extends GenTask {

    static final boolean DEBUG = false;
    static final boolean DEBUG2 = true;
    static String loc = " in PL_Count ";
    static String em = " Error in PL_Count ";
    static String wm = " Warning in PL_Count ";
    static int manageFailureCount = 1;
    KQMLmsg startMsg; //when this was a ptr to original msg, had null ptr problems
    //String myEndTime;//copy of endtime from msg

    boolean SHORT_CIRCUIT = true; //if a message comes in that raises
				  //Utility above min, report "done" even if
				  //there are still msgs outstanding. See CountMsgs2()
    static Object mySync = new Object();

    public PL_Count() {
	
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
	System.out.println("% PL_Count Zero constructor % <==============");
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
    } // PL_Count constructor
    

    public ProvisionCell init(LinkedListQ Plist, Agent Local){

       ht = Local.userHash;
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       startMsg = new KQMLmsg(K.toString());// save copy for reference

       job = getMsgJob(K);
       
       synchronized(job){
	   do {
	       bidsMade = (Hashtable)localGet("bidsMade", job);
	   } while (bidsMade == null);
	   
	   do {
	       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);       
	   } while (bidsAccepted == null);
       }

       ///myEndTime = K.getContentFieldValue("endtime");
       System.out.println("INSIDE INIT, job is " + job);
       
       //sometimes myTimeout gets this msg before job is set. How?
       return new ProvisionCell(":init heyMyTimeout", "OK");
    }

    /*
     * Messages come here from local generation and from children.
     * all local and child results go into :results. Incoming data are
     * all in :result (not plural).
     */
   public ProvisionCell countMsgs2(LinkedListQ Plist, Agent Local)
   {

       ht = Local.userHash;
       String resultString, replyWithString, sender, outcome = "NotDone";
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));

       startMsg = new KQMLmsg(K.toString());// save copy for reference
       job = getMsgJob(K);

       Local.checkMsgTime(K, Local.dataFile1, job);

       String symbol = startMsg.getContentFieldValue("symbol");
       //if (symbol == NULL || symbol.equals("")
       
       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);       
       //Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);  //for printing only     

       //System.out.println(  Local.getName() + " PL_Count.countMsgs2 beginning : " + dataFromChildren.toString());

       System.out.println("starting countMsgs2, msg: " + K);

       KQMLmsg K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName() );
       K2.addFieldValuePair("performative", "tell");
       K2.addFieldValuePair("receiver", Local.getName());
       K2.addFieldValuePair("ontology", "PL" );

       //IF ALL REPLIES ARE IN AND DistEnv SIGNALS DONE
       if ( K.getContentFieldValue("status").equals("DistrEnvDone")
	    && ( ! waitingForSenders(job))){
	   System.out.println("leaving " + Local.getName() + " PL_Count.countMsgs2, Done "); 
	   addToDataFromChildren(Local.getName(), "empty", Local); //adds conditionally

	   //TRY THIS OUT
	   K2.addFieldValuePair("content", ":status Done");

	   if (DEBUG)System.out.println("countMsgs2 returning: Done " + K2);
	   return new ProvisionCell(K2.toString(), "Done"); //to collectResults
       }

       if (DEBUG) System.out.println("cm1: Total job time remaining: " +
			  (Local.getTimeRemaining(K.getContentFieldValue("endtime"))/1000.0));
       if (DEBUG) System.out.println("cm1: this task time remaining: " +
			  ( Local.getTimeRemaining(Local.getLowerEndTime()) / 1000 ));

       //Hashtable waitingForSenders = (Hashtable)localGet("waitingForSenders", job);
       HashSet failedSenders = (HashSet)localGet("failedSenders", job);

       StringBuffer content = new StringBuffer();
       content.append( " :endtime " + startMsg.getContentFieldValue("endtime"));

       Bid incomingBid = null; //the bid related to the current result

       //synchronized(waitingForSenders){
       synchronized(failedSenders){

	   System.out.println("PL_Count.countMsgs2 was waiting for " 
			      + getNumberOfWaits(job) + " more replies ");
	   String status = K.getContentFieldValue("status");
	   String oldSender;
	   if ( isOpportunity(K) ){
	       if (K.getContentFieldValue("opportunity").equals("first"))
		   oldSender = K.getContentFieldValue("bidder");
	       else 
		   oldSender = K.getValue("sender");
	   }
	   else 
	       oldSender = K.getContentFieldValue("oldSender");
	   content.append(" :oldSender " + oldSender);

	   //System.out.println(  Local.getName() + " PL_Count.countMsgs2 before insert : " + dataFromChildren.toString());

	   //STORE RESULT
	   resultString = (String)K.getContentFieldValue("result");
	   RSTTree tempTree = null;
	   if (DEBUG2) System.out.println(Local.getName() + 
					  " PL_Count.countMsgs2 oldSender: " + oldSender);// + " w/result: " + resultString);
	   if (resultString.equals("")){
	       System.out.println(wm + "in countMsgs2, resultString not valid in " + K.toString());
	       addToDataFromChildren(oldSender, "empty", Local);
	   }
	   else if (resultString.equals("empty")){
	       //System.out.println(wm + "in countMsgs2, resultString not valid in " + K.toString());
	       addToDataFromChildren(oldSender, "empty", Local);
	   }
	   //make DataSets into trees so can see final utility
	   else if (Local.hasNumericChildren()){
	   
	       if (DEBUG2) System.out.println("countMsgs2, resultString Local.hasNumericChildren()");
	       if ( ! resultString.equals("empty")){
		   Vector trees = Local.processChildData(resultString);
		   if (trees.size() > 1)
		       System.out.println(wm + " multiple trees found in Count.countMsgs2.hasNumericChildren: " + trees);
		   if ( ! trees.isEmpty()){
		       tempTree = (RSTTree)trees.elementAt(0);
		       incomingBid = tempTree.getBid();
		       resultString = tempTree.getString();
		       addToDataFromChildren(oldSender, resultString, Local);
		   }
		   else{
		       addToDataFromChildren(oldSender, "empty", Local);
		       //System.out.println(  Local.getName() + " PL_Count.countMsgs2 after hasNumeric : " + dataFromChildren.toString());
		   }
	       }
	   }
	   else if (Local.isNumeric()){ //then results are a DataSet object string
	       addToDataFromChildren(oldSender, resultString, Local);
	   }
	   else {
	       addToDataFromChildren(oldSender, resultString, Local);
	       tempTree = RSTTree.readRSTTree(resultString);
	       incomingBid = tempTree.getBid();
	       //System.out.println(  Local.getName() + " PL_Count.countMsgs2 incoming bid: " + incomingBid);
	   }

	   //System.out.println(  Local.getName() + " PL_Count.countMsgs2 after insert : " + dataFromChildren.toString());

	   //bookkeeping so collectResults can get opp info
	   if ( isOpportunity(K) ){
	       String oppEnv = K.getContentFieldValue("oppEnv");
	       //localPut("oppEnv" + oldSender + resultString, job, oppEnv);
	       localPut("oppEnv", job, oppEnv);//only handles one incoming opp?
	       //localPut("oppStatus" + resultString, job, "yes");
	       //localPut("oppStatus" + oldSender, job, "yes");
	       HashSet oppSenders = (HashSet)localGet("oppSenders", job);
	       oppSenders.add(oldSender);
	       System.out.println("containsOppResults(): " + containsOppResults());

	       //check to see if opp tree meets opp env
	       if (Local.hasNumericChildren()){
		   BidUtility bu = Local.getUtilityFcn();
		   if (bu != null){
		       Bid b = tempTree.getBid();
		       double bidU = b.getUtility(bu).doubleValue();
		       Envelope myEnv = Envelope.readEnvFromString(oppEnv);
		       double envU = Double.parseDouble((String)myEnv.get("utility_min"));
		       System.out.println(loc + "countMsgs2.isOpp checking bid U: " + bidU + " against env U: " + envU);
		       if (bidU >= envU)
			   status = "PASS_OPP";
		       else
			   status = "FAIL_OPP";
		   }
	       }
	   }

	   /************************************
	   DECIDE WHAT TO DO
           ************************************/

	   //HANDLING FAIL UP OPPORTUNITY currently set to return immediately
	   if (isOpportunity(K) ){//addToData won't write over existing result;yes it will
	       if ( ! status.startsWith("FAIL") && ! oldSender.equals(Local.getName()))
		   removeWaitingForSender( oldSender, job, Local.getName(), " Count-1 " );

	       if (oldSender.equals(Local.getName()) && ! status.startsWith("FAIL")){
		   System.out.println(loc + "isOPP with status: " + status + " returning Done");
		   return new ProvisionCell("localOpp", "Done");
	       }
	       else{
		   System.out.println(loc + "isOPP with status: " + status + " returning NotDone");
		   return new ProvisionCell("opportunity", "NotDone");
	       }
	   }

	   //DISTRIBUTE ENV DID NOT SEND ENVELOPES, SO DONE
	   //s/b got envelope from above &&
	   //else if ( ! waitingForSenders(job)){//set to number of envelopes distributed by distributeEnv
	   //    System.out.println("leaving " + Local.getName() + " PL_Count.countMsgs2, Done "); 
	   //    outcome = "Done";
	   //    addToDataFromChildren(Local.getName(), "empty", Local);
	   //}

	   //AGENT BELOW TIMED OUT
	   else if (status.equals("TIMEOUT") ||
		    K.getValue("performative").equals("timeout")){
	       failedSenders.add(oldSender);

	       Local.sendFailReport(job, symbol, "TIMEOUT from " + oldSender, 
				    Long.toString(Local.getTimeRemaining( K.getContentFieldValue("endtime"))), Local);
	       System.out.println(Local.getName() + " PL_Count.countMsgs2 receiving timeout; numFailed=" + 
				  failedSenders.size() + " numNotReceived=" + getNumberOfWaits(job));
	       //if there is time left, use fail mechanism
	       if  ( Local.getTimeRemaining(Local.getLowerEndTime()) > 1000){ //milliseconds 
		   outcome = "failedSubTask"; //goes to ManageFailure
		   content.append(" :status TIMEOUT ");
		   content.append(" :parentEnv " + K.getContentFieldValue("parentEnv"));
	       }
	       else{//only remove sender from wait list if no time to address failure
		   System.out.println("time: " + Local.getTimeRemaining(Local.getLowerEndTime()) + 
				      " is insufficient time to process timeout from sender: " + 
				      oldSender); 
		   if ( ! removeWaitingForSender( oldSender, job , Local.getName(), " Count-2 timeout below" ) )
		       System.out.println(em + " countMsgs2.0 not able to remove sender: " + 
					  oldSender);
	       }
	   }

	   //AGENT BELOW SAYS RESULT DOES NOT MEET ENVELOPE SPECS
	   else if (status.startsWith("FAIL")){//add to failed results? no, already in dataFromChildren
	       failedSenders.add(oldSender);
	       Local.sendFailReport(job, symbol, "FAILS to meet env, from " + oldSender, 
				    Long.toString(Local.getTimeRemaining( K.getContentFieldValue("endtime"))), Local);
	       System.out.println(Local.getName() + " PL_Count.countMsgs2 receiving " + 
				  oldSender + "." + status + 
				  "; numFailed=" + failedSenders.size() + 
				  " numNotReceived=" + getNumberOfWaits(job));       
	       //if there is time left, use fail mechanism
	       if  ( Local.getTimeRemaining(Local.getLowerEndTime()) > 1000){ //milliseconds 
		   outcome = "failedSubTask"; //goes to ManageFailure
		   content.append(" :status " + status);
		   content.append(" :parentEnv " + K.getContentFieldValue("parentEnv"));
	       }
	       else{//only remove sender from wait list if no time to address failure
		   System.out.println("time: " + Local.getTimeRemaining(Local.getLowerEndTime()) + 
				      " is insufficient time to process fail from sender: " + oldSender);
		   if ( ! removeWaitingForSender( oldSender, job, Local.getName(), " Count-3 fail below"  ) )
		       System.out.println(em + " countMsgs2.1 not able to remove sender: " + 
					  oldSender);
	       }
	   }

	   //SUCCESSFUL RESULT FROM AGENT BELOW
	   else { 
	       if (failedSenders.contains(oldSender)){
		   System.out.println("Replacing failed result of " + oldSender);
		   failedSenders.remove(oldSender);
	       }

	       if ( ! removeWaitingForSender( oldSender, job, Local.getName(), " Count-4 success from below"  ) )
		   System.out.println(em + " countMsgs2 not able to remove sender: " + 
				      oldSender);
	       System.out.println(Local.getName() + " PL_Count.countMsgs2 receiving good result, removing "
				  + oldSender + "from waitingForSenders; waiting: " + 
				  showWaitingForSenders(job));       

	       outcome = "NotDone"; //wait for another message
	   }

	   //if NOT WAITING FOR ANYONE, send results on to collectResults
	   if ( ! waitingForSenders(job)) 
	       outcome = "Done";
	   else if (SHORT_CIRCUIT){
	       /**Short circuit allows agent to stop if bids so far beat minimum
		* utility, even if there are msgs outstanding. This is
		* a good thing when lots of failures are happening and
		* there may be multiple messages to one child asking
		* for similar things. This allows the parent to take
		* the first acceptable reply and continue. 
		**/

	       Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
	       String parentEnv = K.getContentFieldValue("parentEnv"); 
	       String envName = parentEnv.replaceFirst(Local.getName(), "");
	       Envelope currEnv = null;
	       currEnv = (Envelope)localGet(envName, job);	
	       if (currEnv != null){
		   System.out.println("CM2: currEnv test: " + currEnv);
		   Collection thisEnvBids = (Collection)localGet(parentEnv + "BidMap", job);
		   System.out.println("CM2: this env " + parentEnv + " bids were " + thisEnvBids);
		   
		   Iterator aBidsI = thisEnvBids.iterator();//sourceBids from envelope
		   String source;
		   Bid b, next;
		   RSTTree r;
		   BidSet bestPoss = new BidSet();
		   while (aBidsI.hasNext()){
		       b = (Bid)aBidsI.next();
		       source = b.getBidder();//source agent name for one bid in currEnv
		       if ( ! failedSenders.contains(source) ){
			   if (dataFromChildren.containsKey(source) &&
			       ( ! ((String)dataFromChildren.get(source)).equals("empty"))){
			       r = RSTTree.readRSTTree((String)dataFromChildren.get(source));
			       next = r.getBid();
			       bestPoss.add(next);
			   }
		       }
		   }
            

		   Bid temp = bestPoss.makeOneBidFromBidSet(Local.getName());
		   double totalUpossible = temp.getUtility(Local.getUtilityFcn()).doubleValue();
		   double uMin = Double.parseDouble((String)currEnv.get("utility_min"));
		   if (totalUpossible >= uMin)
		       outcome = "Done";
	       }
	   }

   
	   //System.out.println(  Local.getName() + " PL_Count.countMsgs2 finished : " + dataFromChildren.toString());

	   content.append(" :results " + getNonFailedResults());
	   content.append(" :failedResults " + getFailedResults());
	   if (incomingBid != null)
	       content.append(" :currentBid " + incomingBid.toString());
	   else
	       content.append(" :currentBid " + "empty");
       }
       
       K2.addFieldValuePair("content", content.toString());
       if (DEBUG2)System.out.println("countMsgs2 returning: " + outcome + " " + K2);
       return new ProvisionCell(K2.toString(), outcome); //to collectResults or manageFailure
   }//countMsgs2(LinkedListQ Plist, Agent Local)

    /**
     * Puts data from children into a hash table stored in Agent Local.
     **/
    private void addToDataFromChildren(String sender, String data, Agent Local){
	if (DEBUG2)
	    System.out.println("PL_Count.addToDataFromChildren: " + sender + " " + data);
	
       Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
       //Vector oppSenders = (Vector)localGet("protectedResult", job);
	       

       synchronized(dataFromChildren){
       if ( ! dataFromChildren.containsKey(sender))
	   dataFromChildren.put(sender, data);
       else if (data.equals("empty")){
	   if (DEBUG2) System.out.println("not replacing old data with 'empty' ");
	   return;
       }
       //else if (oppSenders != null && oppSenders.contains(sender)){
       //	   System.out.println("not replacing OPP data with new " + data);
       //	   return;
       //}
       else{
	   String oldData = (String)dataFromChildren.get(sender);

	   if (oldData.equals("empty"))
	       dataFromChildren.put(sender, data);
	   else{//store higher utility result
	       
	       if (Local.isNumeric()){//replace because agent above can see U and decide which to hold (assuming both got up there)
		   System.out.println(loc + "addToDataFromChildren received more than one NUMERIC result from " + sender); //race conditions?!
		   System.out.println(loc + "addToDataFromChildren replacing: old: " +
				      dataFromChildren.get(sender) + " new: " +
				      data);
		   dataFromChildren.put(sender, data);
		   
		   //then data contains DataSet
		   //System.out.println("DOES THIS CASE EVER OCCUR?");
		   //Yes, think about recovering from failure.  Can't
		   //look at utility of DataSets.
	       }
	       else{
		   RSTTree old = RSTTree.readRSTTree(oldData);
		   RSTTree curr = RSTTree.readRSTTree(data);
		   if (curr.getBid().getUtility(Local.getUtilityFcn()).doubleValue() >
		       old.getBid().getUtility(Local.getUtilityFcn()).doubleValue()){
		       dataFromChildren.put(sender, data);
		       if (DEBUG) System.out.println("replacing old data with curr");
		   }
		   else
		       if (DEBUG) System.out.println("not replacing old data with curr");
	       }
	   }
       }
       }//synch dataFromChildren
    }//addToDataFromChildren(String sender, String data, Agent Local)

    public ProvisionCell myTimeout(LinkedListQ Plist, Agent Local){
	if (job != null)
	    System.out.println("starting PL_Count.myTimeout, waiting: " + showWaitingForSenders(job));
	else
	    System.out.println("starting PL_Count.myTimeout");

	ht = Local.userHash;//gets set here because myTimeout sometimes happens before ht is set; shouldn't.

	//set in PL_acceptEnv.startTimeout
	long timeLeft = Local.getTimeRemaining(Local.getLowerEndTime());
	System.out.println("starting PL_Count.myTimeout("+ timeLeft/1000.0 +")" + 
				   " for level " + Local.getLevel());
	int i = 0;
	System.out.println("finished + job: " + (Boolean)localGet("finished", job) + job);

	//This is the timing loop. FIX so it isn't busy waiting. Task
	//will run until time expires OR job is finished.
	while (timeLeft > 0 && ((Boolean)localGet("finished", job)).booleanValue() == false){
	    
	    try{
		System.out.println("in PL_Count.myTimeout("+ timeLeft/1000.0 +")" + 
				   " " + i++ + showWaitingForSenders(job));
		Thread.sleep(2000);
	    }
	    catch(Exception e){
		System.out.println("in PL_Count.myTimeout: " + e);
	    }
	    
	    timeLeft = Local.getTimeRemaining(Local.getLowerEndTime());
	}
       
	Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);

	System.out.println(Local.getName() + " entering PL_Count.myTimeout data  ");
	KQMLmsg K = new KQMLmsg();
	K.addFieldValuePair("sender", Local.getName() );
	K.addFieldValuePair("performative", "achieve");
	//K.addFieldValuePair("in-reply-to", taskReplyWith); //see receiveEnv
	K.addFieldValuePair("receiver", Local.getName());
	K.addFieldValuePair("ontology", "PL" );
	
	//Time has expired or job has finished if got to this point
	//Has this task already finished while I was sleeping?
	String outcome = "OK";
	Boolean finished = (Boolean)localGet("finished", job); //should be set in PL_acceptEnv or collectResults
	synchronized(dataFromChildren){
	synchronized(finished){
	    if (finished.booleanValue() == false){//time is up but job is not done
		localPut("finished", job, new Boolean(true));
		System.out.println(Local.getName() + " PL_Count.myTimeout firing" + dataFromChildren.toString());
		Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), "I'm sending my local TIMEOUT ", 
				    Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);

		String results;
		if (dataFromChildren.size() > 0)
		    results = getNonFailedResults();
		else results = "empty";

		K.addFieldValuePair("content", ":msg3 mto1 :results " + results + 
				    " :failedResults " + getFailedResults() 
				    + " :status TIMEOUT");
		MsgUtilities.copyGenContent(startMsg, K, Local);

		String processor = "ProcessAgent";
		if (Local.getLevel() == 1) processor = "CoordProcess";

		MsgUtilities.addContentFieldValuePair(K, "task", processor);
       
		if (DEBUG) System.out.println("mto2: Total job time remaining: " +
				   (Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))/1000.0));

		if (DEBUG) System.out.println(Local.getName() + " at level " + Local.getLevel() + 
				   " PL_Count.myTimeout writing: " + K);
     
		return new ProvisionCell(K.getKQMLString(), outcome);
	    }
	    else{//time is not up, but job is done. Don't want to end PL_Count task
		 //immediately because that could prevent other actions in task
		 //from returning data. Count to three and then return.

		try{
		    //Thread.sleep(3000);
		    System.out.println(Local.getName() + " PL_Count.myTimeout noting job finished " + job);
		}
		catch(Exception e){
		    System.out.println("in PL_Count.myTimeout: " + e);
		}
	    
		outcome = "STOP";
	    }
	}//synch finished
        }//synch dataFromChilren
	return new ProvisionCell("NOT FIRED", outcome);
    }// myTimeout(LinkedListQ Plist, Agent Local)

    private boolean containsOppResults(){
	HashSet oppSenders = (HashSet)localGet("oppSenders", job);
	Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
	StringBuffer result = new StringBuffer();
	
	synchronized(dataFromChildren){
	    synchronized(oppSenders){

		Enumeration sources = dataFromChildren.keys();
		Object o;
		while(sources.hasMoreElements()){
		    o = sources.nextElement();
		    if ( oppSenders.contains(o)){
			return true;
		    }
		}
	    }
	}

	return false;
    }

    private String getNonFailedResults(){
	HashSet failedSenders = (HashSet)localGet("failedSenders", job);
	Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
	StringBuffer result = new StringBuffer();
	
	synchronized(dataFromChildren){
	    synchronized(failedSenders){

		Enumeration sources = dataFromChildren.keys();
		Object o;
		while(sources.hasMoreElements()){
		    o = sources.nextElement();
		    if ( ! failedSenders.contains(o)){
			result.append((String)dataFromChildren.get(o));
			result.append(" ");
		    }
		}
	    }
	}

	return result.length() != 0 ? result.toString() : "empty";
    }

    private String getFailedResults(){
	HashSet failedSenders = (HashSet)localGet("failedSenders", job);
	Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
	StringBuffer result = new StringBuffer();

	synchronized(dataFromChildren){
	    synchronized(failedSenders){

		Iterator failed = failedSenders.iterator();
		Object o;
		while(failed.hasNext()){
		    o = failed.next();
		    if (dataFromChildren.containsKey(o)){
			result.append((String)dataFromChildren.get(o));
			result.append(" ");
		    }
		}
	    }
	}

	return result.length() != 0 ? MsgUtilities.removeDuplEmpties(result) : "empty";
    }//getFailedResults()


    /*
     * Accept failure messages from countMsgs2
     * Continually modify response to Envelope from above as subtasks fail.
     */
    public  synchronized ProvisionCell manageFailure(LinkedListQ Plist, Agent Local){
	if (mySync == null)
	    mySync = new Object();
	synchronized(mySync){
	    
        String mf = "manageFailure";

        KQMLmsg K2 = new KQMLmsg(Util.getValue(Plist, "failed"));
        String sender = K2.getContentFieldValue("oldSender");

	//see PL_DistrEnv
	String parentEnv = K2.getContentFieldValue("parentEnv"); //has env to bid mapping
	Collection thisEnvBids = (Collection)localGet(parentEnv + "BidMap", job);
	System.out.println("###########this env " + parentEnv + " bids were " + thisEnvBids);
	String envName = parentEnv.replaceFirst(Local.getName(), "");
	Envelope currEnv = (Envelope)localGet(envName, job);	
	System.out.println("currEnv test: " + currEnv);
	
        String result = "none";
	String currentFailedResultBidString = K2.getContentFieldValue("currentBid");//set in countMsgs2
	Bid currentFailedResultBid = Bid.readBidFromString(currentFailedResultBidString);
	System.out.println("###########currentFailedResultBid " + currentFailedResultBid);
        String status = "CONTINUE";
        String outcome = "continue";
        //Vector failedBids = new Vector();
        long time = System.currentTimeMillis();

        Hashtable dataFromChildren = (Hashtable)localGet("dataFromChildren", job);
        //HashSet waitingForSenders = (HashSet)localGet("waitingForSenders", job);
        HashSet failedSenders = (HashSet)localGet("failedSenders", job);
        HashSet failedBids = (HashSet)localGet("failedBids", job);
	//recoverybidsMF is set of bids that have been attempted so far
        HashSet recoverybidsMF = (HashSet)localGet("recoverybidsMF", job);

	Hashtable zeroedBids = new Hashtable(); //map zeroed cost/time bids to original form

	//this is an envelope, but not the right envelope, check curr env test above

        Envelope incomingEnvelope = currEnv;//(Envelope)localGet("incomingEnvelope", job); //incomingEnvelope FIX remove put for incomingEnv
        //synchronized(myEnvelope){
	    synchronized(failedBids){
		synchronized(recoverybidsMF){
		    synchronized(failedSenders){

			///Sender will be added again if they are part of env sent to DistrEnv
			//removeWaitingForSender(sender, job, Local.getName(), " Count-5 manageFailure" );

			double uMin = Double.parseDouble((String)incomingEnvelope.get("utility_min"));
			//get bids that are part, subtract failed, calc u
			System.out.println(mf + " parentEnv: " + parentEnv);
			System.out.println(mf + " uMin: " + uMin);

			BidSet attemptedBids = new BidSet();
			//SourceBids are bids from children that were part of this job's chosen envelope
			//BidSet sourceBids = getBidComponents(myEnvelope.getBid());
			
			recoverybidsMF.addAll(thisEnvBids); // sourceBids
			attemptedBids.addAll(recoverybidsMF);

			/**************************************************************
			 * Separate attempted bids into failed and not-failed
			 **/
			//successfulBids are sourceBids that have **NOT YET FAILED**

			System.out.println(mf + " attemptedBids: " + attemptedBids);

			///Have to look through bids this way because
			///failed result may have different cost,
			///length, DS, etc, so cannot find using equals()
			Iterator thisEnvBidsIter = thisEnvBids.iterator();
			Bid currentFailedBid = null;
			///locate original accepted form of the failed bid
			while (thisEnvBidsIter.hasNext()) {
			    Bid b = (Bid)thisEnvBidsIter.next();  
			    System.out.println("walking bids looking for " + currentFailedResultBid.getBidder()+ " in " + b);
			    if (currentFailedResultBid != null && 
				currentFailedResultBid.getBidder().equals( b.getBidder())){
				System.out.println("MF found " + b);
				currentFailedBid = b;
				continue;
			    }
			}
			failedBids.add(currentFailedBid);

			System.out.println(mf + " failedBids: " + failedBids);
			//System.out.println(mf + " successfulBids: " + successfulBids);

			StringBuffer omsg = new StringBuffer("");
			omsg.append(Local.getName());
			omsg.append(" starting manageFailure, count " + (manageFailureCount++));
			omsg.append(" sender " + sender + "\nwaiting=");
			omsg.append(showWaitingForSenders(job));
			omsg.append(" currBid=" + currentFailedBid);
			omsg.append("\nfailedBids= ");
			omsg.append(failedBids.toString());
			Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
					     omsg.toString(),
					     Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), 
					     Local);
        
			/**
			 * compute best possible utility from existing and outstanding data
			 *  look at attemptedBids
			 *  for each bid, get data from tree or directly from bid
			 *  get total
			 **/
			Iterator aBids = attemptedBids.iterator();//sourceBids
			String source;
			Bid b, next;
			RSTTree r;
			BidSet bestPoss = new BidSet();
			while (aBids.hasNext()){
			    b = (Bid)aBids.next();
			    source = b.getBidder();
			    if ( ! failedBids.contains(b) ){//( ! failedSenders.contains(b.getBidder()) ){
				if (dataFromChildren.containsKey(source) &&
				    ( ! ((String)dataFromChildren.get(source)).equals("empty"))){
				    r = RSTTree.readRSTTree((String)dataFromChildren.get(source));
				    next = r.getBid();
				}
				else next = b;
				bestPoss.add(next);
			    }
			}
            
			Bid temp = bestPoss.makeOneBidFromBidSet(Local.getName());
			double totalUpossible = temp.getUtility(Local.getUtilityFcn()).doubleValue();
			
System.out.println("\nfailedSenders: " + failedSenders);
System.out.println("\nMF best bid from attempted w/o failed result: " + temp);
System.out.println("\nMF best bidset: " + bestPoss);
			

			//if this failure doesn't wreck utility, don't worry about it
			if (totalUpossible >= uMin){//then keep going                  
			    //waitingForSenders.remove(sender); //done elsewhere
			    //System.out.println("manageFailure total possible U " + totalUpossible + " exceeds Umin: " + uMin);

			    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
						 "manageFailure total possible U " + totalUpossible + " exceeds Umin=" + uMin,
						 Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);

			    removeWaitingForSender(sender, job, Local.getName(), " Count-5.1 manageFailure" );

			    if ( ! waitingForSenders(job)){//all other responses are in
				System.out.println(mf + " all responses in, continuing.");
				return new ProvisionCell(getNonFailedResults(), "continue");
			    }
			    //if some responses are still outstanding
			    else{ 
				return new ProvisionCell("", "doNothing");
			    }
			}

			/************************************************************/
			//else Current possible is less than Umin
			//Figure out how to increase U with additional
			//bids; Set costs, time to zero, since marginal
			//cost is zero NOT HERE zeroed below after
			//clone

			//vAll is a vector of bidSets sent from below during RFB; has child source bidder names
			Vector vAll = (Vector)localGet("bidsConsidered",job); //set in acceptRFB
			vAll = (Vector)vAll.clone();
			System.out.println(mf + " vAll: " + vAll);
			System.out.println(mf+ " attempted Bids: " + attemptedBids);//sourceBids
			System.out.println("failedBids: " + failedBids);
            
			//All BidSets from bidding process are in
			//vAll; go through each cloned BidSet and
			//remove failed bids. For any bids that are
			//not failed and also in attempted bids, set
			//time and cost to zero since they are already
			//being executed.
            
			Vector newFailed = new Vector();
			Vector bidSetsWithoutFails = new Vector();
			Iterator oldBidSets = vAll.iterator();
			BidSet currOldBidSet;
			Bid old, failed, sourceBid;
			Iterator failedBI;
			Iterator sources;
			while(oldBidSets.hasNext()){
			    currOldBidSet = (BidSet)oldBidSets.next(); //set of all bids from one child
			    //synchronized(currOldBidSet){

				/** remove failed bids from currOldBidSet before updating cost/time **/
			    Vector notFailedBids = new Vector();//contains bids not known to have failed from currOldBidSet
			    Iterator currOldBidSetIter = currOldBidSet.iterator();
			    while(currOldBidSetIter.hasNext()){
				old = (Bid)currOldBidSetIter.next(); //one bid from a child
	 System.out.println("*****old is " + old);
				boolean failedFlag = false;
				failedBI = failedBids.iterator();
				while(failedBI.hasNext()){
				    failed = (Bid)failedBI.next();
	 System.out.println("failed is " + failed);
				    if (failed.limitedEquals(old)){
	 System.out.println("removing");
					newFailed.add(old);//not needed if next line works
					//currOldBidSetIter.remove(); why doesn't this work? may work now, fixed clone? nope
					failedFlag = true;
				    }
				}
				if ( ! failedFlag )
				    notFailedBids.add(old);
			    }

			    if (DEBUG2) System.out.println(mf+ " newFailed " + newFailed);
			    if (DEBUG2 && ! newFailed.isEmpty()) 
				System.out.println(mf+ " cobs w/ failed: " + currOldBidSet);
			    ///this doesn't work either, shows error every time.
			    if ( ! newFailed.isEmpty() && ! currOldBidSet.removeAll(newFailed) ){
				System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
				System.out.println("ERROR failed bids were not removed!");
				System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			    }
			    if (DEBUG2 && ! newFailed.isEmpty()) 
				System.out.println(mf+ " cobs w/o failed: " + currOldBidSet);

			    BidSet oneBidSetWithoutFails = new BidSet(currOldBidSet.getOwner(), (Collection)notFailedBids);
       System.out.println(mf+ " oneBidSetWithoutFails: " + oneBidSetWithoutFails);

			    newFailed.clear();
			    /** set marginal cost/time to zero for completed bids **/
			    Iterator oneBidSetWithoutFailsIter = oneBidSetWithoutFails.iterator();
			    while(oneBidSetWithoutFailsIter.hasNext()){
				old = (Bid)oneBidSetWithoutFailsIter.next();
				sources = attemptedBids.iterator();//sourceBids
				while(sources.hasNext()){
				    sourceBid = (Bid)sources.next();
				    if (DEBUG) System.out.println(mf+ " comparing: " + sourceBid + " to old: " + old);
				    if (old.equals(sourceBid)){
					if (DEBUG) System.out.println(mf+ " found " + sourceBid + " in " + old);
					Bid notZeroedBid = (Bid)old.clone();
					old.put("cost_exp", "0");
					old.put("time_exp", "0");
					zeroedBids.put( old, notZeroedBid );
				    }
				}
			    }

			    bidSetsWithoutFails.add(oneBidSetWithoutFails);

			    ///** set marginal cost/time to zero for completed bids **/
			    //currOldBidSetIter = currOldBidSet.iterator();
			    //while(currOldBidSetIter.hasNext()){
			    //	old = (Bid)currOldBidSetIter.next();
			    //	sources = attemptedBids.iterator();//sourceBids
			    //	while(sources.hasNext()){
			    //	    sourceBid = (Bid)sources.next();
			    //	    if (DEBUG) System.out.println(mf+ " comparing: " + sourceBid + " to old: " + old);
			    //	    if (old.equals(sourceBid)){
			    //		if (DEBUG) System.out.println(mf+ " found " + sourceBid + " in " + old);
			    //		old.put("cost_exp", "0");
			    //		old.put("time_exp", "0");
			    //	    }
			    //	}
			    //}
				// }//synchronized(currOldBidSet){
			}//while changing vAll
			//if (DEBUG2) System.out.println(mf+ "vAll new w zero cost/time: " + vAll);

			bidSetsWithoutFails = bidSetsWithoutFails;
			if (DEBUG2) System.out.println(mf+ "bidSetsWithoutFails new w zero cost/time: " + bidSetsWithoutFails);

			Envelope newEnv = null;
			Vector newBidCombos = null;
			BidSet bs = null;

			if ( ! bidSetsWithoutFails.isEmpty())
			    newBidCombos = BidSet.chooseOneCombos(Local.getName(), bidSetsWithoutFails);
                
			if ( newBidCombos != null && ( ! newBidCombos.isEmpty() )){
			    if (DEBUG) System.out.println(mf + " new bid combos: " + newBidCombos);
			    bs = BidSet.makeSingleBidsFromBidSets(Local.getName(), newBidCombos);
			    bs.setEachBidUtility(Local.getUtilityFcn());
     System.out.println("Count.manageFailure: new combined bids before constraints: ("+bs.size()+")" + bs);

			    ConstraintSet cs = Local.constraints; //FIX      
			    if (DEBUG2) System.out.println(mf + " constraints: " + cs);

			    bs.filterUsingConstraints(cs); //does this need to be done? checks time
			}

			if ( bs != null && ! bs.isEmpty() ){

			    omsg = new StringBuffer("");
			    omsg.append(Local.getName());
			    omsg.append(" manageFailure considering bids: \n");
			    omsg.append(bs.toString());//TEMPORARY?
			    Iterator newBidsI = bs.iterator();
			    while (newBidsI.hasNext()){
				omsg.append( ((Bid)newBidsI.next()).toString() + "\n" );
			    }
			    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
						 omsg.toString(),
						 Long.toString(Local.getTimeRemaining( 
										      startMsg.getContentFieldValue("endtime"))), 
						 Local);
                                
			    //Vector high = new Vector(bs);
			    Bid newHighBid = bs.getHighestUtilityBid(Local.getUtilityFcn());

			    //bs = bs.getNHighestUtility(1, Local.getUtilityFcn());
			    //bs.setOwner(Local.getName());
			    bs = new BidSet(Local.getName());
			    bs.add(newHighBid);
			    System.out.println("new high bid: " + newHighBid);
			    
			    /** If new high bid is not as good a
			     * choice as continuing on current trajectory, don't send new bid. We
			     * don't care if it is not as good as uMin, as long as it is better than what
			     * we are currently looking at. **/
			    if (totalUpossible >= newHighBid.utility()){ // || uMin > newHighBid.utility())

				//removeWaitingForSender(sender, job, Local.getName(), " Count-5.2 manageFailure" );

				//if current U with failed beats U of new highest
				if (totalUpossible >= newHighBid.utility()) {
				    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
							 "manageFailure Best alternative set to failed bid=" + 
							 newHighBid.utility() + " does not beat current path expected U=" + totalUpossible,
							 Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);

				    if (DEBUG)System.out.println("manageFailure: Best alternative set to failed bid: " + newHighBid.utility() + " does not beat current path expected: " + totalUpossible);
				}
                    
				//if U of new highest does not meet Umin
				else if (uMin > newHighBid.utility())  {
				    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
							 "manageFailure Best alternative set to failed bid=" + 
							 newHighBid.utility() + " does not beat  uMin=" + uMin,
							 Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);
				    if (DEBUG) System.out.println("manageFailure: Best alternative set to failed bid: " + 
								  newHighBid.utility() + " does not meet Umin: " + uMin);
				}
				
				/************************************************************/

				if ( ! waitingForSenders(job)){//all other responses are in
				    System.out.println("manageFailure returning CONTINUE");
				    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
							 "manageFailure returning CONTINUE",
							 Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);
				    return new ProvisionCell(getNonFailedResults(), "continue");
				}
				//if some responses are still outstanding
				else return new ProvisionCell("", "doNothing");
			    }
			    //New bidset beats best envelope currently
			    //possible (but not necessarily Umin) and
			    //beats continuing with failed
			    else{
				System.out.println("manageFailure: Best alternative set does beat Umin. Ualt: " + newHighBid.utility());
				Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
						     "manageFailure Best alternative set does beat Umin. Ualt=" + 
						     newHighBid,
						     Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);
				setBidsMade(bs);//stores bid=bidset source pairs in Agent    

				BidSet newBids = newHighBid.getBidSetSource();
				newBids = (BidSet)newBids.clone();
	System.out.println("newBids (larger): " + newBids);
				Iterator recBidsI = recoverybidsMF.iterator();
				//Remove bids that have already been attempted (should there be any? there are...)
				while (recBidsI.hasNext()){
				    Bid b1 = (Bid)recBidsI.next();
	System.out.println("from recBidsI: " + b1);
				    Iterator newBidsIter = newBids.iterator();
				    Bid newBidNext;
				    while (newBidsIter.hasNext()){
					newBidNext = (Bid)newBidsIter.next();
					if (newBidNext.limitedEquals(b1)){
    System.out.println("newBids removing " + b1);
					    newBidsIter.remove();
					}
				    }
				    //newBids.remove(b1);
				}

	System.out.println("old recoveryBids: " + recoverybidsMF);
				//recoverybidsMF.addAll(newBids);
	                        Iterator newBidsI2 = newBids.iterator();
				while (newBidsI2.hasNext()){
				    Bid b2 = (Bid)newBidsI2.next();
				    if (zeroedBids.containsKey(b2))
					recoverybidsMF.add(zeroedBids.get(b2));
				    else 
					recoverybidsMF.add(b2);
				}

	System.out.println("newHighBid.sources: " + newHighBid.getBidSetSource());
	System.out.println("newBids (smaller): " + newBids);
	System.out.println("new recoveryBids: " + recoverybidsMF);
				
				newEnv = new Envelope(newHighBid);
				newEnv.put("utility_min", Double.toString(uMin));
				localPut(newEnv.getName(), job, newEnv);
				//waitingForSenders.add(whom? DistEnv figures this out
			    }
			    /*********IF WE CHOOSE TO ALLOW Umin TO DROP FOR THIS BID******
				      that is, if we allow new U to drop below Umin and set new Umin 
				      (warning: could cause failure chain above since Umins above are not changed)
				      Local.setBidsMade(bs);//stores bid=bidset source pairs in Agent    
				      //should probably be default variance, so set num bids to 1 in getNHighest   
				      Envelope newEnv = bs.getBestBidsEnvelope(Local.getUtilityFcn());
				      localPut(newEnv.getName(), job, newEnv);
			    **********/
			}
            
			else{ //bidSetsWithoutFails is empty         
			    System.out.println("manageFailure: no alternative set to failed bid");
			    removeWaitingForSender(sender, job, Local.getName(), " Count-7 " );

			    Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
						 "manageFailure - no alternative set to failed bid",
						 Long.toString(Local.getTimeRemaining( startMsg.getContentFieldValue("endtime"))), Local);

			    System.out.println("*******************Removing2 " + sender + " from waitingforSenders");
			    if ( ! waitingForSenders(job)){//all other responses are in
				return new ProvisionCell("CONTINUE", "continue");
			    }
			    //if some responses are still outstanding
			    else return new ProvisionCell("", "doNothing");
			}

			//DistEnv looks at localGet(envName, job)
			KQMLmsg K = new KQMLmsg();
			K.addFieldValuePair("sender", Local.getName() );
			K.addFieldValuePair("performative", "achieve");
			//K.addFieldValuePair("in-reply-to", taskReplyWith); //see receiveEnv
			K.addFieldValuePair("receiver", Local.getName());
			K.addFieldValuePair("ontology", "PL" );
			K.addFieldValuePair("content", ":task DistrEnv :newEnv " + newEnv.getName() +
					    " :recovery yes :failedSender " + sender); //recovery field tells DistrEnv that receiver is in wait list already
			MsgUtilities.copyGenContent(startMsg, K, Local);
			//parentEnv in K is this agent's envelope; want to tell DistrEnv the env from this agent's parent
			MsgUtilities.replaceContent(K, "parentEnv", (String)localGet(parentEnv + "ParentEnvMap", job));
			System.out.println(Local.getName() + " PL_Count.manageFailure writing: " + K);
     
			return new ProvisionCell(K.toString(), "newEnvelope");
		    }}}//}
	}//mySync
    }// manageFailure(LinkedListQ Plist, Agent Local)

    /*
     * All local and child results go into :results.
     */
   public ProvisionCell collectResults(LinkedListQ Plist, Agent Local)
   {
       String status = "";
       try{
	   KQMLmsg K1 = new KQMLmsg(Util.getValue(Plist, "allResults"));//is not necessarily a msg
	   status = K1.getContentFieldValue("status");//holds "Done" if there
       } catch (KQMLException ke){
	   if (DEBUG) System.out.println("collectResults input is not a msg: " + 
					 Util.getValue(Plist, "allResults") );
       }
       if (DEBUG) System.out.println("collectResults starting ");// + K1.toString());
       
       String results = getNonFailedResults();
       if (results.equals("")) results = "empty";
       String failedResults = getFailedResults();
       if (failedResults.equals("")) failedResults = "empty";
       String outcome = "OK";

       if (DEBUG) System.out.println("collectResults starting2 ");// + K1.toString());

       Boolean finished = (Boolean)localGet("finished", job); //should be set in PL_acceptEnv
       if (DEBUG) System.out.println("finished is " + finished);
       synchronized(finished){
	   if (finished.booleanValue() == false){

	       localPut("finished", job, new Boolean(true));
	       System.out.println("PL_Count.collectResults setting finished to true.");

	       System.out.println(Local.getName() + " PL_Count.collectResults r: " + results + 
				  " fr: " + failedResults);
	       //if (results.equals("nokids")) results = "empty";

	       KQMLmsg K = new KQMLmsg();
	       K.addFieldValuePair("sender", Local.getName() );
	       K.addFieldValuePair("performative", "achieve");
	       //K.addFieldValuePair("in-reply-to", (String)localGet("taskReplyWith", job)); //see receiveEnv
	       K.addFieldValuePair("receiver", Local.getName());
	       K.addFieldValuePair("ontology", "PL" );

	       String processor;
	       if (Local.getLevel() == 1) processor = "CoordProcess";
	       else processor = "ProcessAgent";

	       K.addFieldValuePair("content", ":task "+ processor +" :msg3 r75 :results " + results + 
				   " :failedResults " + failedResults);

	       if (results.equals("empty") && failedResults.equals("empty") &&
		   status.equals("Done"))
		   MsgUtilities.addContentFieldValuePair(K, "status", status);

	       MsgUtilities.copyGenContent(startMsg, K, Local);

	       if (containsOppResults()){
		   String env = (String)localGet("oppEnv", job);
		   MsgUtilities.addContentFieldValuePair(K, "oppEnv", env);
		   MsgUtilities.addContentFieldValuePair(K, "opportunity", "yes");
	       }

	       System.out.println(Local.getName() + " PL_Count.collectResults writing: " + K);
       
	       return new ProvisionCell(K.getKQMLString(),outcome);
	   }
	   else
	       outcome = "OK"; //still want to return a msg to parent, so don't "STOP"
       }
       return new ProvisionCell("ALREADY TIMED OUT",outcome);
   }//collectResults(LinkedListQ Plist, Agent Local)

} // PL_Count


//	   else if (Local.hasNumericChildren()){
//	       resultString = (String)K.getContentFieldValue("result");
//	       sender = oldSender;//K.getValue("sender");
//	       waitingForSenders.remove(sender);
//
//
//
//
//	//if (sender.equals(Local.getName())){
//	//	   System.out.println(Local.getName() + " PL_Count.countMsgs2 receiving local result: " + resultString);
//	//}
//	//else //sent from a child
//	//	   System.out.println(Local.getName() + " PL_Count.countMsgs2 receiving child result: " + 
//	//			      resultString);       
//	       
//	       dataFromChildren.append(resultString + " ");
//	       P1 =  new ProvisionCell("","NotDone");//wait for another message
//
//	       if (waitingForSenders.size() == 0){ 
//		   //String out = "localTree=" + localData + ", childData=" + ;
//		   System.out.println(  Local.getName() + " PL_Count.countMsgs2 finished, all Data=" + 
//					dataFromChildren.toString());
//
//		   if (dataFromChildren.toString().equals(""))
//		       P1 =  new ProvisionCell("nokids", "Done");
//		   else
//		       P1 =  new ProvisionCell(dataFromChildren.toString(), "Done");
//	       }
//	   }
