import java.io.*;
import java.net.*;
import java.util.*;

public class PL_DebtRisk extends GenAgent
{
    static final boolean DEBUG = true;
    static final String loc = "in PL_DebtRisk ";
    static final String em = "ERROR in PL_DebtRisk ";
    final boolean TIMING_RUN = false; //causes DS failure if cost >= 5

   public PL_DebtRisk()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_DebtRisk Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
   }

    /**
     *Initialize a DebtRisk agent.
    **/
    public ProvisionCell start(LinkedListQ Plist, Agent Local)
    {
	super.start(Local, DSType.RISK);
	System.out.println("**********starting DebtRisk agent: " + Local.getName() + " **************");

	Local.setLevel(3);
	Local.setMyTaskObject(this);
	Local.setHasNumericChildren();

	Local.setParent("Risk");
	Local.addChild("CR");
	Local.addChild("DE");
	Local.defaultString = "DebtRisk output";

	Bid b;
	DataSet d;
////////////////////////////////////////////////////////////
	//b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=IBM, DSr_exp=[[0.5 0.5 1][0 0 0]], topic=r, U=null, bidder=DR}");
	//d = new DataSet(Local.getName());
	//d.put("bid", b);
	//Local.addLocalBid(b, d.toString());
////////////////////////////////////////////////////////////
	//b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=URS, DSr_exp=[[2 2 1][0 0 0]], topic=r, U=null, bidder=DR}");
	//d = new DataSet(Local.getName());
	//d.put("bid", b);
	//Local.addLocalBid(b, d.toString());
//////////////////////////////////////////////////////////////
	//b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=DCX, DSr_exp=[[0 0 0][2 2 1]], topic=r, U=null, bidder=DR}");
	//d = new DataSet(Local.getName());
	//d.put("bid", b);
	//Local.addLocalBid(b, d.toString());
//////////////////////////////////////////////////////////////
	//b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=XYZ, DSr_exp=[[1 1 1][0 0 0]], topic=r, U=null, bidder=DR}");
	//d = new DataSet(Local.getName());
	//d.put("bid", b);
	//Local.addLocalBid(b, d.toString());
////////////////////////////////////////////////////////////
	System.out.println("local bids are: " + Local.getLocalBids());

	return new ProvisionCell("started DebtRisk", "OK");
    }

    public RSTTree makeTreeFromData(DataSet d){
	if (DEBUG) System.out.println(loc + "makeTreeFromData d: " + d); 
	
	Bid b = (Bid)d.get("bid");
	RSTTree result = null;
	if (d.getSource().equals("DR"))
	    result = makeLocalTree(d);
	else if (d.getSource().equals("CR"))
	    result = makeCRTree(d);
	else if (d.getSource().equals("DE"))
	    result = makeDETree(d);
	else{
	    result = RSTTree.GoalDo("Default phrase " + b.getSymbol() + " in DR", DSType.RISK, b);
	}

	if (TIMING_RUN &&
	    5 <= Double.parseDouble((String)b.get("cost_exp"))){
	    //Strength zeroDS = new Strength( 0 );
	    //result.updateBid("DS" + DSType.RISK + "_exp", zeroDS);
	    result.zeroDS(DSType.RISK);
	}

	TreeGenerate tg = new TreeGenerate( b.getSymbol() );
	result.updateBid("length_exp", Integer.toString(tg.wordCount( tg.generate(result)) ));

	if (DEBUG) System.out.println(loc + "makeTreeFromData tree: ");
	if (DEBUG) result.print();
	return result;
    }//makeTreeFromData(DataSet d)

    private RSTTree makeLocalTree(DataSet d){

	double ds = 0, length = 0;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");
	//price = Double.parseDouble((String)b.get("cost_exp"));

	Strength dsr = (Strength)b.get("DSr_exp");
	if (dsr.direction() > 0)
	    ds = dsr.posCurr();
	else if (dsr.direction() < 0)
	    ds = - dsr.negCurr();
	else
	    System.out.println(em + "DataSet has mixed or no Strength: " + d );
	
	String start = "company has a history of ";

	if (ds < -2){ 
	    phrase = start + "high debt "; 
	    length = 8; ds = -1;
	}
	//else if (ds < -1){ 
	//    phrase = start + "high debt "; 
	//    length = 7; ds = -1;
	//}
	else if (ds < 0){ 
	    phrase = start + "liberal borrowing "; 
	    length = 7; ds = -1;
	}
	else if (ds < 2){ 
	    phrase = "company has historically maintained a moderate debt policy ";
	    length = 8;
	}
	else {//if (ds > 1){ 
	    phrase = start + "conservative debt policy ";
	    length = 8;
	}
	
	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSr is " + newDS);
	b.put("DS" + DSType.RISK + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	b.put("topic", DSType.RISK );
	if (ds > 0)
	    result = RSTTree.GoalDo(phrase, DSType.RISK, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.RISK, b);
	return result;
    }//makeLocalTree(DataSet d)


    private RSTTree makeCRTree(DataSet d){

	double ds, diff, length = 0, price, currentRatio, industryCurrentRatio = -1;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");
	price = Double.parseDouble((String)b.get("cost_exp"));

	currentRatio = Double.parseDouble((String)d.get("currentRatio"));

	ds = PL_ExecuteCR.calcDSfromCR(currentRatio);//may be altered below

	if (price < 3){
	    
	    if (ds < -6){ 
		phrase = "company has a very poor current ratio comma indicating significant potential problems with near-term debt"; 
		length = 14;
	    }
	    else if (ds < -3){ 
		phrase = "company has a very poor current ratio comma indicating potential problems with near-term debt"; 
		length = 14;
	    }
	    else if (ds < -1){ 
		phrase = "company has a poor current ratio comma indicating potential problems with near-term debt"; 
		length = 13;
	    }
	    else if (ds < 0){ 
		phrase = "company has a poor current ratio"; 
		length = 6;
	    }
	    else if (ds < 0.5){ 
		phrase = "company has an acceptable current ratio";
		length = 6;
	    }
	    else if (ds < 1){ 
		phrase = "company has a good current ratio";
		length = 6;
	    }
	    else if (ds < 3){ 
		phrase = "company has a strong current ratio comma indicating good short-term liquidity";
		length = 11;
	    }
	    else {
		phrase = "company has a very strong current ratio comma indicating good short-term liquidity";
		length = 12;
	    }
	    ds = ds/2; //REDUCE DS BECAUSE OF COST i.e. info is absolute, less valuable
	}
	else if (price >= 3 && price < 30) {//30 is for testing special opportunities
	    industryCurrentRatio = Double.parseDouble((String)d.get("industryCurrentRatio"));
	    if ( currentRatio >= industryCurrentRatio )
		ds = Math.pow( (currentRatio/industryCurrentRatio), 2);
	    else
		ds = - Math.pow( (industryCurrentRatio/currentRatio), 2);
	    if (ds < -3){ 
		phrase = "company has a very poor current ratio relative to the industry average"; 
		length = 12;
	    }
	    else if (ds < -1.4){ 
		phrase = "company has a poor current ratio relative to the industry average"; 
		length = 11;
	    }
	    else if (ds < -1.1){ 
		phrase = "company current ratio is not as strong as the industry average"; 
		length = 11;
	    }
	    else if (ds < -1){ 
		phrase = "company has a current ratio similar to the industry average"; 
		length = 10;
	    }
//calculation sets ds greater than 1 or less than -1? no, multiplies by 2
	    else if (ds < 1.2){ 
		phrase = "company has a current ratio similar to the industry average";
		length = 10;
	    }
	    else if (ds < 1.4){ 
		phrase = "company has a good current ratio relative to the industry average";
		length = 11;
	    }
	    else if (ds < 3){ 
		phrase = "company has a strong current ratio relative to the industry average";
		length = 11;
	    }
	    else if (ds > 3){ 
		phrase = "company has a very strong current ratio relative to the industry average";
		length = 12;
	    }
	    else {
		phrase = "company CR: " + Double.toString(currentRatio) + 
		    "industry CR: " + Double.toString(industryCurrentRatio);
		length = 8;
	    }
	    ds = ds * 2; //makes numbers more comparable to DSs from other ratios
	}
	
	/******************for testing opps***********************/

	else  {//>30 is for testing special opportunities
	    industryCurrentRatio = Double.parseDouble((String)d.get("industryCurrentRatio"));
	    if ( currentRatio >= industryCurrentRatio )
		ds = Math.pow( (currentRatio/industryCurrentRatio), 2);
	    else
		ds = - Math.pow( (industryCurrentRatio/currentRatio), 2);
	    ds = 10 * ds;
	    if (ds < 0){ 
		phrase = "company has just reported a very poor current ratio relative to the industry average"; 
		length = 14;
	    }
	    else { 
		phrase = "company has a just reported a much improved current ratio relative to the industry average"; 
		length = 15;
	    }
	}
	    /*****************************************************/


	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSr is " + newDS);
	b.put("DS" + DSType.RISK + "_exp", newDS);
	b.put("length_exp", Double.toString(length));

	if (ds > 0)
	    result = RSTTree.GoalDo(phrase, DSType.RISK, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.RISK, b);
	return result;
    }//makeCRTree(DataSet d)

    private RSTTree makeDETree(DataSet d){

	double ds, diff, length = 0, price, debtEquityRatio, industryDebtEquityRatio = -1;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");
	price = Double.parseDouble((String)b.get("cost_exp"));

	debtEquityRatio = Double.parseDouble((String)d.get("debtEquityRatio"));

	//ds = PL_ExecuteDE.calcDSfromDE(debtEquityRatio);//may be altered below

	//REPLACE WITH ds = 1.5x^2 + -15x +10

	if (price < 3){
	    
	    if (debtEquityRatio >= 1.5){ 
		phrase = "company has a very high debt equity ratio comma suggesting high vulnerability if economic conditions decline"; 
		length = 15; ds = -( 8.5 + 10 *(debtEquityRatio - 1.5)); //range 
	    }
	    else if (debtEquityRatio >= .9){ 
		phrase = "company has a very high debt equity ratio comma suggesting aggressive borrowing practices"; 
		length = 12; ds = -(2.5 + 10 *(debtEquityRatio - 0.9)); //range 2.5 - 8.5
	    }
	    else if (debtEquityRatio >= .75){ 
		phrase = "company has a high debt equity ratio comma outside the norms of conservative financing";
		length = 13; ds = -(1 + 10 *(debtEquityRatio - 0.75)); //range 1 - 2.5
	    }
	    else if (debtEquityRatio >= 0.5){ 
		phrase = "company has an acceptable debt equity ratio";
		length = 6; ds = -(-1 + 8 *(debtEquityRatio - 0.5)); //range -1 .. 1
	    }
	    else if (debtEquityRatio >= 0.25){ 
		phrase = "company has a low debt equity ratio comma suggesting the ability to weather an economic downturn ";
		length = 15; ds = -(-6 + 20 *(debtEquityRatio - 0.25)); //range -6 .. -1
	    }
	    else { //if (debtEquityRatio < 0.25){ 
		phrase = "company has extremely low debt relative to its capitalization ";
		length = 9; ds = - ( -6 + 40 * debtEquityRatio); //range -6 .. -1
	    }
	    
	    ds = ds/2; //REDUCE DS BECAUSE OF COST i.e. info is absolute, less valuable
	}
	else { //if (price >= 3){
	    industryDebtEquityRatio = Double.parseDouble((String)d.get("industryDebtEquityRatio"));
	    diff =  (industryDebtEquityRatio - debtEquityRatio) / industryDebtEquityRatio;
	    
	    //REPLACE WITH 5x^2 + 13x + 0 (fitted) where x is diff

	    if (diff < -1) {
		phrase = "company's debt equity ratio is more than twice the industry average comma indicating a very high relative debt load ";
		length = 17; ds = -10;
	    }
	    else if (diff <= -0.6) {
		phrase = "company's debt equity ratio is much worse than the industry average ";
		length = 10; ds = -6;
	    }
	    else if (diff <= -0.3) {
		phrase = "company's debt equity ratio is not good relative to the industry average ";
		length = 11; ds = -4;
	    }
	    else if (diff <= -0.1) {
		phrase = "company's debt equity ratio indicates slightly higher debt than industry average ";
		length = 10; ds = -2;
	    }
	    else if (diff <= 0.1) {
		phrase = "company's debt equity ratio indicates a debt position similar to the industry average ";
		length = 12; ds = 1;
	    }
	    else if (diff <= 0.3) {
		phrase = "company's debt equity ratio indicates a good debt position relative to the industry average ";
		length = 13; ds = 2;
	    }
	    else if (diff <= 0.5) {
		phrase = "company's debt equity ratio indicates a much lower debt position than the industry average ";
		length = 14; ds = 5;
	    }
	    else {
		phrase = "company's debt equity ratio shows a debt load less than half the industry average ";
		length = 14; ds = 10;
	    }

	}

	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSr is " + newDS);
	b.put("DS" + DSType.RISK + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	if (ds > 0)
	    result = RSTTree.GoalDo(phrase, DSType.RISK, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.RISK, b);

	return result;
    }//makeDETree(DataSet d)


}
