/**
 * PL_ExecAgent.java
 *
 *
 * Created: Sun Apr 18 22:34:49 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class PL_ExecAgent extends GenTask {
    public PL_ExecAgent() {
	
    } // PL_ExecAgent constructor
    
    /*
     * gets envelope from KQML message sent by parent's PL_acceptEnv.distributeEnv.
     */
   public ProvisionCell receiveEnvelope(LinkedListQ Plist, Agent Local)
   {
       ht = Local.userHash;
       
       ProvisionCell P1 =  null;
       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println(Local.getName() + " entering PL_ExecAgent.receiveEnvelope: " + K.getKQMLString());
       job = getMsgJob(K);

       Local.checkMsgTime(K, Local.dataFile1, job);

       //resultReplyWith = K.getValue("reply-with"); //see propagateResults
       localPut("resultReplyWith", job, K.getValue("reply-with"));
       //this may not be a name!
       String envelopeData = (String)K.getContentFieldValue("envelope");

       //if (envelopeData.equals("STOP")){
       //	   P1 = new ProvisionCell(Local.getName() + " bid rejected, done.", "STOP");
       //	   System.out.println(Local.getName() + " PL_ExecAgent.receiveEnvelope stopping.");
       //}
       if (envelopeData.equals("empty")){
	   System.out.println(Local.getName() + 
			      " PL_ExecAgent.receiveEnvelope propagating empty envelope.");
	   KQMLmsg K2 = new KQMLmsg();
	   K2.addFieldValuePair("sender", Local.getName() );
	   K2.addFieldValuePair("performative", "achieve");
	   K2.addFieldValuePair("receiver", Local.getName() );
	   K2.addFieldValuePair("ontology", "PL" );
	   K2.addFieldValuePair("content", ":task acceptEnv :in3 msg :env empty");
	   MsgUtilities.copyGenContent(K, K2, Local);

	   System.out.println(Local.getName() + " PL_ExecAgent.receiveEnvelope writing: " + K2);
       
	   P1 =  new ProvisionCell(K2.getKQMLString(), "OK");
       }
       else{
	   Envelope env = Envelope.readEnvFromString(envelopeData);

	   //= (String)K.getValue("reply-with");
       
	   System.out.println(Local.getName() + " PL_ExecAgent.receiveEnvelope incoming Envelope: " + env);
	   //ht.put(env.getName(), env);
	   localPut(env.getName(), job, env);

	   KQMLmsg K2 = new KQMLmsg();
	   K2.addFieldValuePair("sender", Local.getName() );
	   K2.addFieldValuePair("performative", "achieve");
	   K2.addFieldValuePair("receiver", Local.getName() );
	   K2.addFieldValuePair("ontology", "PL" );
	   K2.addFieldValuePair("content", ":task acceptEnv :in3 msg :env " + env.getName());
	   MsgUtilities.copyGenContent(K, K2, Local);

	   System.out.println(Local.getName() + " PL_ExecAgent.receiveEnvelope writing: " + K2);
       
	   P1 =  new ProvisionCell(K2.getKQMLString() + 
				   Util.addTimeout(Local.upperMsgTimeout(K.getContentFieldValue("endtime"))), "OK");
       }
       return P1;
   }///receiveEnvelope(LinkedListQ Plist, Agent Local)

   public ProvisionCell terminate(LinkedListQ Plist, Agent Local)
   {

      String message = new String(Util.getValue(Plist, "MESSAGE"));

      return new ProvisionCell("Bid process stopped, bid not accepted.","OK");
   }

 
} // PL_ExecAgent
