import java.io.*;
import java.net.*;
import java.util.*;

/**
 * Used by GenAgents when they have locally stored (cached) results from previous work.
 **/

public class PL_Execute extends GenTask
{
    
    String taskReplyWith;

   public PL_Execute()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_Execute Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

   public ProvisionCell receiveEnv1(LinkedListQ Plist, Agent Local)
   {
       System.out.println(Local.getName() + " inside PL_Execute.receiveEnv1");

       ht = Local.userHash;

       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       System.out.println(Local.getName() + " PL_Execute.receiveEnv1 receiving: " + K);
       
       job = getMsgJob(K);

       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);       

       String envelopeName = (String)K.getContentFieldValue("env1");
       Envelope env = (Envelope)localGet(envelopeName, job);

       taskReplyWith = (String)K.getValue("reply-with");
       
       System.out.println(Local.getName() + "PL_Execute.receiveEnv1 Envelope: " + env);

       return new ProvisionCell(env.getName(), "OK");  

   }

    public ProvisionCell execute(LinkedListQ Plist, Agent Local)
    {
	ProvisionCell P1 = null;
	String envName = new String(Util.getValue(Plist, "env3"));
	Envelope env = (Envelope)localGet(envName, job);
	System.out.println(Local.getName() + " entering execute: " + env);
	
	String result = Local.generate(env);

	KQMLmsg K = new KQMLmsg();
	K.addFieldValuePair("sender", Local.getName() );
	K.addFieldValuePair("performative", "tell");
	K.addFieldValuePair("in-reply-to", taskReplyWith);
	K.addFieldValuePair("receiver", Local.getName() );
	K.addFieldValuePair("ontology", "PL" );

	String outcome = "OK";
	String status = "DONE";
	Bid btree = null;
	double uMin = -27;
	if (result.equals("empty")){
	    status = "FAILED";
	    outcome = "FAIL";
	}

	else if ((Local.isNumeric()) || Local.hasNumericChildren())
	    {} //result is dataset
	else{
	    RSTTree t = RSTTree.readRSTTree(result);
	    if (Local.getUtilityFcn() != null)
		t.updateUtility(Local.getUtilityFcn());
	    btree = t.getBid();
	    double uTree = btree.utility.doubleValue(); //don't want to use bu to update
	    uMin = Double.parseDouble((String)env.get("utility_min"));
	    if (! (uTree >= uMin)){
		status = "FAILED";
		outcome = "FAIL";
	    }
	}

	K.addFieldValuePair("content", ":result " + result + " :status " + status);
	System.out.println(Local.getName() + " execute writing: " + K);

	Local.sendFailReport(job, "null17", 
			     " execute in " + Local.getName() + 
			     " status: " + status + " uMin:" + uMin + 
			     " bid:" + btree + " (updated?) ",
			     Long.toString(-1), Local);

	P1 = new ProvisionCell(K.getKQMLString(), outcome);
	return P1; 
    }
 
}
