import java.io.*;
import java.net.*;
import java.util.*;

/**
 *
 * This file is for processing the results from the children of the
 * IrbtRisk agent, CurrentRisk and IrbtEquity.
 *
 */

public class PL_ExecuteIR extends GenTask
{
    String taskReplyWith;
    static boolean DEBUG = true;
    static final String loc = "in PL_ExecuteIR ";
    static final String em = "ERROR in PL_ExecuteIR: ";
    static final String wm = "Warning in PL_ExecuteIR: ";

    KQMLmsg startMsg = null;

    static final boolean RANDOM = false; //set true for random generation
    String parentEnv = "unset"; //parent uses this to identify when result is returned

   public PL_ExecuteIR()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_ExecuteIR Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

   public ProvisionCell receiveEnv1(LinkedListQ Plist, Agent Local)
   {
       System.out.println(Local.getName() + " inside PL_ExecuteIR.receiveEnv1");

       ht = Local.userHash;

       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       startMsg = K;
       System.out.println(Local.getName() + " PL_ExecuteIR.receiveEnv1 receiving: " + K);
       
       job = getMsgJob(K);

       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);       

       parentEnv = K.getContentFieldValue("parentEnv");
       String envelopeName = (String)K.getContentFieldValue("env1");
       Envelope env = (Envelope)localGet(envelopeName, job);

       taskReplyWith = (String)K.getValue("reply-with");
       
       System.out.println(Local.getName() + "PL_ExecuteIR.receiveEnv1 Envelope: " + env);

       return new ProvisionCell(env.getName(), "OK");  

   }

   public ProvisionCell execute(LinkedListQ Plist, Agent Local)
    {
       try{
	   	   Thread.sleep(Local.getSimulatedDelay());
       }
       catch(Exception e){
	   System.out.println("Delay problem in " + Local.getName() + ": " + e);
       }

	ProvisionCell P1 = null;
	String envName = new String(Util.getValue(Plist, "env3"));
	Envelope env = (Envelope)localGet(envName, job);
	System.out.println(Local.getName() + loc + " entering execute: " + env);
	System.out.println(Local.getName() + loc + " bids made: " + getBidsMade());
	
	double price, riskEstimate;

	Bid b = (Bid)env.getBid().clone();
	price = Double.parseDouble((String)b.get("cost_exp"));
	String symbol = b.getSymbol();
	String industry = null;
	if (DEBUG && symbol == null) System.out.println(wm + " symbol is null for bid " + b);

	if (RANDOM){ //range is zero to 2
	    riskEstimate = (20 * Math.random()) - 10;
	}
	else {
	    if (DEBUG) System.out.println(loc + " symbol is " + symbol);
	    Object temp = NumericAgent.get(ht, symbol, "industry");
	    if (temp != null){
		industry = (String)temp;
		temp = NumericAgent.get(ht, (String)temp, "ir");
		riskEstimate = Double.parseDouble((String)temp);
		if (DEBUG) System.out.println(loc + " industryRisk for " + 
					      symbol + " is " + riskEstimate);
	    }
	    else riskEstimate = (20 * Math.random()) - 10;
	}

	//if (price >= 3){
	//    if (DEBUG) System.out.println(loc + " symbol is " + symbol);
	//    String industry = NumericAgent.get(ht, symbol, "industry");
	//    industryRisk = Double.parseDouble(NumericAgent.get(ht, industry, "ir"));
	//    if (DEBUG) System.out.println(loc + " industryRisk for " + 
	//				  industry + " is " + industryRisk);
	//}

	DataSet d = new DataSet(Local.getName());
	d.put("symbol", symbol);
	d.put("bid", b);
	d.put("industryRisk", Double.toString(riskEstimate));
	if (industry != null)
	    d.put("industry", industry);
	
	KQMLmsg K = new KQMLmsg();
	K.addFieldValuePair("sender", Local.getName() );
	K.addFieldValuePair("performative", "tell");
	K.addFieldValuePair("in-reply-to", taskReplyWith);
	K.addFieldValuePair("receiver", Local.getName() );
	K.addFieldValuePair("ontology", "PL" );
	K.addFieldValuePair("content", ":result " + d.toString()); // + Local.generate(env)
	//MsgUtilities.addContentFieldValuePair(K, "parentEnv", parentEnv);

	MsgUtilities.copyGenContent(startMsg, K, Local);

	System.out.println(Local.getName() + " execute writing: " + K);

	if(true){
	    P1 = new ProvisionCell(K.getKQMLString(),"OK");
	}

	else if(true) {
	    return new ProvisionCell(Local.getName() + ".execute","FAIL");
	}
      return P1; 
  }
   
    ///*
    // * calculate DS from current ratio
    // */
    //public static double calcDSfromCR(double cr){
    //	double zeroVal = cr - 1.5;
    //	if (zeroVal >= 0)
    //	    return Math.pow(zeroVal, 2) + 2 * zeroVal;
    //	else
    //	    return  zeroVal - Math.pow(zeroVal, 2) - 1.5;
    //}
 
    //public static void main(String[] args){}

}//PL_ExecuteIR
