import java.io.*;
import java.net.*;
import java.util.*;

/**
 * see PL_RetirementAlloc.java and PL_Goal.java
 * see execute-ra.lsp
 *
**/

public class PL_ExecuteRA extends GenTask
{
    
    String taskReplyWith;
    static boolean DEBUG = true;
    static final String loc = "in PL_ExecuteRA ";
    static final String em = "ERROR in PL_ExecuteRA: ";
    static final String wm = "Warning in PL_ExecuteRA: ";
    KQMLmsg startMsg = null;


    static final boolean RANDOM = false; //set true for random generation
    String parentEnv = "unset"; //parent uses this to identify when result is returned

   public PL_ExecuteRA()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_ExecuteRA Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

   public ProvisionCell receiveEnv1(LinkedListQ Plist, Agent Local)
   {
       System.out.println(Local.getName() + " inside PL_ExecuteRA.receiveEnv1");

       ht = Local.userHash;

       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));	
       startMsg = K;

       System.out.println(Local.getName() + " PL_ExecuteRA.receiveEnv1 receiving: " + K);
      
       job = getMsgJob(K);

       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);
 
       parentEnv = K.getContentFieldValue("parentEnv");             
       String envelopeName = (String)K.getContentFieldValue("env1");
       Envelope env = (Envelope)localGet(envelopeName, job);

       taskReplyWith = (String)K.getValue("reply-with");
       
       System.out.println(Local.getName() + "PL_ExecuteRA.receiveEnv1 Envelope: " + env);

       return new ProvisionCell(env.getName(), "OK");  

   }

   public ProvisionCell execute(LinkedListQ Plist, Agent Local)
    {
       try{
	   	   Thread.sleep(Local.getSimulatedDelay());
       }
       catch(Exception e){
	   System.out.println("Delay problem in " + Local.getName() + ": " + e);
       }

	ProvisionCell P1 = null;
	String envName = new String(Util.getValue(Plist, "env3"));
	Envelope env = (Envelope)localGet(envName, job);
	System.out.println(Local.getName() + loc + " entering execute: " + env);
	System.out.println(Local.getName() + loc + " bids made: " + getBidsMade());
	
	int length = 0;
	double ds;
	String phrase = "PL_ExecuteRA default string ", investmentType;
	double bondAllocGoal, allocCurrent, allocWithPurchase, investmentTypeBalance, totalBalance,
	    yearsToRetire, annualConsumption, share_price, num_shares, newAllocStatus;

	String price = startMsg.getContentFieldValue("price");
	share_price = Double.parseDouble(price);
	String quantity = startMsg.getContentFieldValue("quantity");
	num_shares = Double.parseDouble(quantity);

	Bid b = (Bid)env.getBid().clone();
	//	price = Double.parseDouble((String)b.get("cost_exp"));
	String symbol = b.getSymbol();
	if (DEBUG && symbol == null) System.out.println(wm + " symbol is null for bid " + b);

	investmentType = (String)NumericAgent.get(ht, symbol, "type");
	investmentTypeBalance = Double.parseDouble(NumericAgent.get(ht, investmentType, "balance"));
	totalBalance = Double.parseDouble(NumericAgent.get(ht, "total", "balance"));
	//allocGoal = Double.parseDouble(NumericAgent.get(ht, investmentType, "goal_percent"));
	yearsToRetire = Double.parseDouble(NumericAgent.get(ht, "year", "to_retire"));
	annualConsumption = Double.parseDouble(NumericAgent.get(ht, "year", "consumption"));
	//allocCurrent = 100 * investmentTypeBalance / totalBalance;
	//allocWithPurchase  = 100 * (investmentTypeBalance + share_price * num_shares)/ totalBalance;
	bondAllocGoal = Double.parseDouble(NumericAgent.get(ht, "bonds", "goal_percent"));

	RSTTree resultTree = null;
	if (yearsToRetire < 6 && 
	    ((5 - yearsToRetire) * annualConsumption) > ((bondAllocGoal/100) * totalBalance)){

	    ds = -((5 - yearsToRetire) * annualConsumption) / ((bondAllocGoal/100) * totalBalance);
	    //reconsider allocation to higher bond percentage
	}

	else  {
	    ds = 0;
	}

	System.out.println("investmentType " + investmentType);
	System.out.println("investmentTypeBalance " + investmentTypeBalance);
	System.out.println("totalBalance " + totalBalance);
	System.out.println("yearsToRetire " + yearsToRetire);
	System.out.println("annualConsumption " + annualConsumption);
	
	System.out.println("ds " + ds);

	Strength newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSg is " + newDS);
	b.put("DS" + DSType.GOAL + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	b.put("topic", DSType.GOAL );

	String modifier = "ERROR-RA";
	

	if (ds < 0){//NEGATIVE

	    if (ds > -1.2) modifier = "a little";
	    else if (ds > -2) modifier = "somewhat";
	    else if (ds > -6) modifier = "quite";
	    else modifier = "very";

	    resultTree = RSTTree.GoalDoNot(" the equity percentage in your portfolio is " + modifier + " high comma given your proximity to retirement ", DSType.GOAL, b);
	
	    System.out.println("tree " ); 
	    resultTree.print();
	}
	//else resultTree = null

	DataSet d = new DataSet(Local.getName());
	d.put("symbol", symbol);
	d.put("bid", b);
	d.put("tree", (resultTree != null) ? resultTree.getString() : "empty");

	KQMLmsg K = new KQMLmsg();
	K.addFieldValuePair("sender", Local.getName() );
	K.addFieldValuePair("performative", "tell");
	K.addFieldValuePair("in-reply-to", taskReplyWith);
	K.addFieldValuePair("receiver", Local.getName() );
	K.addFieldValuePair("ontology", "PL" );
	K.addFieldValuePair("content", ":result " + d.toString()); // + Local.generate(env)
	MsgUtilities.copyGenContent(startMsg, K, Local);

	System.out.println(Local.getName() + " execute writing: " + K);

	if(true){
	    P1 = new ProvisionCell(K.getKQMLString(),"OK");
	}

	else if(true) {
	    return new ProvisionCell(Local.getName() + ".execute","FAIL");
	}
      return P1; 
  }
   

}//PL_ExecuteRA
