import java.io.*;
import java.net.*;
import java.util.*;

/**
 *
 *
 */

public class PL_ExecuteRE extends GenTask
{
    String taskReplyWith;
    static boolean DEBUG = true;
    static final String loc = "in PL_ExecuteRE ";
    static final String em = "ERROR in PL_ExecuteRE: ";
    static final String wm = "Warning in PL_ExecuteRE: ";
    static final boolean RANDOM = false; //set true for random generation

    KQMLmsg startMsg = null;

    String parentEnv = "unset"; //parent uses this to identify when result is returned

   public PL_ExecuteRE()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_ExecuteRE Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

   public ProvisionCell receiveEnv1(LinkedListQ Plist, Agent Local)
   {
       System.out.println(Local.getName() + " inside PL_ExecuteRE.receiveEnv1");

       ht = Local.userHash; //init for GenTask

       KQMLmsg K = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       startMsg = K;
       System.out.println(Local.getName() + " PL_ExecuteRE.receiveEnv1 receiving: " + K);
       
       job = getMsgJob(K);

       bidsMade = (Hashtable)localGet("bidsMade", job);
       bidsAccepted = (Hashtable)localGet("bidsAccepted", job);       

       parentEnv = K.getContentFieldValue("parentEnv");
       String envelopeName = K.getContentFieldValue("env1");
       Envelope env = (Envelope)localGet(envelopeName, job);

       taskReplyWith = (String)K.getValue("reply-with");
       
       System.out.println(Local.getName() + "PL_ExecuteRE.receiveEnv1 Envelope: " + env);

       return new ProvisionCell(env.getName(), "OK");  

   }

   public ProvisionCell execute(LinkedListQ Plist, Agent Local)
    {
       try{
	   Thread.sleep(Local.getSimulatedDelay());
       }
       catch(Exception e){
	   System.out.println("Delay problem in " + Local.getName() + ": " + e);
       }
	ProvisionCell P1 = null;
	String envName = new String(Util.getValue(Plist, "env3"));
	Envelope env = (Envelope)localGet(envName, job);
	System.out.println(Local.getName() + loc + " entering execute: " + env);
	System.out.println(Local.getName() + loc + " bids made: " + getBidsMade());
	
	double price, dsNum, returnOnEquity, industryReturnOnEquity = -1;
	String industry = null;
	Bid b = (Bid)env.getBid().clone();
	price = Double.parseDouble((String)b.get("cost_exp"));
	String symbol = b.getSymbol();
	if (DEBUG && symbol == null) System.out.println(wm + " symbol is null for bid " + b);

	if (RANDOM){ //range is 1 to 100
	    returnOnEquity = 100 * Math.random();
	}
	else {
	    if (DEBUG) System.out.println(loc + " symbol is " + symbol);

		// Informed Analysis Module Add-on
		String blindprofile, informedprofile, grabberprofile, accessthresh;
		StockInfoGrabber.AccessThreshold at;
		try
		{
			blindprofile = NumericAgent.get(ht, "re", "blindprofile");
			informedprofile = NumericAgent.get(ht, "re", "informedprofile");
			grabberprofile = NumericAgent.get(ht, "re", "grabberprofile");
			accessthresh = NumericAgent.get(ht, "re", "accessthresh");

			at = StockInfoGrabber.parseAccessThreshold(accessthresh);

			if (blindprofile==null || informedprofile==null || grabberprofile==null || accessthresh==null)
			{
				blindprofile = informedprofile = grabberprofile = "standard";
				at = StockInfoGrabber.AccessThreshold.Day;
			}
		}
		catch (Exception ex)
		{
			blindprofile = informedprofile = grabberprofile = "standard";
			at = StockInfoGrabber.AccessThreshold.Day;
		}
		InformedAnalyzer IA = new InformedAnalyzer(symbol,
			blindprofile,
			grabberprofile,
			informedprofile,
			at, false, 0, false, "re");
		IA.analyze();

		String newResult = symbol + " re " + IA.re;
		try { NumericAgent.readDataStringToHT(newResult, ht); }
		catch (Exception e) { System.out.println("WRONG"); }

		returnOnEquity = Double.parseDouble(NumericAgent.get(ht, symbol, "re"));
	    if (DEBUG) System.out.println(loc + " returnOnEquity for " + 
					  symbol + " is " + returnOnEquity);
	}

	DataSet d = new DataSet(Local.getName());
	d.put("symbol", symbol);
	d.put("bid", b);
	d.put("returnOnEquity", Double.toString(returnOnEquity));

	if (price >= 3){
	    if (DEBUG) System.out.println(loc + " symbol is " + symbol);
	    industry = NumericAgent.get(ht, symbol, "industry");
	    if (industry != null) {
		industryReturnOnEquity = Double.parseDouble(NumericAgent.get(ht, industry, "re"));
		if (DEBUG) System.out.println(loc + " industryReturnOnEquity for " + 
					      industry + " is " + industryReturnOnEquity);
		d.put("industry", industry);
		d.put("industryReturnOnEquity", Double.toString(industryReturnOnEquity));
	    }
	}
	
	KQMLmsg K = new KQMLmsg();
	K.addFieldValuePair("sender", Local.getName() );
	K.addFieldValuePair("performative", "tell");
	K.addFieldValuePair("in-reply-to", taskReplyWith);
	K.addFieldValuePair("receiver", Local.getName() );
	K.addFieldValuePair("ontology", "PL" );
	K.addFieldValuePair("content", ":result " + d.toString()); // + Local.generate(env)

	MsgUtilities.copyGenContent(startMsg, K, Local);

	System.out.println(Local.getName() + " execute writing: " + K);

	if(true){
	    P1 = new ProvisionCell(K.getKQMLString(),"OK");
	}

	else if(true) {
	    return new ProvisionCell(Local.getName() + ".execute","FAIL");
	}
      return P1; 
  }
   

}//PL_ExecuteRE
