import java.util.*;
import java.io.*;
/**
 * PL_ProcessAgent.java
 *
 *
 * Created: Sun Apr 18 22:34:15 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class PL_ProcessAgent extends GenTask {

    KQMLmsg startMsg;
    static String loc = " in PL_ProcessAgent ";
    static String em = " Error in PL_ProcessAgent ";
    static String wm = " Warning in PL_ProcessAgent ";
    static final boolean DEBUG1 = false;
    static final boolean DEBUG = true;
    //static final boolean ALTPROCESS = true;
    static final boolean PRINT_TO_FILE = true;

    public PL_ProcessAgent() {
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
	System.out.println("% PL_ProcessAgent() Zero constructor % <==============");
	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
	
    } // PL_ProcessAgent constructor
    
   public ProvisionCell processResults(LinkedListQ Plist, Agent Local)
   {
       ht = Local.userHash;
       String numericChildData = null, failedNumericChildData;
       Vector trees = null;
       Vector failedTrees = null;

       KQMLmsg K1 = new KQMLmsg(Util.getValue(Plist, "MESSAGE"));
       startMsg = new KQMLmsg(K1.toString());// save copy for reference
       String envName = K1.getContentFieldValue("parentEnv");

       job = getMsgJob(K1);
       Local.checkMsgTime(K1, Local.dataFile1, job);

       System.out.println(Local.getName() + " inside processResults: " + startMsg);

       KQMLmsg K;
       
       K = new KQMLmsg();
       K.addFieldValuePair("sender", Local.getName() );
       K.addFieldValuePair("performative", "achieve");
       K.addFieldValuePair("ontology", "PL" );
       K.addFieldValuePair("language", "DECAF");
       K.addFieldValuePair("receiver", Local.getParent() );
       MsgUtilities.copyGenContent(startMsg, K, Local);
       System.out.println("replacing parent env name " +envName + " with " + localGet(envName + "ParentEnvMap", job));
       
       MsgUtilities.replaceContent(K, "parentEnv", (String)localGet(envName + "ParentEnvMap", job)); //after copy is important

       if ( isOpportunity(startMsg) ){
	   MsgUtilities.addContentFieldValuePair(K, "opportunity", "yes");
	   MsgUtilities.addContentFieldValuePair(K, "replies", "useOppEnv");
	   MsgUtilities.addContentFieldValuePair(K, "task", "Count");
       }
       //don't want to use replyWith if opp, because it will not go to Count
       else if(localGet("resultReplyWith", job) != null)
	   K.addFieldValuePair("in-reply-to", (String)localGet("resultReplyWith", job)); //see ExecAgnt.receiveEnvelope
       else {//opp results won't have replyWith waiting
	   System.out.println(em + "no replyWith, but incoming msg not opportunity: " + startMsg);
       }

       BidUtility bu = Local.getUtilityFcn();
       RSTTree best = null;
	   
       if (startMsg.getContentFieldValue("results").equals("empty") &&
	   startMsg.getContentFieldValue("failedResults").equals("empty") &&
	   startMsg.getContentFieldValue("status").equals("Done") ) {
	   MsgUtilities.addContentFieldValuePair(K, "result", "empty" );
	   MsgUtilities.addContentFieldValuePair(K, "status", "Done" );
       }

       else if (! startMsg.getContentFieldValue("results").equals("empty") ||
		! startMsg.getContentFieldValue("failedResults").equals("empty") ){//redundant testing FIX

	   //Numeric agents simply send up their own DataSets
	   if (Local.isNumeric()){
	       numericChildData = startMsg.getContentFieldValue("results");//numerics don't use failedResult(?)
	       MsgUtilities.addContentFieldValuePair(K, "result", numericChildData );//from collectResults
	       if (isOpportunity(startMsg))
		   MsgUtilities.addContentFieldValuePair(K, "oppEnv", startMsg.getContentFieldValue("oppEnv"));

	       System.out.println(Local.getName() + " numeric ProcessAgent.processResults writing: " + K);
	       writeAgentMsgToFile("\n ht: "+ ht.size()+"\n" + numericChildData, startMsg.getContentFieldValue("endtime"), Local);
       
	       //System.out.println("external messages: " + (K1.getExternalMsgNum() - Local.kqmlMsgExtCount));
	       //MsgCount.incrMsgCount(K1.getExternalMsgNum() - Local.kqmlMsgExtCount);
	       //K1.resetExternalMsgNum();
	       //Local.kqmlMsgExtCount = 0;
       
	       ProvisionCell P1 =  new ProvisionCell(K.getKQMLString(),"OK");
	       return P1;
	   }
	   /*******************
	    ELSE SET TREES
	   ******************/
	   //Agents with numeric children get DataSets from kids and
	   //from their own local bids, all of which must be processed
	   //into trees. NOW HAPPENS IN Count.CountMsgs2
	   //else if (Local.hasNumericChildren()){
	   //    numericChildData = startMsg.getContentFieldValue("results");
	   //    failedNumericChildData = startMsg.getContentFieldValue("failedResults");
	   //
	   //    if (DEBUG) System.out.println("processResults Local.hasNumericChildren()");
	   //    if ( ! numericChildData.equals("empty")){
	   //	   trees = Local.processChildData(numericChildData);
	   //    }
	   //    if ( ! (failedNumericChildData.equals("empty") ||
	   //	       failedNumericChildData.equals("") )){
	   //	   failedTrees = Local.processChildData(failedNumericChildData);
	   //    }
	   //}
	   //Agents without numeric children get trees from kids and
	   //from their own local bids
	   else{
	       trees = RSTTree.readMultipleRSTTrees( startMsg.getContentFieldValue("results") );
	       failedTrees = RSTTree.readMultipleRSTTrees( startMsg.getContentFieldValue("failedResults") );
	   }
	   boolean usedFailed = false;
	   if (trees == null || trees.isEmpty()){
	       usedFailed = true;
	       trees = failedTrees;//RSTTree.readMultipleRSTTrees( startMsg.getContentFieldValue("failedResults") );	       
	       System.out.println("processResults trying failed results");
	   }

	   Envelope myEnv = null;
	   //determine envelope to use
	   if ( isOpportunity(startMsg)){
	       String envString = startMsg.getContentFieldValue("oppEnv");
	       myEnv = Envelope.readEnvFromString(envString);
	   }
	   else
	       myEnv = (Envelope)localGet("incomingEnvelope", job);
	    
	   /*******************
	    PROCESS TREES
	   ******************/
	   String status = null;

	   //used only by rc and integrator
	   BidUtility dsBU = bu.dsOnlyClone();

	   if (trees != null && (! trees.isEmpty())){
	       RSTTreePeakDSComp rc = new RSTTreePeakDSComp(dsBU);
	       //RSTTreeComp rc = new RSTTreeComp(dsBU);
	       Collections.sort(trees,rc);
	       if (DEBUG1) {
		   System.out.println(loc + ".processResults all trees after sort: ");
		   for(int i = 0; i < trees.size(); i++)
		       ((RSTTree)trees.get(i)).print();
	       }
	   
	       //Check utility so far - this updates bid utilities with bu instead of dsBU
	       if (treesSatisfyEnvelope(trees, bu, myEnv, Local))
		   status = "PASS";
	       else{//if there are failed results and we haven't used them yet	
		   
		   status = "FAIL_RAW";
		   if (! usedFailed && 
		       failedTrees != null){//! startMsg.getContentFieldValue("failedResults").equals("empty")){	
       
		       System.out.println("processResults checking failed results");
		       //Vector withFailedTrees = RSTTree.readMultipleRSTTrees( startMsg.getContentFieldValue("failedResults") );
		       failedTrees.addAll(trees);//put all in one vector
		       if (treesSatisfyEnvelope(failedTrees, bu, myEnv, Local)){	       
			   System.out.println("processResults using failed results to meet Umin");
			   trees = failedTrees;
			   usedFailed = true;
			   status = "PASS";
		       }
		       else if (utilityFromTrees(failedTrees, bu, Local) >
				utilityFromTrees(trees, bu, Local)){	       
			   System.out.println("processResults using failed results to increase U");
			   trees = failedTrees;
			   usedFailed = true;
		       }
		       else    
			   System.out.println("processResults not using failed results");
		   }
	       }
	       
	       //Collections.sort(trees,rc);
	       Integrator treeIntegrator = new Integrator(dsBU);
	       trees = treeIntegrator.addNewTrees(trees, rc, Local.getName());

	       //update using Local's Ufcn
	       //f (bu != null)
	       //   for(int i = 0; i < trees.size(); i++)
	       //       ((RSTTree)trees.get(i)).updateUtility(bu);
	       //lse
	       //   System.out.println(em + "2 in processResults Local.getU() was null");

	       Collections.sort(trees,rc);
	   
	       if (DEBUG) {
		   System.out.println(loc + ".processResults second all trees: ");
		   for(int i = 0; i < trees.size(); i++){
		       //System.out.println("before: " + ((RSTTree)trees.get(i)).getBid());
		       //((RSTTree)trees.get(i)).getBid().calcAndPrintUtility(dsBU);
		       ((RSTTree)trees.get(i)).print();
		   }
	       }
	   

	       if (DEBUG1) System.out.println(loc + "making joint trees next ");
	       best = treeIntegrator.joinAllTrees(trees, Local.getName());
	       
	       //check utility of processed trees here

	       //update using Local's Ufcn
	       if (bu != null)
		   for(int i = 0; i < trees.size(); i++){
		       ((RSTTree)trees.get(i)).updateUtility(bu);
		       //System.out.println("updating U in processAgent\n");
		       //((RSTTree)trees.get(i)).getBid().calcAndPrintUtility(bu);
		   }
	       else
		   System.out.println(em + "2 in processResults Local.getU() was null");

	       //now sort strictly by Utility
	       RSTTreeComp rc2 = new RSTTreeComp(bu);
	       Collections.sort(trees,rc2);

	       for(int i = 0; i < trees.size(); i++){
		   System.out.println("after"+i+": " + ((RSTTree)trees.get(i)).getBid());
		   ((RSTTree)trees.get(i)).getBid().calcAndPrintUtility(bu);
		   //((RSTTree)trees.get(i)).getBid().calcUtility(bu);
	       }
	       if ( ! trees.isEmpty())//(best == null) 	       ///assumes best tree is first
		   best = (RSTTree)trees.get(0);
	       else best = null;
	       best.updateUtility(bu);

	       Bid b = best.getBid();
	       b.setBidder(Local.getName());//singleton trees from below did not get integrated, so bidder was not getting reset.

	       //Envelope myEnv;
	       //if ( isOpportunity(startMsg) ){
	       //	   System.out.println(loc + " processing OPP envelope from " + 
	       //			      startMsg.getValue("sender"));
	       //	   myEnv = Envelope.readEnvFromString(startMsg.getContentFieldValue("env"));
	       //}
	       //else{
	       //	   myEnv = (Envelope)localGet("incomingEnvelope", job);
	       //}

	       double bidU = b.getUtility(bu).doubleValue();
	       if (myEnv != null){
		   double envU = Double.parseDouble((String)myEnv.get("utility_min"));
		   System.out.println(loc + " checking best bid U: " + bidU + 
				      " against env U: " + envU);
		   if (bidU >= envU) status = "PASS_PROC";
		   else status = "FAIL_PROC";
	       }
	       else{
		   System.out.println(loc + " Checking best bid U: " + bidU + 
				      ", envelope is null, assuming the best...");
		   status = "PASS_ASSUMED";
	       }

	       StringBuffer s = new StringBuffer(500);
	       //for(int i = 0; i < trees.size(); i++)
	       //   s.append(((RSTTree)trees.get(i)).getString());
	       if (best != null)
		   s.append(best.getString());
	   
	       MsgUtilities.addContentFieldValuePair(K, "result", s.toString() );
	       if (status == null)
		    status = startMsg.getContentFieldValue("status");
	       if (status.equals("")) status = "DONE";
	       MsgUtilities.addContentFieldValuePair(K, "status", status);

	       if (isOpportunity(startMsg))
		   MsgUtilities.addContentFieldValuePair(K, "oppEnv", myEnv.toString());
	   }
	   else{ //trees == null
	       MsgUtilities.addContentFieldValuePair(K, "result", "empty" );
	       MsgUtilities.addContentFieldValuePair(K, "status", "FAILED" );//from collectResults
	   }
       }
       else{ //if results == empty
	   MsgUtilities.addContentFieldValuePair(K, "result", "empty" );
	   MsgUtilities.addContentFieldValuePair(K, "status", "FAILED" );
       }
       //bookkeeping
       int resultCount;
       Object o = localGet("resultCount", job);
       if (o == null)
	   resultCount = 1;
       else resultCount = 1 + Integer.parseInt((String)o);
       MsgUtilities.addContentFieldValuePair(K, "resultCount", Integer.toString(resultCount));
       localPut("resultCount", job, Integer.toString(resultCount));

       ProvisionCell P1 =  new ProvisionCell(K.getKQMLString(),"OK");

       System.out.println(Local.getName() + " PL_ProcessAgent.processResults writing: " + K);
       if ( ! isOpportunity(startMsg) )
	   printResult(best, bu, Local);

       writeAgentMsgToFile("\n ht: "+ ht.size()+"\nsending up best:" + numericChildData, startMsg.getContentFieldValue("endtime"), Local);
       writeResultToFile(best, bu, Local);

       //NOT a failure, just a notification for reference
       Local.sendFailReport(job, startMsg.getContentFieldValue("symbol"), 
			    best != null ? best.getBid().toString() : "empty"
			    + "\nfinished ", 
			    Long.toString(Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))), 
			    Local);
       //System.out.println("external messages: " + (K1.getExternalMsgNum() - Local.kqmlMsgExtCount));
       //MsgCount.incrMsgCount(K1.getExternalMsgNum() - Local.kqmlMsgExtCount);
       //K1.resetExternalMsgNum();
       //Local.kqmlMsgExtCount = 0;
       
       return P1;
   }//processResults(LinkedListQ Plist, Agent Local)

    private void writeResultToFile(RSTTree best, BidUtility bu, Agent Local){

	if (PRINT_TO_FILE){
	       if (best != null){//write to file

		    writeAgentMsgToFile(best.getBid().calcAndPrintUtility(bu), startMsg.getContentFieldValue("endtime"), Local);


		   String symbol = startMsg.getContentFieldValue("symbol");
		   TreeGenerate tg = new TreeGenerate(symbol);
		   String bestString =  tg.generate(best);
		   try {
		       String outputFileName =  "output" + Local.getName();
		       System.out.println("writing tree to file " + outputFileName );
		       FileWriter fw = new FileWriter(outputFileName, true);
		       fw.write("\n______________________________________________________________\n______________________________________________________________\n");
		       fw.write("job: " + job);

		       double remaining = Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"));
		       double time = Local.total_time - (remaining/1000);
		       //double time = (Local.total_time - Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))/1000.0);
		       fw.write("   Writing with elapsed time: " + time + " remaining time: " + remaining);
		       fw.write("\nUfcn: " + bu + "\n");
		       fw.write(best.getBid().calcAndPrintUtility(bu));
		       fw.write("\n");
		       best.writeInforms(fw);
		       fw.write("\n");
		       fw.write("\n");
		       fw.write("______________\n");
		       best.writeLong(fw);
		       fw.write("______________________________________________________________\n");
		       fw.write(best.getString());

		       fw.flush();
		       fw.close();
		   } 
		   catch (Exception e) {
		       System.out.println(e);
		   }

	       }
	}
    }

    private void printResult(RSTTree best, BidUtility bu, Agent Local){

       System.out.println("Writing with job " + job + " time remaining: " +
			  (Local.getTimeRemaining(startMsg.getContentFieldValue("endtime"))/1000.0));
       System.out.println("UTILITY FUNCTION: " + bu);
       if (localGet("incomingEnvelope", job) != null){
	   Object e = ((Envelope)localGet("incomingEnvelope", job)).get("utility_min");
	   System.out.println("UTILITY_MIN: " + 
			      ( e == null ? " not yet established." : e.toString()));
       }
       else
	   System.out.println("UTILITY_MIN not yet established.");

       System.out.println("***************************best below******************************");
       if (best != null) best.print();
       System.out.println("**************************************************************");
       
       if (best != null){
	   String symbol = startMsg.getContentFieldValue("symbol");
	   TreeGenerate tg = new TreeGenerate(symbol);
	   String bestString =  tg.generate(best);
	   System.out.println(bestString);
	   best.getBid().calcAndPrintUtility(bu);
       }
       System.out.println("**************************************************************");

    }

    private boolean treesSatisfyEnvelope(Vector trees, BidUtility bu, Envelope myEnv, Agent Local){

	if (bu != null){
	    Bid b = RSTTree.getOneBidFromTrees(trees, Local);

	    if (DEBUG1) System.out.println("PL_ProcessAgent.treesSatisfyEnvelope env: " + myEnv );
		//}

	    if (myEnv == null){//result of opp beat env coming down
		System.out.println("PL_ProcessAgent.treesSatisfyEnvelope envelope is null, returning true");
		return true;
	    }

	    //Envelope myEnv = (Envelope)localGet("incomingEnvelope", job);
	    double bidU = b.getUtility(bu).doubleValue();
	    if (DEBUG1) System.out.println("PL_ProcessAgent.treesSatisfyEnvelope summary bid is: " + b );
	    
	    double envU = Double.parseDouble((String)myEnv.get("utility_min"));
	    if (DEBUG1) System.out.println(loc + " checking bid U: " + bidU + " against env U: " + envU);
	       
	    if (bidU >= envU) return true;
		   else return false;
	}
	else {
	    System.out.println("treesSatisfyEnvelope: no BidUtility");
	    return false;
	}
    }
    
    private double utilityFromTrees(Vector trees, BidUtility bu, Agent Local){

	if (bu != null){
	    Bid b = RSTTree.getOneBidFromTrees(trees, Local);
	    Envelope myEnv = (Envelope)localGet("incomingEnvelope", job);
	    double bidU = b.getUtility(bu).doubleValue();
	    return bidU;
	}
	else {
	    System.out.println("utilityFromTrees: no BidUtility");
	    return -1;
	}
    }

} // PL_ProcessAgent
