import java.io.*;
import java.net.*;
import java.util.*;

public class PL_Risk extends GenAgent
{
    
    static final boolean DEBUG = true;
    static final String loc = "in PL_Risk ";
    static final String em = "ERROR in PL_Risk ";

   public PL_Risk ()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_Risk Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

    /**
     *Initialize a Risk agent.
    **/
   public ProvisionCell start(LinkedListQ Plist, Agent Local)
    {
	super.start(Local, DSType.RISK);
       System.out.println("**********starting Risk agent: " + Local.getName() + " **************");

       Local.setLevel(2);
       Local.defaultString = "Risk output";
       Local.setMyTaskObject(this);
       //       Local.setHasNumericChildren();

       Local.setParent("Coord");
       //Local.addChild("DebtRisk");
       Local.addChild("DR");
       //Local.addChild("IRParent");
       Local.addChild("IRP");

       System.out.println("PL_Risk: children are: " + Local.children);
       Bid b;
       DataSet d;

////////////////////////////////////////////////////////////
       //b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=8, symbol=IBM, DSr_exp=[[1 1 1][0 0 0]], U=null, topic=r, bidder=Risk}");
       //d = new DataSet(Local.getName());
       //d.put("bid", b);
       //Local.addLocalBid(b, d.toString());
////////////////////////////////////////////////////////////
//       b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=URS, DSr_exp=[[1 1 1][0 0 0]], U=null, topic=r, bidder=Risk}");
//       d = new DataSet(Local.getName());
//       d.put("bid", b);
//       Local.addLocalBid(b, d.toString());
////////////////////////////////////////////////////////////
//       b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=DCX, DSr_exp=[[1 1 1][0 0 0]], U=null, topic=r, bidder=Risk}");
//       d = new DataSet(Local.getName());
//       d.put("bid", b);
//       Local.addLocalBid(b, d.toString());
//////////////////////////////////////////////////////////////
//       b = Bid.readBidFromString("{time_exp=1, cost_exp=0, RV=[[] 0], length_exp=10, symbol=XYZ, DSr_exp=[[1 1 1][0 0 0]], U=null, topic=r, bidder=Risk}");
//       d = new DataSet(Local.getName());
//       d.put("bid", b);
//       Local.addLocalBid(b, d.toString());

       System.out.println("local bids are: " + Local.getLocalBids());

	return new ProvisionCell("started Risk", "OK");
   }

    public RSTTree makeTreeFromData(DataSet d){
	if (DEBUG) System.out.println(loc + "makeTreeFromData d: " + d); 
	
	Bid b = (Bid)d.get("bid");
	RSTTree result = null;
	if (d.getSource().equals("Risk"))
	    result = makeLocalTree(d);
	//	else if (d.getSource().equals("IR"))
	//	    result = makeIRTree(d);
	else{
	    result = RSTTree.GoalDo("Default phrase " + b.getSymbol() + " in DR", DSType.RISK, b);
	}
	TreeGenerate tg = new TreeGenerate( b.getSymbol() );
	result.updateBid("length_exp", Integer.toString(tg.wordCount( tg.generate(result)) ));

	if (DEBUG) System.out.println(loc + "makeTreeFromData tree: ");
	if (DEBUG) result.print();
	return result;
    }//makeTreeFromData(DataSet d)


    private RSTTree makeLocalTree(DataSet d){

	double ds = 0, length = 0;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");

	Strength dsr = (Strength)b.get("DSr_exp");

	if (dsr.direction() > 0)
	    ds = dsr.posCurr();
	else if (dsr.direction() < 0)
	    ds = - dsr.negCurr();
	else
	    System.out.println(em + "DataSet has mixed or no Strength: " + d);

	if (ds < -2){ 
	    phrase = "company has historically maintained a high risk profile "; 
	    length = 8; ds = -1;
	}
	//else if (ds < -1){ 
	//    phrase = "company has a history of high debt "; 
	//    length = 7; ds = -1;
	//}
	else if (ds < 0){ 
	    phrase = "company has historically maintained an aggressive risk profile "; 
	    length = 7; ds = -1;
	}
	else if (ds < 2){ 
	    phrase = "company has historically maintained a moderate risk profile ";
	    length = 8;
	}
	else {//if (ds > 1){ 
	    phrase = "company has historically maintained a conservative risk profile ";
	    length = 8;
	}
	
	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSr is " + newDS);
	b.put("DS" + DSType.RISK + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	if (ds > 0)
	    result = RSTTree.GoalDo(phrase, DSType.RISK, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.RISK, b);
	return result;
    }

}
