import java.io.*;
import java.net.*;
import java.util.*;

public class PL_Start
{

    boolean CHANGE_U = false;

   public PL_Start()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_Start Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
   }

    static int topAgentEndTime = 95;
    int myJob = 0;
    static Agent myAgent;

    String[] uStrings = {
    
//original testing bu 
"{DSr_coeff=4, DSv_coeff=4, DSg_coeff=2, DSg_target=5, DSr_target=5, DSv_target=5, cost_coeff=3, cost_target=40, RV_coeff=0.1, length_coeff=1, length_target=150, length_fcn=startPlateauNormal, DSr_fcn=linear, DSv_fcn=linear, DSg_fcn=linear, cost_fcn=startPlateauNormal}"
};
    

    /**
     *Initialize a Start agent.
    **/
   public ProvisionCell start(LinkedListQ Plist, Agent Local)
   {
       myAgent = Local;
       Local.setTotalTime(topAgentEndTime);

       System.out.println("**********starting Start agent: " + Local.getName() + " **************");

       Local.setLevel(1);
       Local.addChild("Risk"); 
       Local.addChild("Value");
       Local.addChild("Goal");

       System.out.println("original tasks: " + Local.taskTemplates);
       Local.addTaskTemplate("acceptRFB.lsp");
       Local.addTaskTemplate("acceptEnv.lsp");
       Local.addTaskTemplate("coord.lsp");
       Local.addTaskTemplate("update.lsp");
       System.out.println("all tasks: " + Local.taskTemplates);
       
       /** Agent roll call **/
       KQMLmsg K2;
       K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName());
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("receiver", Local.getName());
       K2.addFieldValuePair("reply-with", "updateStart");
       K2.addFieldValuePair("language", "DECAF");
       K2.addFieldValuePair("ontology", "PL");	
       K2.addFieldValuePair("content", ":task Update :updateMsg start " + 
			    " :endtime " + Local.getEndTime(topAgentEndTime) +
			    ":job " + 0);
       MsgUtilities.addContentFieldValuePair(K2, "updateNum", "1");

       System.out.println("first roll call: " + K2.toString());

       try{                
       	   Local.sendNow(K2);
       	   Thread.sleep(5 * 1000);
       }
       catch(Exception e){
       	   System.out.println("roll call in PL_Start: " + e);
       }

       K2 = new KQMLmsg();
       K2.addFieldValuePair("sender", Local.getName());
       K2.addFieldValuePair("performative", "achieve");
       K2.addFieldValuePair("receiver", Local.getName()); //update goes to whole hierarchy
       K2.addFieldValuePair("reply-with", "updateStart");
       K2.addFieldValuePair("language", "DECAF");
       K2.addFieldValuePair("ontology", "PL");	
	   
       K2.addFieldValuePair("content", ":task Update :updateMsg start " + 
			    ":update numHigh=5 numAlt=3" +
			    " data=" +  //"stockDataUchange" +
			    "stockDataUM05" +
			    " delay=0" + 
			    " :endtime " + Local.getEndTime(topAgentEndTime) +
			    " :job " + myJob);
       MsgUtilities.addContentFieldValuePair(K2, "updateNum", "2");
       System.out.println(K2.toString());
       Local.sendNow(K2);

         //Set file names for starting local bids (see localBids in AgentDef)
       String[] agents = {"CR", "PE", "IR", "DE", "RE"};
       for (int k = 0; k < agents.length; k++){
 	   K2 = new KQMLmsg();
 	   K2.addFieldValuePair("sender", Local.getName());
 	   K2.addFieldValuePair("performative", "achieve");
 	   K2.addFieldValuePair("receiver", agents[k]);
 	   K2.addFieldValuePair("reply-with", "updateStart");
 	   K2.addFieldValuePair("language", "DECAF");
 	   K2.addFieldValuePair("ontology", "PL");	
 
 	   K2.addFieldValuePair("content", ":task Update :updateMsg start " + 
 				":update" + 
				// .new files have longer text estimates
 				" localBids=" + agents[k] + "data" + //".new" +
 				//num fails increases with j, starting w no fails
 				//( ( k < j && agentsToFail.contains(agents[k])) ? "WFail" : "") +
 				//(agentsToFail.contains(agents[k]) ? "Long" : "") +
 				" numHigh=11 numAlt=3 data=stockDataUM05 " +  
 				" :endtime " + Local.getEndTime(topAgentEndTime) +
 				" :job " + myJob);
 	   MsgUtilities.addContentFieldValuePair(K2, "updateNum", "3");
 	   System.out.println(K2.toString());
 	   Local.sendNow(K2);
       }


              
       BidUtility bu = null;
       
       //String[] symbols = {"IBM", "URS", "DCX", "XYZ"};
       String[] symbols = {"IBM"};
       String symbol;

       symbol = symbols[0];
	
       try{
	   Thread.sleep(2 * 1000);
       }
       catch(Exception e){
	   System.out.println("in PL_Start sleep1: " + e);
       }
	
       /**************************************************/
       /* JOB MESSAGE */
       /**************************************************/


       //Schedule a job for the event-dispatching thread:
       //creating and showing this application's GUI.
       javax.swing.SwingUtilities.invokeLater(new Runnable() {
	       public void run() {
		   createAndShowGUI();
	       }
	   });
       

		   try{
		       Thread.sleep((topAgentEndTime + 15) * 1000);
		   }
		   catch(Exception e){
		       System.out.println("in PL_Start: " + e);
		   }

		   //System.out.println("PL_Start: finished test " + i);
		   //}
	   
		   //System.out.println("in PL_Start: test loop finished");
	       //	   }///j
	       //       }//h

       //ProvisionCell P1 =  new ProvisionCell(K.getKQMLString(),"OK");
       ProvisionCell P1 =  new ProvisionCell("empty","OK");
       return P1;
   }


    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {

	try {
	    Frame1 frame = new Frame1(myAgent, topAgentEndTime);
	    frame.initComponents();
	    frame.setVisible(true);
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }//createAndShowGUI()


}//public class PL_Start

