import java.io.*;
import java.net.*;
import java.util.*;

public class PL_Value extends GenAgent
{
    static final boolean DEBUG = false;
    static final String loc = "in PL_Value ";
    static final String em = "ERROR in PL_Value ";

    public final boolean TIMING_RUN = false;
    
   public PL_Value ()
   {
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
      System.out.println("% PL_Value Zero constructor % <==============");
      System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");

   }

    /**
     *Initialize a Value agent.
    **/
   public ProvisionCell start(LinkedListQ Plist, Agent Local)
    {
	super.start(Local, DSType.VALUE);
	System.out.println("**********starting Value agent: " + Local.getName() + " **************");

	Local.setLevel(2);
	Local.setMyTaskObject(this);
	Local.setHasNumericChildren();

	Local.setParent("Coord");
	Local.addChild("PE");
	Local.addChild("RE");
	Local.defaultString = "Value output";

       System.out.println("PL_Value: children are: " + Local.children);
       Bid b;
       DataSet d;

////////////////////////////////////////////////////////////
	//b = Bid.readBidFromString("{cost_exp=0, RV=[[] 0], length_exp=8, symbol=IBM, DSv_exp=[[.1 .1 1][0 0 0]], U=null, topic=v, bidder=Value}");
	//d = new DataSet(Local.getName());
	//d.put("bid", b);
	//Local.addLocalBid(b, d.toString());
////////////////////////////////////////////////////////////
//	b = Bid.readBidFromString("{cost_exp=0, RV=[[] 0], length_exp=8, symbol=URS, DSv_exp=[[.2 .2 1][0 0 0]], U=null, topic=v, bidder=Value}");
//	d = new DataSet(Local.getName());
//	d.put("bid", b);
//	Local.addLocalBid(b, d.toString());
/////////////////////////////////////////////////////////////
//	b = Bid.readBidFromString("{cost_exp=0, RV=[[] 0], length_exp=8, symbol=DCX, DSv_exp=[[0 0 0][.1 .1 1]], U=null, topic=v, bidder=Value}");
//	d = new DataSet(Local.getName());
//	d.put("bid", b);
//	Local.addLocalBid(b, d.toString());
/////////////////////////////////////////////////////////////
//	b = Bid.readBidFromString("{cost_exp=0, RV=[[] 0], length_exp=9, symbol=XYZ, DSv_exp=[[.1 .1 1][0 0 0]], U=null, topic=v, bidder=Value}");
//	d = new DataSet(Local.getName());
//	d.put("bid", b);
//	Local.addLocalBid(b, d.toString());
/////////////////////////////////////////////////////////////
//      System.out.println("local bids are: " + Local.getLocalBids());

	return new ProvisionCell("started Value", "OK");
   }

    public RSTTree makeTreeFromData(DataSet d){
	if (DEBUG) System.out.println(loc + "makeTreeFromData d: " + d); 
	
	Bid b = (Bid)d.get("bid");
	RSTTree result = null;
	if (d.getSource().equals("PE"))
	    result = makePETree(d);
	else if (d.getSource().equals("RE"))
	    result = makeRETree(d);
	else if (d.getSource().equals("Value"))
	    result = makeLocalTree(d);
	else{
	    //	    Strength dsv = (Strength)b.get("DSv_exp");
	    //	    double ds = dsv.posCurr() > 0 ? dsv.posCurr() : dsv.negCurr();
	    result = RSTTree.GoalDo("Default phrase " + b.getSymbol() + 
				    " in Value", DSType.VALUE, b);
	}

	if (TIMING_RUN &&
	    5 <= Double.parseDouble((String)b.get("cost_exp"))){
	    //Strength zeroDS = new Strength( 0 );
	    //result.updateBid("DS" + DSType.RISK + "_exp", zeroDS);
	    result.zeroDS(DSType.VALUE);
	}

	TreeGenerate tg = new TreeGenerate( b.getSymbol() );
	result.updateBid("length_exp", Integer.toString(tg.wordCount( tg.generate(result)) ));

	if (DEBUG) System.out.println(loc + "makeTreeFromData tree: ");
	if (DEBUG) result.print();
	return result;
    }// makeTreeFromData(DataSet d)

    private RSTTree makeLocalTree(DataSet d){

	double ds = 0, length = 0;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");

	Strength dsv = (Strength)b.get("DSv_exp");
	if (dsv.direction() > 0)
	    ds = dsv.posCurr();
	else if (dsv.direction() < 0)
	    ds = dsv.negCurr();
	else
	    System.out.println(em + "DataSet has mixed or no Strength: " + d);

	if (ds < -2){ 
	    phrase = "company has a history of low value metrics "; 
	    length = 8; ds = -1;
	}
	else if (ds < 2){ 
	    phrase = "company has a history of moderate value metrics ";
	    length = 8; ds = 1;
	}
	else {//if (ds > 1){ 
	    phrase = "company has a history of attractive value metrics ";
	    length = 8; ds = 2;
	}
	
	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSv is " + newDS);
	b.put("DS" + DSType.VALUE + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	b.put("topic", DSType.VALUE );
	if (ds > 0)
	    result = RSTTree.GoalDo(phrase, DSType.VALUE, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.VALUE, b);
	return result;
    }//makeLocalTree(DataSet d)


    private RSTTree makePETree(DataSet d){

	double ds, diff, length = 0, price, priceEarningsRatio, industryPriceEarningsRatio = -1;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");
	price = Double.parseDouble((String)b.get("cost_exp"));

	priceEarningsRatio = Double.parseDouble((String)d.get("priceEarningsRatio"));

	String industry = (String)d.get("industry");

	if (price < 3){
	    
	    if (priceEarningsRatio > 40){ 
		//phrase = "company has a very poor price earnings ratio comma suggesting it may be over-valued "; 
		phrase = "company has a very high price relative to its earnings "; 
		ds = -10; length = 13;
	    }
	    else if (priceEarningsRatio > 30){ 
		//phrase = "company has a poor price earnings ratio "; 
		phrase = "company has a very high price relative to its earnings "; 
		ds = -6; length = 7;
	    }
	    else if (priceEarningsRatio > 20){ 
		phrase = "company has a high price relative to its earnings "; 
		ds = -1; length = 9;
	    }
	    else if (priceEarningsRatio > 17){ 
		phrase = "company has an acceptable price earnings ratio";
		ds = 2; length = 7;
	    }
	    else if (priceEarningsRatio > 14){ 
		phrase = "company has a good price earnings ratio comma indicating it may be a good value ";
		ds = 3; length = 14;
	    }
	    else if (priceEarningsRatio > 10){ 
		phrase = "company has an excellent price earnings ratio comma suggesting it may be under-valued";
		ds = 5; length = 13;
	    }
	    else if (priceEarningsRatio > 8){ 
		phrase = "company has a very low stock price relative to its reported earnings";
		ds = 8; length = 12;
	    }
	    else {
		phrase = "company has a price earnings ratio so low that while it appears to indicate good value comma it bears further scrutiny ";
		ds = 10; length = 20;
	    }
	    ds = ds/2; //REDUCE DS BECAUSE OF COST i.e. info is absolute, less valuable
	}
	else { //if (price >= 3){
	    industryPriceEarningsRatio = Double.parseDouble((String)d.get("industryPriceEarningsRatio"));
	    diff = industryPriceEarningsRatio - priceEarningsRatio;
	    ds = 10 * diff/industryPriceEarningsRatio;
	    phrase = "other phrase";

	    
	    if (ds < -10){ 
		phrase = "company has a very poor price earnings ratio relative to the " 
		    + industry + " industry "; 
		length = 13;
	    }
	    else if (ds < -5){ 
		phrase = "company has a poor price earnings ratio relative to the " 
		    + industry + " industry ";
		length = 12;
	    }
	    else if (ds < -2){ 
		phrase = "company has a somewhat unattractive price earnings ratio relative to the " 
		    + industry + " industry ";
		length = 13;
	    }
	    else if (ds < -1){ 
		phrase = "company has a slightly unattractive price earnings ratio relative to the " 
		    + industry + " industry ";
		length = 13;
	    }
	    else if (ds < 1){ 
		phrase = "company has a price earnings ratio similar to the " 
		    + industry + " industry average ";
		length = 12; ds = 1;
	    }
	    else if (ds < 3){ 
		phrase = "company has a good price earnings ratio relative to the " 
		    + industry + " industry average ";
		length = 12;
	    }
	    else if (ds < 10){ 
		phrase = "company has a very good price earnings ratio relative to the " 
		    + industry + " industry average ";
		length = 12;
	    }
	    else {
		phrase = "company has a price earnings ratio so low relative to the industry that while it appears to indicate good value comma it bears further scrutiny ";
		length = 20;
	    }
	    
	}

	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + " new DSv is " + newDS);
	b.put("DS" + DSType.VALUE + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	if (ds >= 0)
	    result = RSTTree.GoalDo(phrase, DSType.VALUE, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.VALUE, b);
	return result;
    }//makePETree(DataSet d)

    private RSTTree makeRETree(DataSet d){

	double ds, length = 0, price, returnOnEquity, industryReturnOnEquity = -1;
	int index = 0;
	String phrase;
	RSTTree result;
	Strength newDS = null;;
	Bid b = (Bid)d.get("bid");
	price = Double.parseDouble((String)b.get("cost_exp"));

	returnOnEquity = Double.parseDouble((String)d.get("returnOnEquity"));

	String industry = (String)d.get("industry");

	if (price < 3){
	    
	    if (returnOnEquity < -10){ 
		phrase = "company has a large negative return on equity, indicating substantial losses  "; 
		ds = -10; length = 13;
	    }
	    if (returnOnEquity < 0){ 
		phrase = "company has a negative return on equity, indicating losses  "; 
		ds = -10; length = 13;
	    }
	    else if (returnOnEquity < 5){ 
		phrase = "company has a poor return on equity "; 
		ds = -6; length = 7;
	    }
	    else if (returnOnEquity < 8){ 
		phrase = "company has a mediocre return on equity "; 
		ds = -1; length = 9;
	    }
	    else if (returnOnEquity < 12){ 
		phrase = "company has an acceptable return on equity";
		ds = 2; length = 7;
	    }
	    else if (returnOnEquity < 15){ 
		phrase = "company has a reasonably good return on equity  ";
		ds = 3; length = 14;
	    }
	    else if (returnOnEquity < 20){ 
		phrase = "company has a good return on equity";
		ds = 5; length = 13;
	    }
	    else if (returnOnEquity < 25){ 
		phrase = "company has an excellent return on equity ";
		ds = 5; length = 13;
	    }
	    else {//if (returnOnEquity > 25){ 
		phrase = "company has an superb return on equity";
		ds = 5; length = 13;
	    }
	    
	    ds = ds/2; //REDUCE DS BECAUSE info is absolute, less valuable (low cost)
	}
	else { //if (price >= 3) give relative to industry
	    industryReturnOnEquity = Double.parseDouble((String)d.get("industryReturnOnEquity"));
	    //ratio = returnOnEquity/industryReturnOnEquity;
	    index = indexCalc(returnOnEquity, industryReturnOnEquity);
	    
	    phrase = "high cost default RE string";

	    //-5 to 5
	    String[] negPart2 = 
		{" an extremely poor"," a very poor", " a poor"," a poor", " an unfavorable"};
	    String[] posPart4 = 
		{"slightly better than","better than","significantly better than",
		 "superior to","vastly superior to",};
	    String part1 = "company has ";
	    String part3 = " return on equity " ;
	    String part5 = " relative to ";
	    String part6 = " the " + industry + " industry ";
	    String negative = returnOnEquity < 0 ? " negative " : "";
	    if (index < 0){ 
		phrase = part1 + negPart2[5 + index] + negative + part3 + part5 + part6;
		ds = 2 * index;
	    }
	    else if (index == 0){ 
		phrase = part1 +  " a " + negative + part3 + " similar to " + part6 + " average ";
		ds = 1;
	    }
	    else {
		phrase = part1 + " a " +  negative + part3 + posPart4[index - 1] + part6 + " average ";
		ds = 2 * index;
	    }
	    length = TreeGenerate.wordCount(phrase);
	}

	newDS = new Strength( ds );
	if (DEBUG) System.out.println(loc + ".RE new DSv is " + newDS);
	b.put("DS" + DSType.VALUE + "_exp", newDS);
	b.put("length_exp", Double.toString(length));
	if (ds >= 0)
	    result = RSTTree.GoalDo(phrase, DSType.VALUE, b);
	else
	    result = RSTTree.GoalDoNot(phrase, DSType.VALUE, b);
	return result;
    }//makeRETree(DataSet d)


    public static int indexCalc(double ROE, double industryROE){
	int index;

	double ratio = ROE/industryROE;
	if (ROE < 0 && industryROE < 0){
	    ratio = industryROE/ROE;
	    index = (int)Math.ceil(Math.pow( 10 * (ratio - 1), .7 ));
	}
	else if (ROE < 0){
	    index = -3 + (int)Math.ceil(10 * ratio);
	}
	else if (ratio > 1.01)
	    index = (int)Math.ceil(Math.pow( 10 * (ratio - 1), .7 ));
	else if (ratio > .95)
	    index = 0;
	else  if (ratio > 0){//change ratio
	    ratio = industryROE/ROE;
	    index =  - (int)Math.ceil(Math.log( 10 * (ratio - 1) ));
	}
	else {// if (ratio < 0){//change ratio
	    ratio = industryROE/ROE;
	    index =  - (int)Math.ceil(Math.log( 10 * (ratio - 1) ));
	}

	if (index < -5) index = -5;
	else if (index > 5) index = 5;

	if (DEBUG) System.out.println("indexCalc returning " + index);	
	return index;
    }

    public static void main(String[] args){
	double industryReturnOnEquity;
	double returnOnEquity;
	double    ratio = 0;
	int index;

	DataSet d = DataSet.readDataSetFromString( "{returnOnEquity=-2, bid={topic=v, length_exp=14, cost_exp=4, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[4 4 1][0 0 0]], RV=[[] 0], symbol=IBM, U=4.0584516296232485, bidder=RE}, symbol=IBM, source=RE, industryReturnOnEquity=-3, industry=tech}"); 

	PL_Value v = new PL_Value();
	RSTTree t = v.makeTreeFromData(d);
	t.print();
	//industryReturnOnEquity = -10;
	//returnOnEquity = -5;
	//ratio = returnOnEquity/industryReturnOnEquity;
	//index = indexCalc(returnOnEquity, industryReturnOnEquity);
	//System.out.println(returnOnEquity + " " + ratio + " " + index);



    }
}
