 
//import Plan.*;
import java.util.*;
/**
 * Predicate.java
 *
 *
 * Created: Wed Apr  7 16:03:15 1999
 *
 * @author Terry Harvey
 * @version
 */

public class Predicate  {

    static final int argNUM = 4;
    
    String name;
    static int lastID = 0;
    String id;
    Object[] args;
    static Object[] temp = new Object[argNUM];
//    Agent source;
    static boolean DEBUG = false;
    static boolean DEBUG2 = false;

    /* Error message string. */
    static String em = "Error in Predicate.java: ";
    static String wm = "Warning in Predicate.java: ";
    static String loc = "Predicate.java: ";


    public Predicate() {
	id = Integer.toString(++lastID);
	if (DEBUG) System.out.println("One empty Predicate: " + id);
	args = new Object[argNUM];
    }

    public Predicate(String n) {
	name = n;
	args = new Object[argNUM];
	id = Integer.toString(++lastID);
	if (DEBUG) System.out.println(loc + "One full Predicate" + this + "class: " + this.getClass() + ": " + id); 
    }
    public Predicate(String n, Object o1) {
	temp[0] = o1;
	for(int i = 1; i<argNUM; i++) temp[i] = null;
	name = n;
	args = new Object[argNUM];
	if (temp.length <= argNUM)
	    for (int i = 0; i< temp.length; i++)
		args[i] = temp[i];
	id = Integer.toString(++lastID);
	if (DEBUG) System.out.println(loc + "One full Predicate" + this + "class: " + this.getClass() + ": " + id); 
    }
    public Predicate(String n, Object o1, Object o2) {
	temp[0] = o1;
	temp[1] = o2;
	for(int i = 2; i<argNUM; i++) temp[i] = null;
	name = n;
	args = new Object[argNUM];
	if (temp.length <= argNUM)
	    for (int i = 0; i< temp.length; i++)
		args[i] = temp[i];
	id = Integer.toString(++lastID);
	if (DEBUG) System.out.println(loc + "One full Predicate" + this + "class: " + this.getClass() + ": " + id); 
    }
    public Predicate(String n, Object[] arguments) {
	name = n;
	args = new Object[argNUM];
	if (arguments.length <= argNUM)
	    for (int i = 0; i< arguments.length; i++)
		args[i] = arguments[i];
	id = Integer.toString(++lastID);
	if (DEBUG) System.out.println(loc + "One full Predicate" + this + "class: " + this.getClass() + ": " + id); 
    }
    
    public Object arg(int i){ return args[i];}

    public String getName(){ return name + id; }

    public String getNameWithoutID(){ return name; }

    public boolean isPlannable(){
	return false;
    }

    /**Remove duplicate predicates from a vector**/
    static public Vector removeDuplicates(Vector v1){
	Hashtable h = new Hashtable();
	Enumeration e1;
	Object o1;
	Vector v2 = new Vector();
	e1 = v1.elements();
	while (e1.hasMoreElements()){
	    o1 = e1.nextElement();
	    if (h.containsKey(o1))
		continue;
	    else {
		h.put(o1, o1);
		v2.addElement(o1);
	    }
	}
	return v2;
    }

    /**
     * Returns true if the arguments of predicate are unifiable with
     * this predicate.
     **/
    static public boolean isUnifiable(Predicate p1, Predicate p2){
      Hashtable h = new Hashtable();
      boolean result = isUnifiable(p1, p2, h);
      if (DEBUG) System.out.println("result" + result + " h: " + h);
      return result;
    }

    /** If an object o1 has a part String "?rest" then that ?rest
     * matches zero to n remaining parts in the other object. Since this
     * procedure returns as soon as a false is discovered, once a ?rest
     * is encountered true may be returned.
     *
     * If one object is a Predicate and the other is an RSTNode, then
     * they only get compared as Predicates, i.e. the children of the
     * RSTNode are not considered.
     **/
    static public boolean isUnifiable(Predicate p1, Predicate p2, Hashtable h){
	boolean 
	  nameMatch, 
	  argMatch = true;

	if (p1 instanceof RSTNode && p2 instanceof RSTNode){
	    if (DEBUG) System.out.println("inside Predicate isUnifiable, calling RSTNODE version");
	    return RSTNode.isUnifiable(((RSTNode)p1), ((RSTNode)p2), h);
	}
	if (DEBUG) System.out.println("isUnifiable: " + p1 + p2);
	nameMatch = subIsUnifiable(p1.name, p2.name, h);
	if (DEBUG) System.out.println("isUnifiable: nameMatch = " + nameMatch);
	if (! nameMatch) return false;

	int i;
	for(i = 0; i < argNUM; i++){

	    if (p2.args[i] == null){
		if (p2.args[i] == null) return true;
		else return false;
	    }
	    else if (p2.args[i] == null) return false;
	    else if (p1.args[i] instanceof String &&
		     ((String)p1.args[i]).equalsIgnoreCase("?rest"))
		return true; 
	    else if (p2.args[i] instanceof String &&
		     ((String)p2.args[i]).equalsIgnoreCase("?rest"))
		return true;
	    argMatch = subIsUnifiable(p1.args[i], p2.args[i], h);
	    if (DEBUG) System.out.println("    isUnifiable:  " 
					  + p1.args[i] + " " + p2.args[i] + " " + argMatch);
	    if (!argMatch) return false;
	}
	
	return true;
    }

    //Does not handle a case where o1 and o2 are both
    //variables. Doesn't need to. Predicate from below will be fully
    //instantiated.
    static  boolean subIsUnifiable(Object o1, 
				   Object o2,
				   Hashtable h){
	if (o1 == null && o2 == null) return true;
	else if (o1 == null || o2 == null) return false;

	if (o1 instanceof RSTTree && o2 instanceof RSTTree)
	    return RSTTree.isUnifiable((RSTTree)o1, (RSTTree)o2, h);

	if (o1 instanceof Predicate && o2 instanceof Predicate)
	    return isUnifiable((Predicate)o1, (Predicate)o2, h);

	else if (o1 instanceof String && isVarName((String) o1)){ //(o1 instanceof Variable)
	    if (h.containsKey(o1)){
		if (h.get(o1).equals(o2))
		    return true;
		else return false;
	    }
	    else{
		h.put(o1, o2);
		return true;
	    }
	}
	
	else if (o2 instanceof String && isVarName((String) o2)){
	    if (h.containsKey(o2)){
		if (h.get(o2).equals(o1))
		    return true;
		else return false;
	    }
	    else{
		h.put(o2, o1);
		return true;
	    }
	}
	else if (o1 instanceof String && o2 instanceof String)
	    return ((String)o1).equalsIgnoreCase((String)o2);
	else return o1.equals(o2);
    }

    ///possibly also in Variable.java
    public static boolean isVarName( String s ){
	if ( s.charAt(0) == '?' )
	    return true;
	else return false;
    }


    /**
     * Returns true if p2 is the same kind of Predicate and there
     * exist pairwise matches that *could* be unified (but doesn't
     * really unify).
     * If two constants, must match; if 2 vars, must be paired in same
     * direction; 
     * (a ?x ?z) (a ?x ?y) true
     * (a ?x ?y) (a ?x ?x) true
     * (a ?x ?x) (a ?x ?y) false
     * Cannot have a predicate sub for a variable.
     **/
    static public boolean isSameOrMoreGeneralThan(Predicate p1, Predicate p2){
	Hashtable h = new Hashtable(20);
	return isSameOrMoreGeneralThan(p1, p2, h);
    }
	
    static public boolean isSameOrMoreGeneralThan(Predicate p1,
						  Predicate p2,
						  Hashtable h){
	boolean 
	  nameMatch, 
	  argMatch = true;

	if (DEBUG) System.out.println("isSameOrMoreGeneralThan: " + p1 + p2);
	nameMatch = subSameOrMoreGeneralThan(p1.name, p2.name, h);
	if (DEBUG) System.out.println("isSameOrMoreGeneralThan: nameMatch = " + nameMatch);
	if (! nameMatch) return false;

	for (int i=0; i<argNUM; i++){
	argMatch = argMatch && subSameOrMoreGeneralThan(p1.args[i], p2.args[i], h);
	if (DEBUG) System.out.println("isSameOrMoreGeneralThan: argMatch = " 
			   + p1.args[i] + " " + p2.args[i] + " " + argMatch);
	}
	return argMatch;
    }

    static private boolean subSameOrMoreGeneralThan(Object o1, 
					    Object o2,
					    Hashtable h){
	if (o1 == null){
	    if (o2 == null) return true;
	    else return false;
	}
	else if (o2 == null) return false;
	else if (o1 instanceof Predicate && o2 instanceof Predicate)
	    return isSameOrMoreGeneralThan((Predicate)o1, (Predicate)o2, h);

	else if (o1 instanceof Variable){
	    if (h.containsKey(o1)){
		if (h.get(o1).equals(o2))
		    return true;
		else return false;
	    }
	    else{
		h.put(o1, o2);
		return true;
	    }
	}
    
	else {
	    if (o1.getClass() == o2.getClass())
		return o1.equals(o2);
	    else {
		if (DEBUG) System.out.println(loc + "reached here sisomgt " + o1.getClass()+" " + o1+" "  + o2.getClass()+" "  + o2);
		try{
		    if (o2 instanceof Double && o1 instanceof String)
			return ((Double)o2).equals(Double.valueOf((String)o1));
		    else if (o1 instanceof Double && o2 instanceof String)
			return ((Double)o1).equals(Double.valueOf((String)o2));
		    else
			return false;
		}
		catch (NumberFormatException nfe) {
		    return false;
		}
	    }
	}
    }
    

    /** 
     * Hash Predicates according to their String names.
     */
    public int hashCode(){
	return this.toString().hashCode();
    }


    public String toString() {
	StringBuffer s = new StringBuffer( "(" + getName() + " ");

	for (int i = 0; i< argNUM; i++)
	    if (arg(i) != null) s.append(arg(i).toString() + " ");
	s.append(")");
	return s.toString();
    }

    //Prints predicate with all string spaces replaced by underscores.
    //Does not include numeric name suffix.
    public String getString() {
	StringBuffer s = new StringBuffer( "[" + name + " "); //getName() + " ");

	for (int i = 0; i< argNUM; i++)
	    if (arg(i) != null){
		if (arg(i) instanceof Predicate)
		    s.append( ((Predicate)arg(i)).getString() + " ");
		else if (arg(i) instanceof String)
		    s.append( ((String)arg(i)).replace(' ', '_') + " ");
		else
		    s.append(arg(i).toString() + " ");
	    }
	s.append("]");
	return s.toString();
    }


    public static Predicate readPredicate(String s){
	StringTokenizer st = new StringTokenizer(s," \t\n\r\f[]", true );
	st.nextToken(); //get past [
	return readPredicate(st);
    } 
    /*
     * Reads the output from getString(). Assumes underscores and
     * supposed to be spaces, unless they are in name.
     */
    public static Predicate readPredicate(StringTokenizer st){
	Predicate p = null;
	Object[] arguments = new Object[argNUM];
	int i = 0;
	String name = st.nextToken();
	if (DEBUG2) System.out.println("name is " + name);
	String temp;
	do {
	    temp = st.nextToken();
	    	if (DEBUG2) System.out.println("next is " + temp + " " + i);
	    if (temp.equals("]")){
		for (; i<argNUM; i++)
		    arguments[i] = null;
		return new Predicate(name, arguments);
	    }
	    else if (temp.equals("[")){
		p = readPredicate(st);
		arguments[i++] = p;
	    }
	    else if (temp.equals("\t") || temp.equals("\n") || temp.equals("\r") || temp.equals("\f") || temp.equals(" "))
		continue;
	    else
		arguments[i++] = temp.replace('_', ' ');

	} while(st.hasMoreTokens());
	System.out.println("Error in Predicate.readPredicate!");
	return p;
    }//    public static Predicate readPredicate(StringTokenizer st)

    public Object clone(){
	Predicate p = readPredicate(this.getString());
	return p;
    }

    public boolean equals(Object obj){
         if ( obj == null || !(obj instanceof Predicate) ) return false;
         return equals((Predicate)obj);
    }

    public boolean equals(Predicate obj){
      if (DEBUG) System.out.println("pred.equals: " + this + " " + obj);
      boolean result = true;
      if ( ! name.equals(obj.name))
	  return false;
      for (int i =0; i<argNUM; i++){
	  if (args[i] == null){
	      if (obj.args[i] == null) return result;
	      else return false;
	  }
	  else if (obj.args[i] == null) return false;
	  result = result && args[i].equals(obj.args[i]);
      }
      return result;
    }

    public static void main(String[] args){

//	String c[] = {"i","j"};
//	Predicate p0 = new Predicate("xx", c);
//	Object a[] = {"i","?a","k","l"};
//	Predicate p1 = new Predicate("A", a);
//	System.out.println(p1);
//	Object b[] = {"i",p0,"?rest"};
//	Predicate p2 = new Predicate("a", b);
//	System.out.println(p2);
//	System.out.println("getString prints: " + p2.getString());
//	String temp = p2.getString();
//	System.out.println("from read: " + readPredicate(temp));

	Predicate p1 = readPredicate("[Inform [AND70 This_investment_has_quite_low_debt_risk IR_The_industry_as_a_whole_is_currently_considered_very_stable_stop ]]");
	System.out.println(p1.getString());
	Predicate p2 = readPredicate("[Inform ?prop2 ]");
	System.out.println(p2.getString());
	System.out.println(isUnifiable(p1,p2));
	System.out.println(isUnifiable(p1,p2));
	Predicate p3 = (Predicate)p2.clone();
	Predicate p4 = (Predicate)p1.clone();
	System.out.println(p3.getString());
	System.out.println(p4.getString());
	System.out.println("3-4" + isUnifiable(p3,p4));
    }

} // Predicate

