/**
 * RSTTreeComp.java
 *
 * For sorting RSTTrees by utility
 *
 * See also UtilComp.java
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */

import java.util.Comparator;

public class RSTTreeComp implements Comparator {

    BidUtility bu;

    public RSTTreeComp(BidUtility bidU) {
	bu = bidU;
    } // RSTTreeComp constructor
    
  
    /**
     *  For comparing RSTTrees based on their Utility. Orders high U first in a sort.
     */
    public int compare(Object object1, Object object2) {
	if (object1 instanceof RSTTree && object2 instanceof RSTTree){
//	    System.out.println("rc: " + object1 + " " + object2);
//	    ((RSTTree)object1).print();
//	    ((RSTTree)object2).print();
//	    System.out.println("comparing " + object1 + ", " + object2 + " = " + 
//			       (((RSTTree)object2).getStrength().absCurr() - ((RSTTree)object1).getStrength().absCurr()) );
//	    return (int)(((RSTTree)object2).getUtility(bu).doubleValue() - ((RSTTree)object1).getUtility(bu).doubleValue());

	    if (((RSTTree)object1).getBid().getUtility(bu).doubleValue() < ((RSTTree)object2).getBid().getUtility(bu).doubleValue())
		return  1;
	    else if (((RSTTree)object1).getBid().getUtility(bu).doubleValue() > ((RSTTree)object2).getBid().getUtility(bu).doubleValue())
		return  -1;
	    else return 0;
	}
	System.out.println("ERROR in RSTTreeComp.compare, should be two RSTTrees: " + object1 + " " + object2);
	return 0;
    }
    
//    public static void main(String[] args){
//	//	RSTTree x = RSTTree.GoalDoNot("too much long term debt", -3);
//	//RSTTree x = RSTTree.GoalDo("too much short term debt", 1);
//	//RSTTree y = RSTTree.GoalDoNot("too much long term debt", -2);
//
//	RSTTree x = RSTTree.GoalDoNot("too much long term debt", -3);
//	RSTTree y = RSTTree.GoalDo("too much short term debt", 2);
//	x.print();
//	y.print();
//	System.out.println("rules: ");
//	
//	Vector trees = new Vector();
//	trees.add(x);
//	trees.add(y);
//	trees.add(x);	
//	System.out.println("unsorted: " + trees);
//	
//       RSTTreeComp rc = new RSTTreeComp();
//       Collections.sort(trees,rc);
//
//       System.out.println("sorted: " + trees);
//    }    

} // RSTTreeComp
