/**
 * RSTTreePeakDSComp.java
 *
 * For sorting RSTTrees by peak DS only
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
import java.util.*;
import java.util.Comparator;

public class RSTTreePeakDSComp implements Comparator {

    BidUtility bu;

    public RSTTreePeakDSComp(BidUtility bidU) {
	bu = bidU;
    } // RSTTreePeakDSComp constructor
    
  
    /**
     *  For comparing RSTTrees based on their Utility. Orders high U first in a sort.
     */
    public int compare(Object object1, Object object2) {
	if (object1 instanceof RSTTree && object2 instanceof RSTTree){
//	    System.out.println("rc: " + object1 + " " + object2);
//	    ((RSTTree)object1).print();
//	    ((RSTTree)object2).print();
//	    System.out.println("comparing " + object1 + ", " + object2 + " = " + 
//			       (((RSTTree)object2).getStrength().absCurr() - ((RSTTree)object1).getStrength().absCurr()) );
//	    return (int)(((RSTTree)object2).getUtility(bu).doubleValue() - ((RSTTree)object1).getUtility(bu).doubleValue());

//FIX - calling fcns too many times

	    if (((RSTTree)object1).getBid().getHiCurrDSUtil(bu) < ((RSTTree)object2).getBid().getHiCurrDSUtil(bu))
		return  1;
	    else if (((RSTTree)object1).getBid().getHiCurrDSUtil(bu) > ((RSTTree)object2).getBid().getHiCurrDSUtil(bu))
		return  -1;
	    else if (((RSTTree)object1).getBid().getUtility(bu).doubleValue() < ((RSTTree)object2).getBid().getUtility(bu).doubleValue())
		return  1;
	    else if (((RSTTree)object1).getBid().getUtility(bu).doubleValue() > ((RSTTree)object2).getBid().getUtility(bu).doubleValue())
		return  -1;
	    else return 0;
	}
	System.out.println("ERROR in RSTTreePeakDSComp.compare, should be two RSTTrees: " + object1 + " " + object2);
	return 0;
    }
    
    public static void main(String[] args){
	//	RSTTree x = RSTTree.GoalDoNot("too much long term debt", -3);
	//RSTTree x = RSTTree.GoalDo("too much short term debt", 1);
	//RSTTree y = RSTTree.GoalDoNot("too much long term debt", -2);

	BidUtility bu = BidUtility.readBidUtilityFromString("{length_coeff=10, DSg_coeff=1, DSv_coeff=1, DSv_fcn=linear, length_target=85, DSg_target=5, RV_coeff=1, DSr_target=5, DSg_fcn=linear, DSr_fcn=linear, cost_coeff=10, cost_fcn=zeroNormal, DSv_target=5, cost_target=15, length_fcn=zeroNormal, DSr_coeff=1}");

	RSTTree x = RSTTree.GoalDoNot("too much long term debt", "r", -5, new Bid());
	RSTTree y = RSTTree.GoalDo("too much short term debt",  "r", 4, new Bid());
	x.print();
	y.print();
	System.out.println("rules: ");
	
	Vector trees = new Vector();
	trees.add(x);
	trees.add(y);
	trees.add(x);	
	System.out.println("unsorted: " + trees);
	
       RSTTreePeakDSComp rc = new RSTTreePeakDSComp(bu);
       Collections.sort(trees,rc);

       System.out.println("sorted: " + trees);
    }    

} // RSTTreePeakDSComp
