import java.util.*;
/**
 * Rule3.java
 *
 *
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class Rule3 extends Rule {

    int ruleNumber = 3;
    int ruleValue = 2;
    boolean worksUnderMixedDirectionTrees = false; //not true for concession, contrast
    boolean worksOnSubTrees = false; //not true for concession, contrast

    public Rule3() {
	
    } // Rule3 constructor
    
    public boolean worksOnSubTrees(){return worksOnSubTrees;}
    public boolean worksUnderMixedDirection(){return worksUnderMixedDirectionTrees;}
    public int ruleNumber(){return ruleNumber;}
    public int ruleValue(){return ruleValue;}

    //Rule3 CONTRAST: one tree has DS 2 more than other, diff directions 
    public RSTTree apply(RSTTree a, RSTTree b, String agentName){

	//a(don't act), but concede b
	Strength sa = a.getTotalStrength();
	Strength sb = b.getTotalStrength();
	if (DEBUG) System.out.println(" " + sa.direction() + " " + sb.direction() + " sa:" + sa + " sb:" + sb);

	//trees must have different direction, not same curr strength
	if ( ! ((sa.direction() != sb.direction()) &&
		(sa.direction() != 0) &&
		(sb.direction() != 0) &&
		( Math.abs(sa.absCurr() - sb.absCurr()) < 2) &&
		sa.absCurr() != 0 && //redundant?
		sb.absCurr() != 0 )){
	    if (DEBUG) System.out.println("rule3 failed, direction & strength");
	    return null;
	}
	RSTTree posTree = sa.direction() == 1 ? a : b;
	RSTTree negTree = sa.direction() == 1 ? b : a;

	//create superstructure with correct instantiations

	RSTNode g3 = new RSTNode("CONTRAST");
	RSTTree aPoint = null, bPoint = null;

	//if (posTree.getTotalStrength().absCurr() > negTree.getTotalStrength().absCurr()){
	//    aPoint = (RSTTree)posTree.clone();
	//    bPoint = (RSTTree)negTree.clone();
	//}
	//else{
	//    aPoint = (RSTTree)negTree.clone();
	//    bPoint = (RSTTree)posTree.clone();
	//}
	//use ordering from coordProcess, ProcessAgent
	aPoint = (RSTTree)a.clone();
	bPoint = (RSTTree)b.clone();

	if (DEBUG) System.out.println("two attach points are : " + aPoint + " " + bPoint);

	g3.addChild(aPoint);
	g3.addChild(bPoint);
	
	RSTTree newTree = new RSTTree(g3);

	//DebugFile df = new DebugFile("rule3output");
	//df.write("tree A: " + aPoint.getRoot() + " " + aPoint.getBid());
	//df.write("________________\n");
	//df.write("tree B: " + bPoint.getRoot() + " " + bPoint.getBid());
	//df.write("________________\n");
	//
	//df.write("\n" + newTree.getString() + "\n" );
	//df.close();
	
	return newTree;
    }// apply(RSTTree a, RSTTree b) Contrast

    public static void main(String[] args){
	Bid b1 = new Bid();
	Bid b2 = new Bid();

	RSTTree x  = RSTTree.GoalDoNot("goaldonot", DSType.RISK, -3, b1);
	RSTTree y = RSTTree.GoalDo("goaldo1", DSType.RISK, 2, b2);

	Rule r2 = new Rule3();
	RSTTree z = r2.apply(x, y,  "spam");
	z.print();
    }
}
