import java.util.*;
/**
 * RuleValue.java
 *
 * Last rule used is last in vector (higher in tree is generally
 * later, but because they can be merged and duplicates can and should
 * happen, order is not absolute).  [prevRulesVector ptTotal]
 *
 * Created: Tue Jan 4 20:10:10 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class RuleValue {
    
    Vector rulesApplied = new Vector();
    Integer value = new Integer(0);
    static final String em = "ERROR in RuleValue.java: ";
    static final String wm = "WARNING in RuleValue.java: ";
    static final String loc = "in RuleValue.java: ";
    static final boolean DEBUG = false;

    public RuleValue() {
    } // RuleValue constructor
    
    public RuleValue(int ruleNumber, int val) {
	rulesApplied.add(new Integer(ruleNumber));
	value = new Integer(val);
    } // RuleValue constructor
   
    //    public Integer getValue(){return value;}
 
    public int getIntValue(){return value.intValue();}

    public boolean equals(Object o){
	if (! (o instanceof RuleValue)) return false;
	RuleValue rv = (RuleValue)o;
	if (value.equals(rv.value) && rulesApplied.equals(rv.rulesApplied))
	    return true;
	else return false;
    }
 
    public void increase(int ruleNumber, int val) {
	rulesApplied.add(new Integer(ruleNumber));
	value = new Integer(value.intValue() + val);
    }

    public static RuleValue merge(RuleValue r1, RuleValue r2){
	RuleValue result = new RuleValue();
	result.rulesApplied.addAll(r2.rulesApplied);
	result.rulesApplied.addAll(r1.rulesApplied);
	result.value = r1.value;
	result.value = new Integer(result.value.intValue() + r2.value.intValue());
	return result;
    }

    public String toString(){
	return "[" + rulesApplied.toString().replaceAll(",", "") + " " + value + "]";
    }

    ///  [[] 0]
    public static RuleValue readRuleValue(String s){
	return readRuleValue(new StringTokenizer(s," ,\t\n\r\f[]", true ));
    }
    //first bracket has not been eaten
    public static RuleValue readRuleValue(StringTokenizer st){
	RuleValue rv = new RuleValue();
	//if (st.hasMoreTokens()){
	String testing = st.nextToken("[], {}=");
	//if( ! st.nextToken().equals("["));
	if (DEBUG) System.out.println("inside readRuleValue(): token is: " + testing);
	    
	if (! testing.equals("[") )
	    System.out.println(em + "while reading rule value, last token was: " + testing);
	    
	rv.rulesApplied = readIntegerList(st); //read Vector of Integers
	st.nextToken(); //space
	rv.value = Integer.valueOf(st.nextToken());
	st.nextToken(); // ]
	
	return rv;
    }

    private static Vector readIntegerList(StringTokenizer st){
	Vector v = new Vector();
	Integer i = null;
	while(! st.nextToken().equals("[")); //first [

	String temp = st.nextToken();
	while(! temp.equals("]")){
	    if (temp.equals("\t") || temp.equals("\n") || temp.equals("\r") || temp.equals("\f") || temp.equals(" ")){
		temp = st.nextToken();
		continue;
	    }
	    else{
		i = Integer.valueOf(temp);
		v.add(i);
		temp = st.nextToken();
	    }
	}

	return v;
    }

    public static void main(String[] args){
	RuleValue r = new RuleValue(3, 2);
	RuleValue r1 = new RuleValue(3, 2);
	System.out.println(r);
	r.increase(7, 1);
	System.out.println(r);
	String temp = r.toString();
	System.out.println(temp);
	r = readRuleValue(temp);

	System.out.println(r);	

	System.out.println(merge(r,r1));	
    }

} // RuleValue
