import java.util.*;
/**
 * TreeGen.java
 *
 *
 * Created: Tue Mar 30 14:10:12 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class TreeGen {

    static final boolean DEBUG = false;

    public TreeGen() {
	
    } // TreeGen constructor
    
    public static void gen(StringBuffer s, RSTTree t, BidUtility bu){
	if (DEBUG) System.out.println("string so far is: " + s.toString());
	
	RSTNode root = t.getRoot();
	if (DEBUG) System.out.println("root is: " + root.toString());

	if (root.getName().regionMatches(true, 0, "inform", 0, 6)){
	    if(root.arg(0) instanceof String)
		s.append((String)root.arg(0));
	    else if (root.arg(0) instanceof Predicate)
		s.append(predicateToText((Predicate)root.arg(0)));
	    else 
		s.append(root.arg(0).toString());
	}
	Iterator i;

	switch (root.getNumberOfChildren()){
	case 0: break;
	case 1: 
	    gen(s, (RSTTree)root.getChildren().next(), bu); break;
	case 2:
	    root.sortChildren(bu);
	    i = root.getChildren();
	    gen(s, (RSTTree)i.next(), bu); 
	    s.append(nodeToText(root));
	    gen(s, (RSTTree)i.next(), bu);  
	    break;
	default:
	    root.sortChildren(bu);
	    i = root.getChildren();
	    while (i.hasNext()){
		gen(s, (RSTTree)i.next(), bu);
		s.append(", and ");
	    }
	}
	//replace , and stop comma
	//say children in order if topics vary (how? pairwise comp in Vector?)
    }

    public static String treeString(RSTTree t, BidUtility bu){
	StringBuffer s = new StringBuffer();
	TreeGen.gen(s, t, bu);
	String result = s.toString();
	result = result.replaceAll(" comma", ",");
	return result;
    }

    private static String predicateToText(Predicate p){
	return p.toString();
    }

    private static String nodeToText(RSTNode r){
	Vector elab = new Vector();
	elab.add("; also ");
	elab.add("; further, ");
	Vector contrast = new Vector();
	contrast.add(". On the other hand, ");
	contrast.add(". In contrast, ");
	contrast.add(". But ");
	if (r.name.equalsIgnoreCase("concession"))
	    return ". However, ";
	if (r.name.equalsIgnoreCase("contrast"))
	    return (String)contrast.elementAt( ((int)(Math.random() * 100)) % 3);
	if (r.name.equalsIgnoreCase("joint"))
	    return " and ";
	if (r.name.equalsIgnoreCase("elaborate"))
	    return (String)elab.elementAt( ((int)(Math.random() * 100)) % 2);
	//System.out.println("Error: unanticpated node name: " + r.name);
	return "";
    }

    public static void main(String[] args){

	BidUtility bu = BidUtility.readBidUtilityFromString("{cost_coeff=1, cost_target=25, length_coeff=1, length_target=60, DSr_coeff=5, DSr_target=10, DSv_coeff=10, DSv_target=10, DSg_target=10, DSg_coeff=5, RV_coeff=1}");
	
	Bid b1 = new Bid();	
	
	//RSTTree x  = RSTTree.GoalDoNot("goaldo comma not1", DSType.RISK, -0.5, b1);
	RSTTree y = RSTTree.readRSTTree("[{topic=r, length_exp=18.0, DStot_exp=[[1 2 2][0 0 0]], cost_exp=0.0, time_exp=2.0, DSr_exp=[[1 2 2][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[0 0 0][0 0 0]], RV=[[1] 1], symbol=IBM, U=30.837179367719685, bidder=Risk}[Goal [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[Recommend BuyInvestment ][]][{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[Persuade [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[MOTIVATE BuyInvestment [AND company_has_maintained_a_moderate_risk_profile; company_has_historically_maintained_a_moderate_debt_policy; ] ][[{topic=r, length_exp=18.0, DStot_exp=[[1 2 2][0 0 0]], cost_exp=0.0, time_exp=2.0, DSr_exp=[[1 2 2][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[0 0 0][0 0 0]], RV=[[] 0], symbol=IBM, U=null, bidder=Risk}[Inform [AND company_has_maintained_a_moderate_risk_profile; company_has_historically_maintained_a_moderate_debt_policy; ] ][]]]]]]]]");
	
	System.out.println( TreeGen.treeString(y, bu) );;
	
    }
} // TreeGen
