import java.io.*;
import java.util.*;
/**
 * TreeGenerate.java
 *
 *
 * Created: Tue Mar 30 14:10:12 2004
 *
 * @author <a href="mailto:terry@Terry-Harveys-Computer.local.">Terry Harvey</a>
 * @version 1.0
 */
public class TreeGenerate {

    static  boolean DEBUG = false;
    static  boolean DEBUG2 = false;
    static String em = "Error in TreeGenerate.java: ";
    static String wm = "Warning in TreeGenerate.java: ";
    static String loc = "TreeGenerate.java: ";
    static final int paragraphLength = 1000;
    boolean foundElabFlag = false;

    private StringBuffer msg; //init in generate()
    BidUtility bu; //private!

    StringBuffer sbRandomArray;
    static Hashtable conjunctions;
    static Hashtable replacements;

    public TreeGenerate() {}

    public TreeGenerate(String symbol) {
	//Last position in conj array is reserved for final instantiation in sentence
	conjunctions = new Hashtable();
	String sa[] = {"; further,","; also","; and"};
	conjunctions.put("semicolonAnd", sa);
	String ca[] = {", ", ", and"};
	conjunctions.put("commaAnd", ca);
	String pa[] = {". In addition,", ". Furthermore", ". Also "};
	conjunctions.put("periodAnd", pa);
	String pc[] = {". However,", ". On the other hand,"};//, " pc   "
	conjunctions.put("periodConcession", pc);
	String sc[] = {"; however,", "; on the other hand,"};//, "  sc  "
	conjunctions.put("semiConcession", sc);
	String pc2[] = {". In contrast,", ". On the other hand,"};//, " pc2   "
	conjunctions.put("periodContrast", pc2);
	String sc2[] = {"; in contrast,", "; but ", "; on the other hand,"};//, "  sc2  "
	conjunctions.put("semiContrast", sc2);
	String period[] = {". "};
	conjunctions.put("period", period); //replacements

	replacements = new Hashtable();
	String co[] = {"the company", symbol, "the stock"};
	replacements.put("company", co);
	String coposs[] = {"the company's", symbol + "'s", "the stock's"};
	replacements.put("company's", coposs);
	String ri[] = {" risk metrics suggest ", " from a risk perspective "};//" risk ratios indicate ", 
	replacements.put("RiskIntro", ri);
	String vi[] = {" value metrics suggest ", " from a value perspective "};//" value ratios indicate ", 
	replacements.put("ValueIntro", vi);
	String gi[] = {" your portfolio metrics suggest ", " from a portfolio perspective "};//" portfolio ratios indicate ", 
	replacements.put("GoalIntro", gi);
	String comma[] = {","};
	replacements.put("comma", comma);
    } // TreeGenerate constructor

    public String generate(RSTTree t){
	String result = null;
	try{
	    msg = new StringBuffer(paragraphLength);
	    gen(t, null, msg);
	    result = msg.toString();
	    if (DEBUG) System.out.println("111 " + result);
	    result = removeDups(result);
	    if (DEBUG) System.out.println("222 " + result);
	    result = replace(result);
	    if (DEBUG) System.out.println("333 " + result);
	    result = result.replaceAll("[ ]+", " ");
	    result = result.replaceAll(" [.]", ".");
	    result = result.replaceAll(" [,]", ",");
	    result = result.replaceAll(" [;]", ";");
	    result = result.replaceAll("[;][.]", ".");
	    result = result.replaceAll("[.][.]", ".");//why?
	    result = result.replaceAll("[.][,]", ".");
	    result = result.trim();
	    result = addCapsAndPeriod(result);
	} catch (Exception e){
	    System.out.println("tree: " + t.getString());
	    System.out.println( e);
	}
	return result;
    }

    // High int port goal info has overridden the priority you placed on risk
    public String generateLong(RSTTree t, BidUtility b){
	bu = b;
	t.print();
	String hiCoefficient = bu.hiCoeff();
	if (DEBUG) System.out.println("hi coeff is " + hiCoefficient);
	String coeffTopic = hiCoefficient.substring(2,3);
	
	String topic = firstTopic(t);
	if (DEBUG) System.out.println("first topic is: " + topic);
	if (DEBUG) System.out.println("first inform is: ");
	firstInformTree(t).print();
	
	String dsType = "DS" + topic + "_coeff";
	String prefix;
	if (hiCoefficient.equals(dsType))
	    prefix = "";
	//don't say unless pref is 50 percent higher than lead
	else if (Double.parseDouble((String)bu.get(hiCoefficient)) > 
		 (1.5 * Double.parseDouble((String)bu.get(dsType)))){
	    //else {
	    if (topic.equals(DSType.GOAL))
		topic  = getLongTopicName(topic);
	    else topic  = getTopicName(topic);
	    prefix = "High interest " + topic + 
		" information has overridden the priority you placed on " + 
		getLongTopicName(coeffTopic) + " period ";
	}
	else 
	    prefix = "";

	msg = new StringBuffer(paragraphLength);
	gen(t, null, msg);
	String result = msg.toString();

	msg.insert(0, prefix);
	result = msg.toString();
	if (DEBUG) System.out.println("111 " + result);
	result = removeDups(result);
	if (DEBUG) System.out.println("222 " + result);
	result = replace(result);
	if (DEBUG) System.out.println("333 " + result);
	result = result.replaceAll("[ ]+", " ");
	result = result.replaceAll(" [.]", ".");
	result = result.replaceAll(" [,]", ",");
	result = result.replaceAll(" [;]", ";");
	result = result.replaceAll("[;][.]", ".");
	result = result.replaceAll("[.][,]", ".");
	result = result.trim();
	result = addCapsAndPeriod(result);
	return result;
    }

    public String generateRandom(RSTTree t){
	
	msg = new StringBuffer(paragraphLength);
	RSTTree r = randomTree(t);
	gen(r, null, msg);
	String result =  msg.toString();

	if (DEBUG) System.out.println("111 " + result);
	result = removeDups(result);
	if (DEBUG) System.out.println("222 " + result);
	result = replace(result);
	if (DEBUG) System.out.println("333 " + result);
	result = result.replaceAll("[ ]+", " ");
	result = result.replaceAll(" [.]", ".");
	result = result.replaceAll(" [,]", ",");
	result = result.replaceAll(" [;]", ";");
	result = result.replaceAll("[;][.]", ".");
	result = result.replaceAll("[.][,]", ".");
	result = result.trim();
	result = addCapsAndPeriod(result);
	return result + "  a: " + sbRandomArray.toString();
    }

    /**
     * prev is last Inform tree that was expressed, not the root of
     * the last expressed tree. Returns last tree generated,
     * i.e. rightmost leaf of t (last leaf from in-order traversal.
     **/
    public RSTTree gen(RSTTree t, RSTTree prev, StringBuffer msg){
	
	if (DEBUG && (prev != null)) 
	    System.out.println("entering gen, root is: " + t.getRoot() + " " + 
			       prev.getRoot());
	else if (DEBUG) System.out.println("entering gen, root is: " + t.getRoot() + " null");
	//if (DEBUG) System.out.println("isMixedDirection() " + t.isMixedDirection());
	//if (DEBUG) System.out.println("isMixedTopic() " + t.isMixedTopic());
	
	RSTNode root = t.getRoot();

	//JOINT or ELAB
	/**one topic, one direction **/
	if (root.getName().regionMatches(true, 0, "elabo", 0, 5) ||
	    (root.getName().regionMatches(true, 0, "joint", 0, 5)))
	    return joint(t, prev, msg);

	//if (root.getName().regionMatches(true, 0, "elabo", 0, 5) ||
	//    (root.getName().regionMatches(true, 0, "joint", 0, 5) &&
	//     ! t.isMixedDirection() &&
	//     ! t.isMixedTopic()
	//     )){
	//    
	//    return oneDirOneTopic(t, prev, msg);
	//}
	//    /**mixed topic, one direction **/
	//else if (root.getName().regionMatches(true, 0, "joint", 0, 5) &&
	//	  ! t.isMixedDirection() //will be mixed topic
	//	  ){
	//    return oneDirMixedTopic(t, prev, msg);
	//}
	///**one topic, mixed direction **/
	//else if (root.getName().regionMatches(true, 0, "joint", 0, 5) &&
	//	  ! t.isMixedTopic() //will be mixed direction
	//	 ){
	//    return oneTopicMixedDirJoint(t, prev, msg);
	//}
	///**mixed topic, mixed direction **/
	//else if (root.getName().regionMatches(true, 0, "joint", 0, 5)
	//	 //will be mixed direction and topic
	//	 ){
	//    return mixedTopicMixedDirJoint(t, prev, msg);
	//}

	//CONCESSION
	else if (root.getName().regionMatches(true, 0, "conce", 0, 5) ){
	    return concession(t, prev, msg);
	}

	//CONTRAST
	else if (root.getName().regionMatches(true, 0, "contr", 0, 5) ){
	    return contrast(t, prev, msg);
	}

	//INFORM
	else if (root.getName().regionMatches(true, 0, "inform", 0, 6)){
	    return inform(t, prev, msg);
	}

	Iterator i;

	RSTTree last = prev;
	i = root.getChildren();
	while (i.hasNext()){
	    last = gen((RSTTree)i.next(), last, msg);
	}
	
	return last; 

    }//gen(RSTTree t, RSTTree prev, StringBuffer msg)

    public RSTTree inform(RSTTree t, RSTTree prev, StringBuffer msg){
	
	if (DEBUG2) {
	    System.out.print("inside inform: " + t.getRoot() + " ");
	    if (prev != null) System.out.println(prev.getRoot());
	    else System.out.println("null");
	}	

	RSTNode root = t.getRoot();

	if ((! isSameTopic(t, prev)) || prev == null )
	    msg.append(getTopicIntro(t));

	if(root.arg(0) instanceof String)
	    msg.append( (String)root.arg(0));
	else if (root.arg(0) instanceof Predicate)
	    msg.append( predicateToText((Predicate)root.arg(0)));
	else 
	    msg.append( root.arg(0).toString());

	return t;
    }	

    public RSTTree concession(RSTTree t, RSTTree prev, StringBuffer msg){
	if (DEBUG) System.out.println("inside concession()");

	//if (t.isMixedTopic() && containsCon(msg))
	//    msg.append("Information from other sources is also mixed: ");
	//else if (t.isMixedTopic())
	//    msg.append("Information from other sources is mixed: ");

	Vector v = t.getRoot().getChildrenVector();
	RSTTree left = (RSTTree)v.get(0);
	RSTTree right = (RSTTree)v.get(1);

	int sizeLeft = countInforms(left);
	int sizeRight = countInforms(right);

	RSTTree leftLast;
	String strLeft, sbRight;
	StringBuffer sbLeft = new StringBuffer(paragraphLength);
	leftLast = gen(left, prev, sbLeft);
	
	if (containsSemicolonAnd(sbLeft) || containsSemicolon(sbLeft))
	    sbLeft.append(" periodConcession ");
	else if (sizeLeft + sizeRight <= 3)
	    sbLeft.append(" semiConcession ");
	else
	    sbLeft.append(" periodConcession ");

	msg.append(sbLeft);
	RSTTree last = gen(right, leftLast, msg);
	msg.append(" period ");
	return last;
	
    }//concession

    public RSTTree contrast(RSTTree t, RSTTree prev, StringBuffer msg){
	if (DEBUG) System.out.println("inside contrast()");
	
	//if (t.isMixedTopic() && containsCon(msg))
	//    msg.append("Information from other sources is also mixed: ");
	//else if (t.isMixedTopic())
	//    msg.append("Information from other sources is mixed: ");

	Vector v = t.getRoot().getChildrenVector();
	RSTTree left = (RSTTree)v.get(0);
	RSTTree right = (RSTTree)v.get(1);

	int sizeLeft = countInforms(left);
	int sizeRight = countInforms(right);

	RSTTree leftLast;
	String strLeft, sbRight;
	StringBuffer sbLeft = new StringBuffer(paragraphLength);
	leftLast = gen(left, prev, sbLeft);
	
	if (containsSemicolonAnd(sbLeft) || containsSemicolon(sbLeft))
	    sbLeft.append(" periodContrast ");
	else if (sizeLeft + sizeRight <= 3)
	    sbLeft.append(" semiContrast ");
	else
	    sbLeft.append(" periodContrast ");

	msg.append(sbLeft);
	RSTTree last = gen(right, leftLast, msg);
	msg.append(" period ");
	return last;
	
    }//contrast


    /**
     * If there is a change of topic or direction going into joint,
     * and joint contains more than one inform node, then insert a
     * period before join.
     **/
    public RSTTree joint(RSTTree t, RSTTree prev, StringBuffer msg){
	
	if (DEBUG) System.out.println("entering joint");
	if (DEBUG) t.print();
	//int numLeadingInforms = countInformsBeforeElab(t);
	//int informs = countInforms(t);
	//RSTTree leftMostInform = firstInformTree(t);
	//if ( ((! isSameTopic(leftMostInform, prev)) || (! isSameDirection(leftMostInform, prev))) &&
	//     informs > 1) {
	//    System.out.println("joint appending change period before " + leftMostInform.getRoot().getName());
	//    msg.append(" period ");
	//}

	StringBuffer sbNext;

	Vector v = t.getRoot().getChildrenVector();   //(getInformNodes(t, v);   
	if (DEBUG) System.out.println(v);
	

    	RSTTree left = (RSTTree)v.get(0);
    	if (DEBUG) System.out.println(left.getRoot().getName() + "leftTopic:" + left.isMixedTopic() + "  leftDir: " + 
    			   left.isMixedDirection());
    	RSTTree right = (RSTTree)v.get(1);
    	if (DEBUG) System.out.println(right.getRoot().getName());
	String rightIntro = "", leftIntro = "";

    	if (DEBUG)System.out.println(left.getRoot().getName() + "leftTopic:" + left.isMixedTopic() + "  leftDir: " + 
    			   left.isMixedDirection()+ " " + right.getRoot().getName() + "rightTopic:" +
    			   right.isMixedTopic()+ "  rightDir: " +right.isMixedDirection());
    	
	if (right.isMixedTopic()){
    	    if (left.isMixedDirection() && right.isMixedDirection())
    		rightIntro = "Information from other sources is also mixed: ";
    	    else if (right.isMixedDirection())
    		rightIntro = "Information from other sources is mixed: ";
    	    else if (left.isMixedDirection())//right is not mixed
    		rightIntro = "Information from other sources is consistent: ";
    	}
    	else if (left.isMixedTopic()){ //but right is not mixed topic
    	    if (right.isMixedDirection() && left.isMixedDirection()){
    		//leftIntro = "Information from all sources is mixed period "; 
    	    }
    	    //else if (left.isMixedDirection())
    	    //	//rightIntro = "Information from a " + getTopicName(right) + " point of view is not mixed: ";
    	    //	rightIntro = "";
    	}

	RSTTree last;
	msg.append(leftIntro);
	StringBuffer sbLeft = new StringBuffer(paragraphLength/4);
	last = gen( left, prev, sbLeft);

	//if ( left.getRoot().getName().regionMatches(true, 0, "contr", 0, 5) ||
	//    right.getRoot().getName().regionMatches(true, 0, "contr", 0, 5) ||
	//     left.getRoot().getName().regionMatches(true, 0, "conce", 0, 5) ||
	//     right.getRoot().getName().regionMatches(true, 0, "conce", 0, 5)){
	//    System.out.println("joint appending con period");
	//    sbLeft.append(" period ");
	//}

	int informsRight = countInforms(right);
	RSTTree leftMostInformOfRightTree = firstInformTree(right);

	if (! isSameDirection(last, leftMostInformOfRightTree)){
	    if (DEBUG) System.out.println("joint appending changeDir period before " + leftMostInformOfRightTree.getRoot().getName());
	    sbLeft.append(" period ");
	}
	else if ( (! isSameTopic(last, leftMostInformOfRightTree)) && informsRight > 1) {
	    if (DEBUG) System.out.println("joint appending changeTop period before " + leftMostInformOfRightTree.getRoot().getName());
	    sbLeft.append(" period ");
	}
	else if ( (! isSameTopic(last, leftMostInformOfRightTree)) && informsRight > 1) {
	    if (DEBUG) System.out.println("joint appending changeTop period before " + leftMostInformOfRightTree.getRoot().getName());
	    sbLeft.append(" period ");
	}
	else{// (isSameDirection(last, right))
	    if (containsSemicolonAnd(sbLeft))
		sbLeft.append(" semicolonAnd ");
	    //sbLeft.append(" period");
	    else if (containsComma(sbLeft)) 
		sbLeft.append(" semicolonAnd ");
	    else if (containsCommaAnd(sbLeft)) 
		sbLeft.append(" commaAnd ");
	    else
		sbLeft.append(" commaAnd ");
	}

	msg.append(sbLeft);
	msg.append(rightIntro);
	last = gen( right, last, msg);

	//RSTTree last = prev;
	//RSTTree nextTree;
	//int i = 0;
	//for (i = 0; i < (v.size() - 1); i++ ){
	//
	//    nextTree = (RSTTree)v.elementAt(i);
	//
	//    sbNext = new StringBuffer(paragraphLength/4);//can get rid of this now??
	//    last = gen( nextTree, last, sbNext); //topic intro will happen in here if necessary
	//    
	////last one
	//if ( ! v.isEmpty() )
	//    last = gen( (RSTTree)v.elementAt(i), last, msg );
	 
	return last;
	
	//if inform is longer than X or contains comma, end with ;?
	//   after say also? when to have period?	      
    }//joint//oneDirOneTopic(RSTTree t)


//if one inform, return segment. Two requires conj; three requires commas or semis.
/**
 * If there is an elab, and a sentence break is needed, break before or after the elab.
 * How are elabs treated differently? Parts stay in same sentence.
 **/
    //public static RSTTree oneDirOneTopic(RSTTree t, RSTTree prev, StringBuffer msg){
    //	
    //	if (DEBUG) System.out.println("entering odot");
    //
    //	if (! isSameTopic(t, prev) )
    //	    msg.append(getTopicIntro(t));
    //
    //	int numLeadingInforms = countInformsBeforeElab(t);
    //
    //	StringBuffer next;
    //
    //	Vector v = new Vector();
    //	getInformNodes(t, v);        //(t.getRoot().getChildrenVector();
    //	RSTTree last = null;
    //	int i = 0;
    //	///all but last one
    //	for (int i = 0; i < (v.size() - 1); i++ ){
    //
    //	    next = new StringBuffer(paragraphLength/4);
    //	    gen( (RSTTree)v.elementAt(i), (RSTTree)v.elementAt(i), next );
    //	    
    //	    if (containsSemicolonAnd(next))
    //		next.append(" semicolonAnd ");
    //	    //next.append(" period");
    //	    else if (containsComma(next)) 
    //		next.append(" semicolonAnd ");
    //	    else if (containsCommaAnd(next)) 
    //		next.append(" commaAnd ");
    //	    else
    //		next.append(" commaAnd ");
    //
    //	    msg.append(next);
    //	}
    //	//last one
    //	if ( ! v.isEmpty() )
    //	    last = gen( (RSTTree)v.elementAt(i), (RSTTree)v.elementAt(i), msg );
    //	 
    //	return last;
    //	
    //	//if inform is longer than X or contains comma, end with ;?
    //	//   after say also? when to have period?	      
    //}//oneDirOneTopic(RSTTree t)

    //public static RSTTree oneDirMixedTopic(RSTTree t, RSTTree prev, StringBuffer msg){
    //	
    //	if (DEBUG) System.out.println("entering odmt root: " + t.getRoot() + " " + topicIntro);
    //
    //	StringBuffer result = new StringBuffer("");
    //
    //	String next, intro = "";
    //	Vector v = t.getRoot().getChildrenVector();
    //
    //	for (int i = 0; i < v.size(); i++ ){
    //	    if (topicIntro && ! ((RSTTree)v.elementAt(i)).isMixedDirection()){
    //		intro = getTopicIntro((RSTTree)v.elementAt(i));
    //		next = gen( (RSTTree)v.elementAt(i), bu, false );
    //	    }
    //	    else
    //		next = gen( (RSTTree)v.elementAt(i), bu, topicIntro);
    //	    next.append(intro);
    //	    next.append(" " + next);
    //	    if ( i != (v.size() - 1)){
    //	    if (containsSemicolonAnd(next))
    //		next.append(" semicolonAnd ");
    //	    //next.append(" period");
    //	    else if (containsComma(next)) 
    //		next.append(" semicolonAnd ");
    //	    else if (containsCommaAnd(next)) 
    //		next.append(" commaAnd ");
    //	    else
    //		next.append(" commaAnd ");
    //	    }
    //	} 
    //	if (DEBUG) System.out.println("odmt returning " + result.toString());
    //	return result.toString();
    //	
    //	//if inform is longer than X or contains comma, end with ;?
    //	//   after say also? when to have period?	      
    //}//oneDirOneTopic(RSTTree t)
    

    //public static RSTTree oneTopicMixedDirJoint(RSTTree t, RSTTree prev, StringBuffer msg){
    //	
    //	if (DEBUG)
    //	    System.out.println("entering otmd");
    //
    //	StringBuffer result = new StringBuffer("");
    //
    //	String next;
    //	Vector v = t.getRoot().getChildrenVector();
    //
    //	for (int i = 0; i < v.size(); i++ ){
    //	    next = gen( (RSTTree)v.elementAt(i), bu, false );
    //	    next.append(next);
    //	    if ( i != (v.size() - 1)){
    //		next.append(" period ");
    //		//if (containsSemicolonAnd(next))
    //		//    next.append(" period ");
    //		////next.append(" period");
    //		//else if (containsComma(next)) 
    //		//    next.append(" semicolonAnd ");
    //		//else if (containsCommaAnd(next)) 
    //		//    next.append(" commaAnd ");
    //		//else
    //		//    next.append(" commaAnd ");
    //	    }
    //	} 
    //	if (DEBUG) System.out.println("otmd returning " + result.toString());
    //	return result.toString();
    //		      
    //}
    
    /**
     * This method could have a concession inside, possibly more than
     * one. If there are two concessions, need to indicate topic
     * change explicitly; If one concession, don't need explicit topic
     * change as long as direction is consistent leading into or out
     * of concession.
     * If both children are mixed direction, be explicit.
     **/
    //public static RSTTree mixedTopicMixedDirJoint(RSTTree t, RSTTree prev, StringBuffer msg){
    //	
    //	if (DEBUG)
    //	    System.out.println("entering mtmd");
    //
    //	StringBuffer result = new StringBuffer("");
    //
    //	String next, leftIntro = "", rightIntro = "";
    //	boolean leftTI = topicIntro, rightTI = topicIntro;
    //
    //	Vector v = t.getRoot().getChildrenVector();
    //	RSTTree left = (RSTTree)v.get(0);
    //	RSTTree right = (RSTTree)v.get(1);
    //	if (DEBUG)System.out.println("leftTopic:" + left.isMixedTopic() + "  leftDir: " + 
    //			   left.isMixedDirection()+ "rightTopic:" +
    //			   right.isMixedTopic()+ "  rightDir: " +right.isMixedDirection());
    //	
    //
    //	if (topicIntro){
    //	    if ( ! left.isMixedTopic()){
    //		leftIntro = getTopicIntro(left);
    //		leftTI = false;
    //	    }
    //	    if ( ! right.isMixedTopic()){
    //		rightIntro = getTopicIntro(right);
    //		rightTI = false;
    //	    }
    //	}
    //	else if (right.isMixedTopic()){
    //	    if (left.isMixedDirection() && right.isMixedDirection())
    //		rightIntro = "Information from other sources is also mixed: ";
    //	    else if (right.isMixedDirection())
    //		rightIntro = "Information from other sources is mixed: ";
    //	    else if (left.isMixedDirection())//right is not mixed
    //		rightIntro = "Information from other sources is consistent: ";
    //	    rightTI = true;
    //	}
    //	else if (left.isMixedTopic()){
    //	    if (right.isMixedDirection() && left.isMixedDirection()){
    //		leftIntro = "Information from all sources is mixed period "; 
    //		leftTI = true;
    //	    }
    //	    else if (left.isMixedDirection())
    //		//rightIntro = "Information from a " + getTopicName(right) + " point of view is not mixed: ";
    //		rightIntro = "";
    //	    rightTI = true;
    //	}
    //	else {
    //	    rightIntro = getTopicIntro(right);
    //	    rightTI = true;
    //	}
    //	//if (left.isMixedDirection() && right.isMixedDirection()){
    //	    
    //	result.append(leftIntro);
    //	result.append( gen(left, bu, leftTI) );
    //	result.append( " period " );
    //	    //say left, then explicit topic change for right
    //	result.append(rightIntro);
    //	result.append( gen(right, bu, rightTI) );
    //	    //}
    //
    //	//else if (left.isMixedDirection() && 
    //	//	 (left.getTopic().equals(right.getTopic()) )
    //	//	 ){
    //	//    result.append( gen(left, bu, leftTI) );
    //	//    result.append( " period " );
    //	//    //say left, then explicit topic change for right
    //	//    result.append( gen(right, bu, rightTI) );
    //	//}
    //	//
    //	//else{//NO DIFFERENCE YET
    //	//    result.append( gen(left, bu, leftTI) );
    //	//    result.append( " period " );
    //	//    //say left, then explicit topic change for right
    //	//    result.append( gen(right, bu, rightTI) );
    //	//}
    //	
    //	if (DEBUG) System.out.println("mtmd returning " + result.toString());
    //	return result.toString();
    //		      
    //}

    private static String predicateToText(Predicate p){
	if (p.getName().regionMatches(true, 0, "and", 0, 3)){
	    return and(p);
	}
	else
	    return p.toString();
    }
    /*
     * Reads string args from a nested Predicate and appends them all to result.
     */
    private static void flatten(Predicate p, Vector allArgs)
	throws IOException
    {
	String name = p.getNameWithoutID();
	String next;
	
	//if (DEBUG) System.out.println(name + p.arg(0));

	for (int i = 0; i < Predicate.argNUM && (p.arg(i) != null); i++){
	    //if (DEBUG) System.out.println(name + p.arg(i));
	    if (p.arg(i) instanceof Predicate){
		if ( ! name.equals(((Predicate)p.arg(i)).getNameWithoutID()))
		    throw new IOException("flatten: " + name + " " + p.arg(i));
		else
		    flatten((Predicate)p.arg(i), allArgs);
	    }
	    else{
		next = ((String)p.arg(i));
		allArgs.add(next);
	    } 
	}
    }

private static String and(Predicate p){

    if (DEBUG)
	System.out.println("entering AND");

    //if (DEBUG) System.out.println(p.toString());


    Vector args = new Vector();
    
    try{
	flatten(p, args);
    } catch (IOException e) {
	System.out.println(e);
    }
    //if (DEBUG) System.out.println(args);
    StringBuffer result = new StringBuffer();
    String next;
	    
    if (! args.isEmpty()){
	if (DEBUG) System.out.println(args.elementAt(0));
	next = (String)args.elementAt(0);
	result.append(next);
	
	for (int i = 1; i < args.size(); i++){
	    if ( i != (args.size()) ){
		if (containsSemicolonAnd(next))
		    result.append(" semicolonAnd ");
		//result.append(" period");
		else if (containsComma(next)) 
		    result.append(" semicolonAnd ");
		else if (containsCommaAnd(next)) 
		    result.append(" commaAnd ");
		else
		    result.append(" commaAnd ");
	    }
	    next = (String)args.elementAt(i);
	    result.append(next);
	} 
    }
	
    if (DEBUG) System.out.println("AND returning " + result.toString());
    return result.toString();
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
    /*                UTILITIES                            */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

    //should only call on single topic trees
    private static String getTopicIntro(RSTTree t){
	if (DEBUG)System.out.println("getting intro for " + t.getRoot());
	
	String topic = t.getTopic();
	if (topic.equals(DSType.RISK))//UNSET, MIXED
	    return " RiskIntro ";
	else if (topic.equals(DSType.VALUE))
	    return " ValueIntro ";
	else if (topic.equals(DSType.GOAL) && t.getBid().getBidder().equals("RA"))
	    return " from a portfolio perspective ";
	else if (topic.equals(DSType.GOAL))
	    return " GoalIntro ";
	else
	    System.out.println(em + " in getTopicIntro() " + t.getRoot());
	return "ERROR INTRO";
    }
    
    private static String getTopicName(RSTTree t){
	if (DEBUG)System.out.println("getting topicName for " + t.getRoot());
	
	String topic = t.getTopic();
	if (topic.equals(DSType.RISK))//UNSET, MIXED
	    return " risk ";
	else if (topic.equals(DSType.VALUE))
	    return " value ";
	else if (topic.equals(DSType.GOAL))
	    return " goal ";
	else
	    System.out.println(em + " in getTopicName() " + t.getRoot());
	return "ERROR NAME";
    }
    private static String getTopicName(String s){
	if (DEBUG)System.out.println("getting topicName for " + s);
	
	if (s.equals(DSType.RISK))//UNSET, MIXED
	    return " risk ";
	else if (s.equals(DSType.VALUE))
	    return " value ";
	else if (s.equals(DSType.GOAL))
	    return " goal ";
	else
	    System.out.println(em + " in getTopicName() " + s);
	return "ERROR NAME";
    }
    private static String getLongTopicName(String s){
	if (DEBUG)System.out.println("getting topicName for " + s);
	
	if (s.equals(DSType.RISK))//UNSET, MIXED
	    return " risk information ";
	else if (s.equals(DSType.VALUE))
	    return " value information ";
	else if (s.equals(DSType.GOAL))
	    return " portfolio allocation ";
	else
	    System.out.println(em + " in getTopicName() " + s);
	return "ERROR NAME";
    }


    static public boolean isSameTopic(RSTTree a, RSTTree b){
	if (DEBUG && a != null) System.out.println(getTopicName(a));
	if (DEBUG && b != null) System.out.println(getTopicName(b));
	//if (DEBUG) System.out.println(a.getRoot().getName() + "  " + b.getRoot().getName());
	
	if (a == null || b == null)
	    return true;
	else
	    return a.getTopic().equals(b.getTopic());
    }

    static public boolean isSameDirection(RSTTree a, RSTTree b){
	if (a == null || b == null)
	    return true;
	else
	    if (a.getTotalStrength().direction() != 0 &&
		a.getTotalStrength().direction() == b.getTotalStrength().direction())
		return true;
	return false;
    }

    //actually counts spaces between words; must be single spaces to work.
    public static int wordCount(String s){

    	StringTokenizer st = new StringTokenizer(s);
    	int count = 0;
    
    	while (st.hasMoreTokens()){
    	    st.nextToken();
    	    count++;
    	}
	return count;
    }

    //String was trimmed first
    public String addCapsAndPeriod(String s){
	
	char curr;
	char[] c = s.toCharArray();
	
	int periodIndex = -2;
	for(int i = 0; i < c.length; i++){
	    if (i == periodIndex + 2)
		c[i] = Character.toUpperCase(c[i]);
	    if (c[i] == '.')
		periodIndex = i;
	}
	if (c[c.length - 1] == '.')
	    return new String(c);
	else
	    return new String(c) + ".";
    }

    public String removeDups(String s){

	StringTokenizer st = new StringTokenizer(s);
	
	StringBuffer result = new StringBuffer(300);
	String next = "", last = "";

	while (st.hasMoreTokens()){
	    last = next;
	    next = st.nextToken();	    
	    if (! next.equals(last)){
		result.append(" " + last);
	    }
	}
	result.append(" " + next);
	return result.toString();
    }
 	    

    private static boolean containsComma(StringBuffer s){
	return s.indexOf("comma ") >= 0;
    }
    private static boolean containsComma(String s){
	return s.indexOf("comma ") >= 0;
    }
    private static boolean containsCommaAnd(StringBuffer s){
	return s.indexOf("commaAnd") >= 0;
    }
    private static boolean containsCommaAnd(String s){
	return s.indexOf("commaAnd") >= 0;
    }
    private static boolean containsSemicolon(StringBuffer s){
	return s.indexOf("semicolon ") >= 0;
    }
    private static boolean containsSemicolon(String s){
	return s.indexOf("semicolon ") >= 0;
    }
    private static boolean containsSemicolonAnd(StringBuffer s){
	return s.indexOf("semicolonAnd") >= 0;
    }
    private static boolean containsSemicolonAnd(String s){
	return s.indexOf("semicolonAnd") >= 0;
    }
    private static boolean containsCon(StringBuffer s){
	return (s.indexOf("ontrast") >= 0 || s.indexOf("oncession") >= 0);
    }
   
    private static int countInforms( RSTTree t){
	
	RSTNode root = t.getRoot();
	if (DEBUG) System.out.println("root is: " + root.toString());

	if (root.getName().regionMatches(true, 0, "inform", 0, 6))
	    return 1;
	else{
	    int result = 0;
	    Iterator i = root.getChildren();
	    while (i.hasNext())
		result += countInforms( (RSTTree)i.next() ); 
	    return result;
	}
    }

    private int countInformsBeforeElab( RSTTree t){
	foundElabFlag = false;
	int count = subCIBE(t);
	if (DEBUG) System.out.println("cibe root is: " + t.getRoot().getName() + " " + count);
	return count;
    }
    private int subCIBE( RSTTree t){
    
	RSTNode root = t.getRoot();
	
	if (root.getName().regionMatches(true, 0, "inform", 0, 6))
	    return 1;
	else if (root.getName().regionMatches(true, 0, "elab", 0, 4)){
	    foundElabFlag = true;
	    return 0;
	}
	else{
	    int sum = 0;
	    Iterator i = root.getChildren();
	    while (i.hasNext() && foundElabFlag == false)
		sum += subCIBE( (RSTTree)i.next() ); 
	    
	    return sum;
	}
    }

//pass a vector in, INFORM nodes from tree are put in, left-to-right traversal.
    private static void getInformNodes(RSTTree t, Vector v){
    	
    	RSTNode root = t.getRoot();
    
    	if (root.getName().regionMatches(true, 0, "inform", 0, 6))
    	    v.add(root);
    	else{
    	    int result = 0;
    	    Iterator i = root.getChildren();
    	    while (i.hasNext())
    		getInformNodes( (RSTTree)i.next(), v ); 
    	    return;
    	}
    }//getInformNodes( RSTTree t)

    private static String firstTopic(RSTTree t){

    	RSTNode root = t.getRoot();
    
    	if (root.getName().regionMatches(true, 0, "inform", 0, 6))
    	    return t.getTopic();
    	else{
    	    String result;
    	    Iterator i = root.getChildren();
    	    while (i.hasNext()){
		result = firstTopic( (RSTTree)i.next() );
		if (result != null)
		    return result; 
	    }
	    return null;
    	}
    }

    private static RSTTree firstInformTree(RSTTree t){

    	RSTNode root = t.getRoot();

    	if (root.getName().regionMatches(true, 0, "inform", 0, 6))
    	    return t;
    	else{
    	    RSTTree result;
    	    Iterator i = root.getChildren();
    	    while (i.hasNext()){
		result = firstInformTree( (RSTTree)i.next() );
		if (result != null)
		    return result; 
	    }
	    return null;
    	}
    }

    //WARNING: breaks predicates like AND; only for use with random trees.
    //pass a vector in, INFORM nodes from tree are put in, in-order traversal.
    private static void getInformTrees(RSTTree t, Vector v){
    	
    	RSTNode root = t.getRoot();
    
    	if (root.getName().regionMatches(true, 0, "inform", 0, 6)){
	    if ( ! (root.arg(0) instanceof Predicate))
		v.add(t);
	    else{
		synchronized(v){
		    System.out.println("PREDICATE INSIDE INFORM: " + root.arg(0));
		    dissectPredicate((Predicate)root.arg(0), v, t.getBid());
		}
	    }
	}
    	else{
    	    Iterator i = root.getChildren();
	    RSTTree next;
    	    while (i.hasNext()){
    		next = (RSTTree)i.next(); //remove
		getInformTrees( next, v ); 
	    }
    	    return;
    	}
    }//getInformTrees( RSTTree t)

    private static void dissectPredicate(Predicate p, Vector v, Bid b){
	Object[] a = p.args;
	for (int i = 0; i < a.length; i++){
	    if (a[i] != null && (a[i] instanceof Predicate))
		dissectPredicate((Predicate)a[i], v, b);
	    else if (a[i] != null){
		System.out.println("Creating new inform tree: " + a[i]);
		v.add(new RSTTree(b, new RSTNode("Inform", a[i])));
	    }
	}
    }

    //Takes a tree, returns a new tree with leaves in new order, and
    //superstructure is all JOINT nodes.
    public  RSTTree randomTree(RSTTree r){
	Vector trees = new Vector();
	int length;
	getInformTrees(r, trees);

	length = trees.size();
	RSTTree[] randomTrees = new RSTTree[length];
	
	int [] a = CosineDistance.getDistantRandomArray(length, 2);//using Collections.shuffle()
	sbRandomArray = new StringBuffer(50);//global, ick

	for (int i = 0; i < a.length; i++)
	    sbRandomArray.append(a[i] + " ");
	System.out.println("a: " + sbRandomArray);
	
	for (int i = 0; i < trees.size(); i++)
	    ((RSTTree)trees.get(i)).print();

	//int[] a = {4,2,0,1,3,5};//{2,4,3,0,5,1}
	for (int i = 0; i < a.length; i++)
	    randomTrees[i] = (RSTTree)trees.get(a[i]);
	
	trees.clear();

	for (int i = 0; i < a.length; i++)
	    trees.add(randomTrees[i]);
	
	Integrator I = new Integrator();
	RSTTree result = I.joinRandomTrees(trees, "gen");
	result.print();
	return result;
    }


    public String replace(String s){
	StringTokenizer st = new StringTokenizer(s);
	
	StringBuffer result = new StringBuffer("");
	StringBuffer between = new StringBuffer("");
	String next, lastConj = null;

	while (st.hasMoreTokens()){
	    next = st.nextToken();
	    if (conjunctions.containsKey(next)){
		if (DEBUG)System.out.println("next: " + next + "  lastConj: " + lastConj + "  between: " + between);
		if (lastConj != null){
		    if (next.equals(lastConj))
			result.append( getConj(lastConj, false) );
		    else
			result.append( getConj(lastConj, true) );
		}
		result.append(between);
		between = new StringBuffer("");
		lastConj = next;
	    }
	    else if (replacements.containsKey(next))
		between.append(" " + getRepl(next));
	    else
		between.append(" " + next);
	}///end while

	if (lastConj != null)
	    result.append( getConj(lastConj, true) );
	result.append(between);
	return result.toString();
    }

    //last means last conj of this type; next is different
    private String getConj(String s, boolean last){
	if (DEBUG)System.out.println("inside getConj: " + s);
	
	String[] a;

	if (last){
	    if  (s.equals("semicolonAnd")){
		a = (String[])conjunctions.get("periodAnd");
		last = false;
	    }
	    //use startsWith()?
	    else if (s.equals("periodContrast") || s.equals("periodConcession") || s.equals("periodAnd")){
		a = (String[])conjunctions.get(s);
		last = false;
	    }
	    else
		a = (String[])conjunctions.get(s);
	}
	else
	    a = (String[])conjunctions.get(s);

	int r;

	if (last) 
	    r = a.length - 1;
	else
	    r = (int)(Math.random() * (a.length - 1));

	if (DEBUG)
	    System.out.println("inside getConj, r: " + r + " last: " + last + " word: " + (String)a[r]);
	//if (s.equals("commaAnd")){
	//    if (last) r = a.length - 1;
	//    else r = a.length - 2;
	//}
	//else
	//    r = (int)(Math.random() * a.length);

	return (String)a[r];
    }

    private String getRepl(String s){

	
	String[] a = (String[])replacements.get(s);

	int r = (int)(Math.random() * a.length );
	if (DEBUG)System.out.println("inside getRepl: " + s + " " + r);
	return (String)a[r];
    }

    public static void main(String[] args){

	BidUtility bu = BidUtility.readBidUtilityFromString("{cost_coeff=1, cost_target=25, length_coeff=1, length_target=60, DSr_coeff=1, DSr_target=10, DSv_coeff=3, DSv_target=10, DSg_target=10, DSg_coeff=5, RV_coeff=1}");
	
	Bid b1 = new Bid();	

	//RSTTree x17 = RSTTree.readRSTTree("[{topic=v, length_exp=22.0, DStot_exp=[[1 3 3][0 0 0]], cost_exp=4.0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[1 3 3][0 0 0]], symbol=IBM, RV=[[1 1] 2], U=3.8392229324878793, bidder=Value, lastBU=bu5}[Goal [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[Recommend BuyInvestment ][]][{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[Persuade [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[MOTIVATE BuyInvestment [AND [AND company_has_an_acceptable_price_earnings_ratio company_has_a_history_of_moderate_value_metrics_ ] company_has_an_acceptable_return_on_equity ] ][[{topic=v, length_exp=22.0, DStot_exp=[[1 3 3][0 0 0]], cost_exp=4.0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[1 3 3][0 0 0]], symbol=IBM, RV=[[1] 1], U=null, bidder=Value, lastBU=unset}[Inform [AND [AND company_has_an_acceptable_price_earnings_ratio company_has_a_history_of_moderate_value_metrics_ ] company_has_an_acceptable_return_on_equity ] ][]]]]]]]]");

	RSTTree x17 = RSTTree.readRSTTree("[{topic=mixed, length_exp=27.0, DStot_exp=[[2 4 3][0 0 0]], cost_exp=8.0, DSr_exp=[[2 2 1][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[1 2 2][0 0 0]], symbol=IBM, RV=[[1 6] 2], U=13.210813980939578, bidder=Coord, lastBU=bu1}[Goal [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[Recommend BuyInvestment ][]][{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[Persuade [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[Joint ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[MOTIVATE BuyInvestment [Inform [AND company_has_an_acceptable_price_earnings_ratio company_has_an_acceptable_return_on_equity ] ] ][[{topic=v, length_exp=14.0, DStot_exp=[[1 2 2][0 0 0]], cost_exp=4.0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[1 2 2][0 0 0]], RV=[[] 0], symbol=IBM, U=3.555525951535392, bidder=Value, lastBU=bu1}[Inform [AND company_has_an_acceptable_price_earnings_ratio company_has_an_acceptable_return_on_equity ] ][]]]][{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset, lastBU=unset}[MOTIVATE BuyInvestment [Inform company's_debt_equity_ratio_indicates_a_good_debt_position_relative_to_the_industry_average_ ] ][[{topic=r, length_exp=13.0, cost_exp=4, DSr_exp=[[2 2 1][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[0 0 0][0 0 0]], RV=[[] 0], symbol=IBM, U=4.300287102592869, bidder=DE, lastBU=bu1}[Inform company's_debt_equity_ratio_indicates_a_good_debt_position_relative_to_the_industry_average_ ][]]]]]]]]]]");

	//RSTTree x  = RSTTree.GoalDoNot("goaldo comma not1", DSType.RISK, -0.5, b1);

//	RSTTree x17 = RSTTree.readRSTTree("[{topic=v, length_exp=33.0, DStot_exp=[[2.5 4.5 2][6 6 1]], cost_exp=6.0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[2.5 4.5 2][6 6 1]], symbol=URS, RV=[[2 5] 3], U=16.7, bidder=Value}[CONCESSION ][[{topic=v, length_exp=12.0, DStot_exp=[[0 0 0][6 6 1]], cost_exp=4, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[0 0 0][6 6 1]], symbol=URS, RV=[[] 0], U=12.8, bidder=RE}[GOAL [NOT [DO BuyInvestment ] ] ][[{DSv_exp=[[0 0 0][0 0 0]], topic=v, DSr_exp=[[0 0 0][0 0 0]], DStot_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[RECOMMEND [NOT [DO BuyInvestment ] ] ][]][{DSv_exp=[[0 0 0][0 0 0]], topic=v, DSr_exp=[[0 0 0][0 0 0]], DStot_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[DISSUADE [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], topic=v, DSr_exp=[[0 0 0][0 0 0]], DStot_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[DEMOTIVATEACT BuyInvestment company_has__a_poor_return_on_equity__relative_to__the_construction_industry_ ][[{topic=v, length_exp=12.0, DStot_exp=[[0 0 0][6 6 1]], cost_exp=4, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[0 0 0][6 6 1]], symbol=URS, RV=[[] 0], U=12.8, bidder=RE}[INFORM company_has__a_poor_return_on_equity__relative_to__the_construction_industry_ ][]]]]]]]][{topic=v, length_exp=21.0, DStot_exp=[[2.5 4.5 2][0 0 0]], cost_exp=2.0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[2.5 4.5 2][0 0 0]], symbol=URS, RV=[[5] 1], U=11.7, bidder=Value}[Goal [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[Recommend BuyInvestment ][]][{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[Persuade [DO BuyInvestment ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[MOTIVATE BuyInvestment [Elaborate ] ][[{DSv_exp=[[0 0 0][0 0 0]], DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], U=null, bidder=unset}[Elaborate ][[{topic=v, length_exp=13.0, DStot_exp=[[2.5 2.5 1][0 0 0]], cost_exp=2, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[2.5 2.5 1][0 0 0]], RV=[[] 0], symbol=URS, U=10.0, bidder=PE}[Inform company_has_an_excellent_price_earnings_ratio_comma_suggesting_it_may_be_under-valued ][]][{topic=v, length_exp=8.0, DStot_exp=[[2 2 1][0 0 0]], cost_exp=0, DSr_exp=[[0 0 0][0 0 0]], DSg_exp=[[0 0 0][0 0 0]], DSv_exp=[[2 2 1][0 0 0]], RV=[[] 0], symbol=URS, U=9.6, bidder=Value}[Inform company_has_a_history_of_attractive_value_metrics_ ][]]]]]]]]]]]]");



	//String test1 = "company has a low debt equity ratio comma suggesting the ability to weather an economic downturn semicolonAnd company has a strong current ratio relative to the industry average semicolonAnd  company has historically maintained a moderate debt policy commaAnd company has maintained a moderate risk profile ";

					  //String result = "Information from all sources is mixed period your equity percentage is quite high comma given your proximity to retirement semicolonAnd you have already exceeded your allocation goal for equities periodContrast ValueIntro company has a return on equity slightly better than the tech industry average commaAnd company has a history of moderate value metrics period RiskIntro company has a poor current ratio relative to the industry average commaAnd company has a high debt equity ratio comma outside the norms of conservative financing semiContrast company has historically maintained a moderate debt policy commaAnd company has maintained a moderate risk profile period the tech industry has a somewhat aggressive risk profile";

	TreeGenerate tg = new TreeGenerate("ABC");
	tg.DEBUG = true;
	tg.bu = bu;

	//result = "periodContrast ValueIntro company has a return on equity slightly better than the tech industry average commaAnd company has a history of moderate value metrics period RiskIntro ";
	//if (DEBUG) System.out.println("111 " + result);
	//result = tg.removeDups(result);
	//if (DEBUG) System.out.println("222 " + result);
	//result = tg.replace(result);
	//if (DEBUG) System.out.println("333 " + result);
	//result = result.replaceAll("[ ]+", " ");
	//result = result.replaceAll(" [.]", ".");
	//result = result.replaceAll(" [,]", ",");
	//result = result.replaceAll(" [;]", ";");
	//result = result.replaceAll("[;][.]", ".");
	//result = result.trim();
	//result = tg.addCapsAndPeriod(result);

	String original = tg.generate(x17);
	System.out.println("original: " + original);
	System.out.println("wc = " + tg.wordCount(original)); 
	
//	RSTTree rTree = tg.randomTree(x17);
//	String temp = tg.generateLong(rTree,bu);
//	System.out.println("random: " + temp);
//	System.out.println("wc = " + tg.wordCount(temp)); 
//	
//	System.out.println("\noriginal: " + original);

	
    }
} // TreeGenerate
