//package Plan;

import java.util.*;
/**
 * Variable.java
 * Unassigned Variables can match to any value or
 * another Variable of the same name.  
 *
 * Created: Wed Apr 14 16:14:03 1999
 *
 * @author Terry Harvey
 * @version
 */

public class Variable  {
    
  static Hashtable namesUsed = new Hashtable();

    String name;
  //Object value; NO setting value requires tracking all unified vars 
  //if value is changed 

    public Variable(String n) {
	name = n;
    }

  /**
   * Creates Variable with a unique name using given String prefix.
   */
    public Variable(String n, boolean unique) {
      if (unique){
	name = getUniqueName(n);
	namesUsed.put(name, this);
      }
      else
	name = n;
    }

    public String getName(){ return name; }


    public static boolean isVarName( String s ){
	if ( s.charAt(0) == '?' )
	    return true;
	else return false;
    }


    public boolean prefixMatch(String s){
	return this.name.startsWith(s);
    }
    
    static public Variable getVarFromUniqueName(String name){
	Object var = namesUsed.get(name);
	if (var instanceof Variable)
	    return (Variable)var;
	else return null;
    }

  static public String getUniqueName(String s){
    if (namesUsed.containsKey(s)){
      //change name
      int i = 2;
      while (namesUsed.containsKey(s + i))
	i++;
      namesUsed.put(s + i,s + i);
      return s + i; 
    }
    else {
      namesUsed.put(s, s + "1");
      return s + "1"; 
    }
  }

    public String toString(){
      return name;
    }
    
    /** 
     * Hash Variables according to their String names.
     */
    public int hashCode(){
	return this.name.toString().hashCode();
    }

    public boolean equals( Object obj )
    {
         if ( obj == null || !(obj instanceof Variable) ) return false;
         return name.equals( ( (Variable) obj ).name );
    }

//    public boolean equals(Variable obj){
//	  return obj != null 
//	      && name.equals(obj.name);
//	  }

    //public static void main(String args[]){
    //	  Variable var1 = new Variable("y");
    //	  Variable var2 = new Variable("y");
    //	  System.out.println(var1.hashCode());
    //	  System.out.println(var2.hashCode());
    //	  System.out.println("== hash: " + (var1.hashCode() == var2.hashCode()));
    //	  MyHashtable h1 = new MyHashtable();
    //	  h1.put(var1, "a");
    //	  System.out.println("contains: " + h1.containsKey(var2));	
    //	  h1.put(var2, "b");
    //	  System.out.println("h1: " + h1);
    //	  System.out.println(h1.get(var1));
    //	  System.out.println(var1.equals(var2));
    //	  System.out.println(getUniqueName("spam"));
    //	  System.out.println(getUniqueName("spam"));
    //	  System.out.println(getUniqueName("spam"));
    //	  System.out.println("var: " + new Variable("spam", true));
    //}

} // Variable
