
    public String calcAndPrintUtility(BidUtility bu){

	StringBuffer sb = new StringBuffer(200);
		
	int char_loc;
	double coeff, coeffSum, target, expValue, nextTermU, newUtility = 0;
	String attName = null, root = null, targetName = null, coeffName = null, 
	    fcn = null,  //is the name of fcn in DistFcn
	    fcnName = null; //is the name by which fcn is found in U
	coeffSum = bu.sumCoeffs();

	Iterator attributes = this.getAttributes();
	//if utility function does not have an entry for this item, do not change utility
	while (attributes.hasNext()){
	    nextTermU = 0;
	    coeff = 0; //default
	    fcn = null;
	    target = 10; //default
	    expValue = 0;
	    attName = (String)attributes.next();
	    if (DEBUG) System.out.println("next attr: " + attName);

	    /********************* Set names to find in Ufcn ************************/	    
	    char_loc = attName.indexOf('_');
	    if (char_loc > -1){ // is -1 if not found
		root = attName.substring(0, char_loc);
	    }
	    else { //no underscore
		root = attName;
	    }

	    coeffName = root.concat("_coeff");
	    targetName = root.concat("_target");
	    fcnName = root.concat("_fcn");

	    /***************Get coeff and target numbers from Ufcn**********************/

	    if (bu.containsKey(coeffName)){
		coeff = Double.parseDouble((String)bu.get(coeffName));
		coeff = 100 * (coeff / coeffSum); //scale coefficients so U is 0-100
	    }
	    if (bu.containsKey(targetName))
		target = Double.parseDouble((String)bu.get(targetName));
	    if (bu.containsKey(fcnName))
		fcn = (String)bu.get(fcnName);

	    if (DEBUG) System.out.println("fcn is: " + fcn);
	    /*************special term behaviors**************************/
	    if (attName.startsWith("DS")){
		Strength s = (Strength)this.getValue(attName);
		expValue = s.getDSSumsForUtility();
		if (DEBUG) System.out.println("inside DS");
		
		if (fcn == null)
		    fcn = "linear";
		if (DEBUG) System.out.println("DS fcn is: " + fcn);
		nextTermU = coeff * DistFcn.f( fcn, expValue, target, target/STD_DEV_QUOTIENT);
		if (DEBUG) System.out.println("leaving DS nextTermU is: " + nextTermU);
	    }
	    else if (attName.startsWith("RV")){
		RuleValue rv = (RuleValue)this.getValue(attName);
		expValue = rv.getIntValue();
		if (fcn == null)
		    fcn = "linear";
		nextTermU = coeff * DistFcn.f( fcn, expValue, target, target/STD_DEV_QUOTIENT);
	    }
	    else if (attName.startsWith("cost")){
		expValue = Double.parseDouble((String)this.getValue(attName));
		if (fcn == null)
		    fcn = "startPlateauNormal"; //works with neg coeff if cost is bad for U, but don't use neg coeff
		nextTermU = coeff * DistFcn.f( fcn, expValue, target, target/STD_DEV_QUOTIENT);
	    }
	    else if (attName.startsWith("time")){
		expValue = Double.parseDouble((String)this.getValue(attName));
		if (fcn == null)
		    fcn = "startPlateauNormal"; 
		nextTermU = coeff * DistFcn.f( fcn, expValue, target, target/STD_DEV_QUOTIENT);
	    }
	    else if (attName.startsWith("topic")
		     || attName.startsWith("symbol")
		     //|| attName.startsWith("time")
		     ){
		//continue;
	    }
	    /********************Default Behavior***************************/
	    else{
		expValue = Double.parseDouble((String)this.getValue(attName));

		if (fcn == null)
		    fcn = "normal";
		//else System.out.println(em + "no target for " + attName + " in " + bu);
		nextTermU = coeff * DistFcn.f(fcn, expValue, target, target/STD_DEV_QUOTIENT);
	    }
	    
	    if (coeff != 0)
		    sb.append(" " + attName + "=" + 
			      coeff + "*"+ fcn + "(" +expValue + ", " + target + ")=" + nextTermU);
	    
	    newUtility += nextTermU;
	}
	Uchanged = false;
	utility = new Double(newUtility);
	lastBU = (String)bu.get("name");

	sb.insert(0, utility.toString() + " = ");
	System.out.println(sb.toString());
	System.out.println(Double.toString(newUtility));

	return sb.toString();
    }//calcAndPrintUtility(BidUtility bu)
